2008-07-01  Al Riddoch  <alriddoch@googlemail.com>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.16

2008-06-08  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/cyphesis-setup.sh: Fix command line to su so it works.

2008-06-07  Al Riddoch  <alriddoch@googlemail.com>

	* Makefile.am, scripts/cyphesis-setup.sh: Add the setup script to the
	  build.

2008-06-05  Al Riddoch  <alriddoch@googlemail.com>

	* tests/PropertyExerciser.cpp: Use the C++ limits API, rather than
	  the C defines.

	* tests/Containertest.cpp: Add missing C headers required by more
	  recent compilers.

2008-06-04  Al Riddoch  <alriddoch@googlemail.com>

	* Makefile.am, libraries/Makefile.am: Fix the recursive rules
	  so a complete distribution package is built.

2008-06-03  Al Riddoch  <alriddoch@googlemail.com>

	* server/EntityFactory.cpp: Add some doc strings.

2008-05-28  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Character.h: Remove some of the
	  obsolete handlers in the filter on ops from the mind. Stop using
	  the generic IG op switch, and write a custom one.
	  Fix a bug where Use ops were getting filtered out unintentionally.

2008-05-28  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/import_bullet: Check explicitly for source files suffixes
	  before treating them as sources. Create temporary files to avoid
	  updating Makefile.am if there is no change. Mark headers as not to
	  be installed.

2008-05-08  Al Riddoch  <alriddoch@googlemail.com>

	* scripts/import_bullet: An experimental script.

2008-04-29  Al Riddoch  <alriddoch@googlemail.com>

	* common/log.cpp: Don't assign strings to non-const char*.

2008-04-28  Al Riddoch  <alriddoch@googlemail.com>

	* common/Database.cpp, common/globals.cpp, common/id.cpp,
	  common/log.cpp, modules/DateTime.cpp, rulesets/Container.h,
	  rulesets/Statistics.h, server/CommListener.cpp,
	  server/CommServer.cpp, tools/cyconfig.cpp, tools/cyconvertrules.cpp:
	  Add includes required for recent compilers which include less
	  stuff implicitly in standard headers.

2008-04-19  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp, common/system.h: Add a security setup function
	  which creates a persistent server identity.

2008-04-13  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp: Add test code to generate unique cryptographic
	  server identity.

2008-03-28  Al Riddoch  <alriddoch@googlemail.com>

	* data/devices.xml: Add a second type of operation to the example
	  device.

	* rulesets/Character.cpp: Sort out the fixme so non-default actions
	  can be specified when actuating devices.

	* rulesets/basic/mind/goals/common/misc_goal.py: Clean up the
	  actuation testing goal.

2008-03-28  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/goals/common/misc_goal.py: Make the checking
	  for a list simpler. Add a test goal for exercising the device
	  activation interface.

	* rulesets/mason/define_world.py: Add client test method to try
	  out the activation goal.

2008-03-28  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_Location.cpp: Implement the repr() method of the
	  Python object protocol for this wrapper, making debugging easier in
	  scripts.

2008-03-26  Al Riddoch  <alriddoch@googlemail.com>

	* common/Actuate.h, common/Makefile.am, common/custom.cpp,
	  common/op_switch.h, common/operations.cpp: Add Actuate to the
	  cyphesis core custom operations.

	* rulesets/Entity.cpp, rulesets/Entity.h, rulesets/Character.cpp:
	  Add handlers for Actuate to the operation routing interface.

	* data/devices.xml: Add example device.

	* data/Makefile.am: Add new devices file.

	* data/operations.xml: Remove temporary soft Actuate definition.

2008-03-23  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Change the name of the attribute that stores
	  operations to be used on devices, so devices can't accidentally
	  be used as tools.

2008-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/mason/world/statistics/Statistics.py: Use super() instead
	  of hardcoding the superclass.

2008-03-20  Al Riddoch  <alriddoch@googlemail.com>

	* data/operations.xml: Add an op definition for "actuate" to be used
	  for interacting with devices and machines.

	* rulesets/Character.cpp, rulesets/Character.h: Mock up the code for
	  processing actuate operations from the client or mind.

2008-03-12  Al Riddoch  <alriddoch@googlemail.com>

	* configure.ac, NEWS: Increment version number for release soon.

2008-01-30  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Add more details to comments.

	* rulesets/Character.cpp: Add a warning when an unknown up comes
	  from the mind.

2008-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/BaseEntity.h,
	  common/OOGThing.cpp, common/OOGThing.h: Make files as removed.

	* tests/BaseEntitytest.cpp, tests/Makefile.am, tests/OOGThingtest.cpp:
	  Remove the tests for the above removed files.

	* tests/LocatedEntitytest.cpp, tests/ThingupdatePropertiestest.cpp:
	  Update the tests to call the right base class constructors.

2008-01-28  Al Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.cpp, common/BaseEntity.cpp, common/BaseEntity.h,
	  common/Identified.cpp, common/Identified.h, common/Makefile.am,
	  common/OOGThing.cpp, common/OOGThing.h, common/OperationRouter.cpp,
	  common/OperationRouter.h, rulesets/Character.h, rulesets/Entity.h,
	  rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h,
	  server/Account.cpp, server/Account.h, server/Admin.cpp,
	  server/CommClient.cpp, server/CommClient.h, server/Connection.cpp,
	  server/Connection.h, server/ExternalMind.cpp, server/ExternalMind.h,
	  server/ExternalProperty.cpp, server/ExternalProperty.h,
	  server/Lobby.cpp, server/Lobby.h, server/Master.cpp, server/Master.h,
	  server/Peer.cpp, server/Peer.h, server/ServerRouting.cpp,
	  server/ServerRouting.h, server/SlaveClientConnection.cpp,
	  server/SlaveClientConnection.h: Factor out the more pointless base
	  classes, in favor of simple interface. Move destroyed signal to
	  Entity, which is the only place it is needed.

2008-01-26  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/BaseEntity.h: Remove the code that
	  handle ID, and just inherit from Identified.

	* client/CharacterClient.cpp, client/CreatorClient.cpp,
	  common/OOGThing.cpp, rulesets/BaseMind.cpp, rulesets/Character.cpp,
	  rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/LocatedEntity.cpp, rulesets/MemEntity.cpp,
	  rulesets/Plant.cpp, rulesets/Stackable.cpp, rulesets/Structure.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/Account.cpp,
	  server/Admin.cpp, server/ExternalMind.cpp, server/Lobby.cpp,
	  server/Peer.cpp, server/Player.cpp, server/ServerRouting.cpp,
	  server/SlaveClientConnection.cpp: Add calls to the virtually
	  inherited Identified constructor as required.

2008-01-23  Al Riddoch  <alriddoch@googlemail.com>

	* server/Connection.h: Add sigc::trackable back into the inheritance
	  for Connection, so it gets disconnected from signals on destruction.

2008-01-23  Al Riddoch  <alriddoch@googlemail.com>

	* valgrind-python.supp: Uncomment supressions required if Python
	  has not been re-compiled.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/Identified.cpp, common/Identified.h: Add a new base class
	  which combines Identified with OperationRouter.

	* server/CommClient.cpp, server/CommClient.h: Modify CommClient to
	  refer to it's operation routing object purely by the OperationRouter
	  interface.

	* server/Connection.cpp, server/Connection.h,
	  server/TrustedConnection.cpp: Re-factor connection routers so
	  they no longer inherit from BaseEntity, and instead inherit
	  cleanly from the minimum required interfaces.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/Identified.cpp, common/Identified.h: New base class for
	  anything that has an identity.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* tests/EntityExerciser.h, tests/IGEntityExerciser.h: Remove
	  operation calls from the operation router tests which no longer
	  exist in the interface.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/BaseMind.cpp: Remove an obsolete local variable.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/BaseEntity.h: Remove generic operation
	  routing code.

	* common/op_switch.h: Remove all OOG operations from the standard
	  op switch.

	* rulesets/Entity.cpp, rulesets/Entity.h: Replace generic operation
	  routing with a more specific IG routing implementation.

	* rulesets/BaseMind.cpp: Add a mind specific operation router
	  implementation.

	* server/Account.cpp, server/Account.h: Remove handling of Login,
	  which should never got to Account. Add base handler for Get,
	  as it needs to be overriden in Admin.

2008-01-17  Al Riddoch  <alriddoch@googlemail.com>

	* server/Admin.cpp, server/Connection.cpp, server/Connection.h,
	  server/ServerRouting.cpp, server/ServerRouting.h: Use the much
	  simpler OperationRouter interface when handling routing operations
	  round the server.

2008-01-14  Al Riddoch  <alriddoch@googlemail.com>

	* tests/BaseEntitytest.cpp, tests/EntityExerciser.h,
	  tests/LocatedEntitytest.cpp, tests/Makefile.am,
	  tests/OOGThingtest.cpp, tests/OperationExerciser.cpp,
	  tests/OperationExerciser.h, tests/inheritancetest.cpp: Fix tests
	  to account for header changes, and the fact that some of the
	  base classes are now abstract.

2008-01-13  Al Riddoch  <alriddoch@googlemail.com>

	* client/BaseClient.cpp, client/ClientConnection.cpp,
	  common/BaseWorld.h, common/OperationRouter.h, common/TypeNode.h,
	  common/inheritance.cpp, common/inheritance.h, common/types.h,
	  rulesets/ActivePropertyFactory.h, rulesets/AtlasProperties.h,
	  rulesets/EntityPropertyFactory.h, rulesets/LocatedEntity.h,
	  rulesets/MemMap.h, rulesets/Motion.h, rulesets/Movement.h,
	  rulesets/Pedestrian.h, rulesets/PythonThingScript.cpp,
	  rulesets/Statistics.h, rulesets/Task.h, server/Account.h,
	  server/Connection.h, server/Player.h, server/ServerRouting.h,
	  server/WorldRouter.h, tests/OperationExerciser.h, tools/cycmd.cpp:
	  A major clean up and re-work in internal headers.

2008-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* common/BaseEntity.cpp, common/custom.cpp, common/inheritance.cpp,
	  common/inheritance.h, common/op_switch.h, common/types.h,
	  rulesets/Character.cpp, rulesets/Creator.cpp,
	  rulesets/PythonThingScript.cpp, server/Account.cpp,
	  server/Connection.cpp, server/ExternalMind.cpp,
	  tests/OOGThingtest.cpp, tests/inheritancetest.cpp:
	  Remove a set of pointless definitions, and use the originals
	  throughout the code.

2008-01-12  Al Riddoch  <alriddoch@googlemail.com>

	* common/OperationRouter.cpp, common/OperationRouter.h: Interface
	  class for objects when can handle or route operations.

	* common/BaseEntity.h, common/BaseEntity.cpp: Remove standard
	  implementation of operation handler, forcing class to provide
	  more specific implementations.

	* rulesets/LocatedEntity.h, rulesets/LocatedEntity.cpp: Add an
	  implementation of the OperationRouter interface, suitable for
	  IG operations.

	* server/ServerRouting.h, server/Peer.cpp, server/Peer.h,
	  rulesets/MemEntity.h: Add placeholder OperationRouter
	  implementations.

	* server/Connection.cpp: Update OperationRouter implementation to
	  be better suited.

	* server/Account.cpp, server/Account.h: Implement OperationRouter
	  for accounts.

2008-01-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h: Add an additional template function for
	  forcing the existence of a property of the required type.

	* rulesets/Character.cpp: Make the code further simpler and more
	  readable by using the new template function to require a property
	  exist.

2008-01-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Use getSpecificProperty() to replace
	  last other dynamic_cast of property.

2008-01-08  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.h: Add a template function for quickly
	  querying a property of the required type.

	* rulesets/Character.cpp: Use getSpecificProperty() to improve
	  brevity and readability of some of the code.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* tests/IGEntityExerciser.h: When testing the world, ensure it has
	  a container storage, as code expect this.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* Charactertest.cpp, Creatortest.cpp, Planttest.cpp,
	  Stackabletest.cpp, Structuretest.cpp, Thingtest.cpp,
	  Worldtest.cpp: Update tests so they no longer expect the
	  contains property to be set by default.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Motion.cpp: Add more thorough assert checks.

	* tests/IGEntityExerciser.h: Ensure the containership is complete and
	  legal on entities to be tested, so collision code called from
	  update handler works correctly.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Entitytest.cpp: Update so that it no longer expects the
	  contains property to be set by default.

	* tests/EntityReftest.cpp: Fix tests so that when calling destroy
	  on an Entity, it's hierarchy is as expected.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* tests/EntityPropertytest.cpp: Fix the test to account for the
	  new dynamic nature of this property.

2008-01-07  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.h: Remove an obsolete include.

2008-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h: Add a virtual
	  function that is called when the location of an entity changes.

	* rulesets/Entity.cpp, rulesets/Entity.h: Implement the virtual
	  function called when location changes and use it to call the
	  containered signal. Remove the containered_oneshots list, and
	  make containered inherently one shot only.

	* rulesets/OutfitProperty.cpp: Remove the use of containered_oneshots
	  is this mechanism is obsolete and has been removed.

2008-01-06  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/EntityProperty.h, rulesets/EntityProperty.cpp:
	  Refactor so this property is always dynamic, and add an accessor.

	* rulesets/Character.cpp, rulesets/Character.h: Remove the hard
	  coded entity references used for wield tool, and replace with
	  a dynamic property.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp: Fix a missed check for m_contains being
	  null.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Fix dependencies so tests build.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp: Clean up the syntax and line length in
	  destroy() to make the code more readable.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h:
	  Don't allocated storage for m_contains by default, only
	  on demand. Add a convenience method which checks, and
	  allocates the storage if required. Set up the ID property
	  on this base class rather then Entity.

	* rulesets/Py_Thing.cpp: Remove special handling of ID attribute
	  as it is now handled by the property.

	* rulesets/Character.cpp, rulesets/Entity.cpp, rulesets/MemMap.cpp,
	  rulesets/Motion.cpp, rulesets/Py_Mind.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/WorldRouter.cpp:
	  Make sure all parts of the code where contains is used have
	  the right checks, as it could be null.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* common/system.cpp: Use PACKAGE_BUGREPORT from autoconf for the
	  email address to report bugs to in error messages.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_Thing.cpp: Remove the world attribute on Entity
	  wrapper.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/acorn/world/objects/animals/Deer.py,
	  rulesets/acorn/world/objects/animals/Pig.py,
	  rulesets/acorn/world/objects/outdoor/Campfire.py,
	  rulesets/acorn/world/objects/plants/Tree.py,
	  rulesets/acorn/world/objects/tools/Cleaver.py,
	  rulesets/basic/world/objects/plants/Tree.py,
	  rulesets/mason/world/objects/animals/Deer.py,
	  rulesets/mason/world/objects/animals/Pig.py,
	  rulesets/mason/world/objects/clothing/Garment.py,
	  rulesets/mason/world/objects/elements/Fire.py,
	  rulesets/mason/world/objects/outdoor/Campfire.py,
	  rulesets/mason/world/objects/tools/Bow.py,
	  rulesets/mason/world/objects/tools/Bucksaw.py,
	  rulesets/mason/world/objects/tools/Cleaver.py,
	  rulesets/mason/world/objects/tools/Sword.py,
	  rulesets/mason/world/objects/tools/Tinderbox.py,
	  rulesets/mason/world/objects/tools/Torch.py,
	  rulesets/mason/world/objects/tools/Trowel.py,
	  rulesets/mason/world/tasks/Bisect.py,
	  rulesets/mason/world/tasks/Combat.py,
	  rulesets/mason/world/tasks/Cultivate.py,
	  rulesets/mason/world/tasks/Delve.py,
	  rulesets/mason/world/tasks/Dig.py,
	  rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Reap.py,
	  rulesets/mason/world/tasks/Sharpen.py,
	  rulesets/mason/world/tasks/Slaughter.py,
	  rulesets/mason/world/tasks/Slice.py,
	  rulesets/mason/world/tasks/Trailblaze.py,
	  rulesets/werewolf/world/objects/tools/Gallows.py:
	  Remove code that accesses the world attribute on Entity,
	  replacing where necessary with server.world.

2008-01-05  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_World.h: Remove the pointer to the world router from
	  its wrapper, as all the wrapper code should now use the singleton
	  interface.

	* rulesets/Python_API.cpp, rulesets/Py_World.cpp,
	  rulesets/Py_Thing.cpp: Fix up all the code which uses the world
	  router pointer.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Python_API.cpp: Add an instance of the world wrapper to
	  the server module, which should then be used instead of the
	  world attribute on entities.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Py_World.cpp: Modify the world wrapper so it does not
	  require a pointer to the world router instance, and uses it as
	  a singleton instead.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/basic/mind/NPCMind.py: Clean up some imports, and remove
	  some legacy aliasing.

2008-01-04  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Python_API.cpp: Remove the server_python flag used to
	  allow scripts to run unmodified on the obsolete python prototype.

	* rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/mind/goals/animal/herd.py,
	  rulesets/basic/mind/goals/common/common.py,
	  rulesets/basic/mind/goals/common/move.py,
	  rulesets/mason/world/objects/buildings/House.py: Remove support
	  for running these scripts on the obsolete python prototype.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp, rulesets/LocatedEntity.cpp: Move cleaning
	  up properties into the LocatedEntity destructor, so none are leaked.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Entitytest.cpp: Remove the difference between attribute and
	  property checks, as all attributes are now handled by the property
	  mechanism.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/Stackabletest.cpp, tests/Structuretest.cpp,
	  tests/Thingtest.cpp, tests/Worldtest.cpp: Add TypeNode.h include.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* tests/Makefile.am: Add TypeNode.o to tests as required.

	* tests/Planttest.cpp: Add TypeNode.h include.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Entity.cpp, rulesets/LocatedEntity.cpp: Move the code the
	  decremements the reference to containing entity into the
	  LocatedEntity destructor where it belongs.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp: Fix leak of m_contains.

2007-12-31  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/Character.cpp, rulesets/Entity.cpp,
	  rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h,
	  rulesets/MemMap.cpp, rulesets/Motion.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Thing.cpp, rulesets/World.cpp,
	  server/WorldRouter.cpp: Change LocatedEntity::m_contains into
	  a pointer so that the majority of entities that can not contain
	  anything don't waste the storage.

2007-12-29  Al Riddoch  <alriddoch@googlemail.com>

	* rulesets/LocatedEntity.cpp: Add code to getAttr so it looks in
	  the default properties on the TypeNode if the instances does not
	  have the property.

2007-12-29  Al Riddoch  <alriddoch@googlemail.com>

	* common/TypeNode.h: Change the type of defaults over to properties.

	* common/inheritance.cpp, common/inheritance.h: Modify the API
	  for specifying defaults on a new TypeNode to take the new
	  property based data.

2007-12-29  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h, rulesets/LocatedEntity.h: Clean up typedefs, and
	  make sure they are used from the right includes.

2007-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Fix a brief and blatantly obvious comment.

2007-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/TypeNode.h, common/TypeNode.cpp: Move TypeNode into
	  its own files.

	* common/Makefile.am, common/inheritance.cpp, common/inheritance.h:
	  Add the new files to the build and remove the old implementation.

	* client/Py_CreatorClient.cpp, rulesets/Character.cpp,
	  rulesets/Entity.cpp, rulesets/MemMap.cpp,
	  rulesets/MindFactory.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Stackable.cpp,
	  server/WorldRouter.cpp: Fix up the includes for all code that
	  uses TypeNode.

2007-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.h, server/EntityFactory.cpp: Move a typedef
	  into the only cpp file where it is used.

2007-12-24  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistor.cpp, server/Persistor_impl.h,
	  server/Restoration.cpp, server/Restorer.cpp,
	  server/Restorer_impl.h: Add errors to files removed from the
	  build.

2007-12-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Entity.h, rulesets/LocatedEntity.cpp,
	  rulesets/LocatedEntity.h: Remove raw atlas attributes, and use
	  properties for everything, cutting down the differences in
	  interface.

	* rulesets/Py_Thing.cpp, rulesets/Thing.cpp: Remove code that accessed
	  soft attributes directly.

2007-12-24  Al Riddoch  <alriddoch@zepler.org>

	* common/Property.h, common/Property.cpp: Add a soft property class,
	  which can take values of any type.

	* rulesets/Entity.cpp: Use soft property for any values for which
	  there is no assigned property factory, and avoid using raw atlas
	  attributes completely.

2007-12-21  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.h: Remove a nasty hack for old compilers, and
	  make the private part of Database protected.

2007-12-21  Al Riddoch  <alriddoch@zepler.org>

	* common/terrain_utils.h, common/Makefile.am: Remove the persistence
	  code used to save terrain data.

	* common/Database.cpp, common/Database.h: Remove the object
	  relational API for persisting entity data, and put the code
	  beyond use.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Remove obsolete persistence code from tests
	  that used to depend on it.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am, server/Restoration.h, server/Restorer.h,
	  server/server.cpp: Remove the counter part templated restorer
	  code from the build.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/Makefile.am,
	  server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h, server/Persistor.h,
	  server/Restoration.cpp, server/Restorer.cpp, server/Restorer.h,
	  server/Restorer_impl.h: Remove the templated persistor code from
	  the build.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Delete the peristance connector in
	  the right place.

	* server/PersistantThingFactory.h: Document what the persistor 
	  connector does more clearly.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Fix up the tests to use the updated
	  class names.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/EntityFactory.h,
	  server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h: Rename the base class for
	  Entity factories from FactoryBase to EntityKit.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/EntityFactory.h, server/Admin.cpp,
	  server/PersistantThingFactory.cpp, server/WorldRouter.cpp,
	  server/server.cpp: Rename EntityFactory to EntityBuilder, to make
	  it's function clearer.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.h, common/PropertyFactory_impl.h,
	  rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h,
	  rulesets/EntityPropertyFactory.h,
	  rulesets/EntityPropertyFactory_impl.h,
	  server/CorePropertyManager.cpp:
	  Rename all property factory classes to have PropertyFactory as the
	  suffix.

2007-12-20  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.cpp, common/PropertyFactory.h,
	  rulesets/ActivePropertyFactory.h, rulesets/EntityPropertyFactory.h,
	  server/CorePropertyManager.cpp, server/CorePropertyManager.h:
	  Rename abstract base class for property factorys to PropertyKit.

2007-12-10  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Add usage information for --help and --version
	  so that the checker does not warn about them.

	* configure.ac: Increment version.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.15

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.h, common/Database.cpp: Add a new decoder for atlas
	  objects, and use it when getting the full contents of a table
	  full of Atlas data.

	* server/Persistance.cpp, server/Persistance.h: Modify the API
	  for getting the rules table to use atlas objects rather than
	  messages.

	* server/EntityFactory.cpp: Re-enable loading rules from the
	  Database, now that the data is available from the peristence
	  API in the right format.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h, common/PropertyFactory.h, rulesets/Character.h,
	  rulesets/LocatedEntity.h, rulesets/MemMap.h, rulesets/Py_Location.h,
	  rulesets/Py_Thing.h, rulesets/Python_Script_Utils.h,
	  rulesets/Statistics.h, server/Connection.h, server/EntityFactory.h,
	  server/Persistance.h, server/PersistantThingFactory.h,
	  server/Persistor.h, server/Restoration.h, server/TaskFactory.h:
	  Sort forward declarations alphabetically, because alphabetical
	  is good.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.h, server/EntityFactory.h,
	  server/TaskFactory.h: Fix up doc comments, using some more
	  Design Pattern compliant terminology.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistance.cpp: Delete the Persistance instance on shutdown.

	* common/inheritance.cpp: Delete the TypeNodes in Inheritance on
	  shutdown.

2007-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Fix conditional compilation to use UNIX
	  functionality, broken for ages. syslogging now works again.
	  Change the ident used for logging, and include the instance
	  name.

2007-12-06  Al Riddoch  <alriddoch@zepler.org>

	* common/system.h: Add a new exit status code indicating that no
	  ports were available in the dynamic range.

	* server/server.cpp, common/system.cpp: When there are no ports
	  available, write an appropriate message, and a hint describing
	  how to allocate more.

2007-12-06  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistance.cpp: Change the log message so it is clearer
	  what is happening.

2007-12-06  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Remove an assert, and only shutdown the
	  database connection if one currently exists.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/Persistance.cpp: Add an information message when attempting
	  to create a new instance database.

	* server/server.cpp: Store a new value for the start of the dynamic
	  port range, if one is allocated.

	* common/globals.cpp: Force the instance name into lower case
	  alphanumeric, and underscore only. Reject it if it can't easily
	  be forced.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Fix the logic for creating per instance
	  databases.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp, common/Database.h: Add a new API for
	  attempting to bootstrap an instance database from the master.

	* server/Persistance.h, server/Persistance.cpp: Make some of the
	  functions in the persistence API non-static, so they work
	  more cleanly and consistently. Use the new return codes
	  specified in the config header. If an instance can't get a database
	  connection, use the master database to try and create one.

	* server/server.cpp: Use the persistence code the way it is
	  intended to be used.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp, common/Database.h: Remove the flag specifying
	  that the database should be created at connection time, as we
	  basically can't do this. Make the default database name depend on
	  instance name currently in use.

	* common/accountbase.cpp, tools/cydumprules.cpp, tools/cyloadrules.cpp:
	  Fix code for the change to the database API.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h: Add database error return codes.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Add exported variables for
	  the names of the main config sections.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Provide a separate function
	  for saving user settings back to the home directory. When
	  configuring a new instance, store the ruleset in user settings,
	  and log an informational message rather than a warning.

	* server/server.cpp: When dynamically assigning a port to a new
	  instance, store the port in user settings, and log an informational
	  message. Save the user configuration once the validity has been
	  completely verified and applied.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Fix up the warning message so it gives correct
	  instructions about disabling the database for instances.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Allow per-instance database configuration.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Make nice default to 1, so that it works the
	  same on all instances.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Move the instance configuration setting out
	  of a section, and fix the usage code so it can deal correctly with
	  this.

2007-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Fix a leak of the TXT record published
	  using avahi.

2007-12-04  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Add a new config setting for
	  the instance short name, and support per-instance configuration.
	  Add config settings for a dynamic port range.

	* server/server.cpp: Support per-instance configuration and use a
	  dynamic port for non-default instances.

2007-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Remove commented out call to
	  Subscribe_Script().

2007-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp, rulesets/BaseMind.h, rulesets/Entity.cpp
	  rulesets/Entity.h: Remove the scriptSubscribed methods which
	  were empty and unused.

	* rulesets/Python_API.cpp, rulesets/Python_Script_Utils.h: Remove
	  Subscribe_Script() as it is useless now.

	* server/ScriptFactory.cpp: Remove call to Subscribe_Script().

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/LocatedEntity.h: Update the doc strings
	  as the role of Entity has changed now that some of it's
	  functionality is in LocatedEntity.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* data/Makefile.am: Update the xml check so it works with out of
	  srcdir builds.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/Areatest.cpp, tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/Entitytest.cpp, tests/Foodtest.cpp, tests/Linetest.cpp,
	  tests/Planttest.cpp, tests/Stackabletest.cpp, tests/Structuretest.cpp,
	  tests/Thingtest.cpp, tests/Worldtest.cpp: Remove mass from the
	  attribute names assumed in the entity tests.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* data/animals.xml: Give all the animals BIOMASS.

	* data/characters.xml: Add mass to some character classes that were
	  missing it.

	* rulesets/Character.cpp, rulesets/Character.h, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/Plant.cpp, rulesets/Statistics.cpp,
	  rulesets/World.cpp, server/CorePropertyManager.cpp,
	  server/Persistor.cpp, server/Persistor_impl.h,
	  server/Restorer_impl.h: Remove the hard coded mass property from
	  Entity.

	* rulesets/mason/world/statistics/Statistics.py: Fix scripts which
	  assume entities will have mass.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Character.h, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/Plant.cpp, rulesets/Py_Thing.cpp,
	  rulesets/StatusProperty.cpp, rulesets/attributes.h,
	  server/CorePropertyManager.cpp, server/Persistor.cpp,
	  server/Persistor_impl.h, server/Restorer.cpp,
	  server/Restorer_impl.h: Remove the hard coded status property from
	  Entity, and the hard coded food property from character. Fix
	  the logic handling digestion and plants to use the new softer
	  properties.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add a test for the xmllint program.

	* data/Makefile.am: Use xmllint to make sure the rules data files are
	  ok.

2007-12-03  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Add status to the fire entity as the script needs
	  it to be there.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* tests/AllPropertytest.cpp, tests/IGEntityExerciser.h,
	  tests/Makefile.am: Fix the tests up so the build and run again.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* client/CreatorClient.cpp, client/CreatorClient.h,
	  client/Py_CreatorClient.cpp, common/BaseWorld.h, common/types.h,
	  modules/Location.cpp, modules/Location.h,
	  rulesets/AtlasProperties.cpp, rulesets/AtlasProperties.h,
	  rulesets/BaseMind.cpp, rulesets/Character.cpp, rulesets/Character.h,
	  rulesets/Entity.cpp, rulesets/Entity.h,
	  rulesets/EntityProperties.cpp, rulesets/LocatedEntity.cpp,
	  rulesets/LocatedEntity.h, rulesets/MemEntity.cpp,
	  rulesets/MemEntity.h, rulesets/MemMap.cpp, rulesets/Motion.cpp,
	  rulesets/Motion.h, rulesets/Py_Location.h, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Py_Thing.h,
	  rulesets/PythonMindScript.h, rulesets/PythonScript.h,
	  rulesets/PythonThingScript.cpp, rulesets/PythonThingScript.h,
	  rulesets/Python_API.cpp, rulesets/Script.cpp, rulesets/Script.h,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/WorldRouter.cpp,
	  server/WorldRouter.h: Refactor all the entity code so there is now
	  a new base class for entities in the world simulation, and in the
	  mind which only contains things which are trully common to both.
	  This moves a lot of functionality which should not have been
	  present in mind entities away, and makes that code safer and more
	  efficient.

	* tests/TestWorld.h: Update the test world API to match the base
	  class.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* tests/LocatedEntitytest.cpp: Add full coverage for current code
	  in LocatedEntity.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Make the attribute interface virtual.

	* rulesets/LocatedEntity.cpp: Add in basic implementatios without
	  properties of the attribute interface.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/LocatedEntity.cpp, rulesets/LocatedEntity.h:
	  Add a new base class for entities with location data and
	  attributes.

2007-12-02  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Add some checks to make sure the world
	  state is consistent.

2007-11-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Provide a more verbose error message about
	  incorrect updates.

	* rulesets/mason/define_world.py: Make sure the arguments to
	  the python builtin range() is always an integer.

2007-11-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/Areatest.cpp, tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/Entitytest.cpp, tests/Foodtest.cpp, tests/Linetest.cpp,
	  tests/Planttest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Thingtest.cpp,
	  tests/Worldtest.cpp: Remove the STATUS and NAME properties
	  from those expected to be on all entities.

	* tests/ThingupdatePropertiestest.cpp: Comment out all the code
	  as it depends on the NAME property being hard coded.

2007-11-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/StatusProperty.cpp, rulesets/StatusProperty.h: 
	  Add a dynamic property that deletes the entity when it goes
	  below zero, removing the need for the hard coded property
	  of the same name.

	* rulesets/Makefile.am: Add the new property to the build.

	* server/CorePropertyManager.cpp: Add the new property to the system.

	* rulesets/mason/define_world.py: Add a test for setting the status
	  to below zero.

	* rulesets/Entity.cpp: Remove the hard property for status.

	* rulesets/Thing.cpp: Remove the code that checks the hard
	  status property to see if the entity needs to be deleted.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Fix the low threshold of the
	  sandy beach shader to be below water level.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/editor.py: Don't pre-pend the name on sentences
	  sent to program the AIs.

	* rulesets/basic/mind/NPCMind.py: Replace all the places where
	  the name of an entity is taken with a function which checks
	  for the name, but then uses the type if it is not present.

	* rulesets/basic/mind/panlingua/interlinguish.py: Fix the code
	  that strips the name from the beginning of sentences so that
	  it checks first.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.cpp, client/CharacterClient.cpp,
	  client/CharacterClient.h, client/CreatorClient.cpp,
	  client/CreatorClient.h, rulesets/BaseMind.cpp, rulesets/BaseMind.h,
	  rulesets/Character.cpp, rulesets/Entity.cpp, rulesets/Entity.h,
	  rulesets/MindFactory.cpp, rulesets/MindFactory.h, rulesets/Thing.cpp,
	  rulesets/World.cpp, server/Account.cpp, server/Connection.cpp,
	  server/EntityFactory.cpp, server/Persistor.cpp,
	  server/Persistor_impl.h, server/Restorer_impl.h,
	  server/WorldRouter.cpp: Remove the hard name attribute, now that
	  most entities don't set it.

2007-11-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Remove an old experimental type class, and clean
	  up includes.

	* client/Py_CreatorClient.cpp, rulesets/MemMap.cpp,
	  rulesets/MindFactory.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Stackable.cpp,
	  server/WorldRouter.cpp: Add necessary includes.

2007-11-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Move a bunch of random animals
	  to the end of world initialisation, so they don't create physics
	  load before everything else is set up.

2007-11-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/editor.py: Make the default argument of m.make
	  the type, and name optional.

	* rulesets/mason/define_world.py: Swap the type to the default
	  argument of m.make, and strip the names off most entities.

2007-11-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp: Clean up some attribute checks.

2007-11-26  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.cpp, common/inheritance.h: Introduce a type
	  node class as a carrier for all information, including default
	  values for a type.

	* rulesets/Entity.h, rulesets/Entity.cpp, rulesets/Character.cpp:
	  Use a TypeNode pointer rather than a string giving the type
	  of an entity.

	* client/Py_CreatorClient.cpp, rulesets/MemMap.cpp, rulesets/MemMap.h,
	  rulesets/MindFactory.cpp, rulesets/MindFactory.h,
	  rulesets/Py_Mind.cpp, rulesets/Py_Thing.cpp, rulesets/Stackable.cpp,
	  rulesets/World.cpp, server/PersistantThingFactory.h,
	  server/Restorer_impl.h, server/WorldRouter.cpp:
	  Adapt all the code that deals with types. Set the type pointer
	  up correctly in BaseMind.

	* server/EntityFactory.cpp: Initialise the TypeNode pointer on new
	  entities.

	* tests/inheritancetest.cpp: Adapt the test to cope with TypeNode.

2007-11-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp, rulesets/Makefile.am: Remove now oboleted
	  PythonMindScript from the code, and the build.

2007-11-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonMindScript.cpp, rulesets/PythonMindScript.h,
	  rulesets/PythonThingScript.cpp, rulesets/PythonThingScript.h:
	  Eliminate the difference between the code in these two classes,
	  as they really don't need to be different.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, rulesets/BaseMind.cpp, rulesets/BaseMind.h:
	  Get rid of complicated dispatch of perception and sub operation
	  separately.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Script.h, rulesets/Script.cpp,
	  rulesets/PythonThingScript.h, rulesets/PythonThingScript.cpp,
	  rulesets/PythonMindScript.h, rulesets/PythonMindScript.cpp:
	  Modify the script interface so it now only handles one operation.

	* rulesets/BaseMind.cpp: Pass in the sub operation only for
	  sight and sound of other operations.

	* rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/mind/goals/humanoid/transaction.py: Adapt the mind
	  and goal code so it only requires one operation.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Set FROM on fake Set operations used in
	  metabolism.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Set FROM and SECONDS on Set operations generated
	  by Updates.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp: Stop using the sight op when getting
	  updates.

2007-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Rename some arguments to make
	  way for some changes to the code.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Update the entity factory tests to
	  comply with the new API, and fix pre-conditions which break
	  recently added assertions.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Clean up header
	  a little. Add some alerts for consistency. Stub out a method
	  for updating a task factory from a class description.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Rename 
	  dictionary of entity factories so that it is consistent.

2007-11-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Add names to
	  arguments of public member functions.

2007-11-21  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Re-order the
	  arguments to installFactory() so they are consistent with all the
	  other calls.

2007-11-21  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h: Clean up formatting, and name all the
	  arguments.

2007-11-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp: Add some asserts that proved useful in working
	  out why orientation data was sometimes uninitialised.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/MemMap.cpp: Initialise the next index when going through
	  the map checking for entities that we should remove. Avoid a lookup
	  when it is the wrong thing.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: Make sure the time is initialised in the
	  constructor.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tools/Makefile.am, tools/cyconfig.cpp, tools/cyconvertrules.cpp:
	  Add support for --help and --version to everything.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Fix the link order now that we don't have libtool
	  to fix it for us.

2007-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/AtlasFileLoadertest.cpp: Update the tests now that the data
	  format handled by the loader has changed.

2007-11-16  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Make some checks clearer.

2007-11-15  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Store rich class
	  data for entity class types.

2007-11-15  Al Riddoch  <alriddoch@zepler.org>

	* common/AtlasFileLoader.cpp, common/AtlasFileLoader.h: Switch to
	  loading and storing the file using the Atlas Objects Decoder.

	* server/EntityFactory.cpp, server/EntityFactory.h: Switch to using
	  Atlas Objects rather than Messages in most places. Makes much of
	  the code cleaner, and allows storage of richer class data.

	* server/Admin.cpp: Update to match the modified EntityFactory API.

2007-11-14  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Modify the loadConfig
	  function so it takes usage hints, and checks the options in known
	  sections against those in the usage help.

	* client/client.cpp, server/server.cpp, tools/cyaddrules.cpp,
	  tools/cycmd.cpp, tools/cydumprules.cpp, tools/cyloadrules.cpp,
	  tools/cypasswd.cpp: Convert all calls to loadConfig to provide
	  the right hints.

2007-11-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: Task to allow players to
	  create roads is now functional.

2007-11-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: Fix _create_path to
	  generate the operation correctly.

2007-11-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: More work in progress.

2007-11-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: More work in progress.

2007-11-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: More work in progress.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Trailblaze.py: Add a new task script
	  for character defined roads. Work in progress.

	* data/tasks.xml, data/tools.xml: Add tool and task classes for
	  trailblazing.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* tools/cyaddrules.cpp, tools/cycmd.cpp: Use less verbose function
	  template to read config values.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* client/client.cpp, common/Database.cpp: Use less verbose function
	  template to read config values.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp, server/slave.cpp: Use less verbose function
	  template to read config values.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Update build rules so cyslave links.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h: Export the function template for making config
	  easier.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Update the email addresses, and tweak
	  the way man pages are included to be a little cleaner.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Add a template function that ensures config
	  values are read without having to repeat the section and key.
	  Much less verbose and more obvious. Set the default ruleset in a
	  more sane way.

2007-11-05  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Disable dependency tracking and use multiple CPU
	  cores when building the rpm.

	* configure.ac: Remove the need for libtool. Clean up some bit rot.

	* AUTHORS: Update email addresses, and make it clearer who did what.

	* acinclude.m4: Clean up the help text formatting in the postgresql
	  macro.

	* autogen.sh: Remove libtoolize.

2007-11-02  Al Riddoch  <alriddoch@zepler.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.14

2007-11-02  Al Riddoch  <alriddoch@zepler.org>

	* man/Makefile.am: Remove the man pages on maintainer-clean, so they
	  can be re-created in a maintainer rebuild.

2007-10-27  Al Riddoch  <alriddoch@zepler.org>

	* data/terrain.xml, data/mason.xml: Move some terrain related
	  definitions from mason into their own rules file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/food.xml, data/basic.xml, data/mason.xml: Move some food types
	  from basic and mason into their own file.

	* data/construction.xml, data/basic.xml: Move a construction type from
	  basic into the right file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/operations.xml, data/basic.xml: Move some operation definitions
	  from basic into their own rules file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/weapons.xml, data/basic.xml: Move some weapon types
	  from basic into their own rules file.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml, data/tools.xml, data/buildings.xml: Move a bunch
	  of things from basic into the right places.

2007-10-19  Al Riddoch  <alriddoch@zepler.org>

	* data/operations.xml, data/tasks.xml: Move some operation definitions
	  from tasks into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/characters.xml, data/basic.xml: Move some character types
	  from basic into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/construction.xml, data/mason.xml: Move all the construction types
	  from mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/characters.xml, data/mason.xml: Move all the character types
	  from mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/tasks.xml, data/mason.xml: Move all the task types from
	  mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/tools.xml, data/mason.xml: Move all the tool types from
	  mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/animals.xml, data/mason.xml: Move all the animal types from
	  mason into their own rules file.

	* data/clothing.xml: Add a couple more overlooked clothing types.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/clothing.xml, data/mason.xml: Move all the clothing types from
	  mason into their own rules file.

2007-10-18  Al Riddoch  <alriddoch@zepler.org>

	* data/buildings.xml, data/mason.xml: Move all the building types from
	  mason into their own rules file.

2007-10-17  Al Riddoch  <alriddoch@zepler.org>

	* data/plants.xml: Add a fern.

2007-10-17  Al Riddoch  <alriddoch@zepler.org>

	* data/plants.xml, data/mason.xml: Move all the plant types from mason
	  into their own rules file.

2007-10-17  Al Riddoch  <alriddoch@zepler.org>

	* NEWS, configure.ac: Increment version and NEWS for release later.

2007-10-09  Al Riddoch  <alriddoch@zepler.org>

	* modules/EntityRef.h: Simplify the sigc++ signal used.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Make a missing config file no longer fatal,
	  as the default are now sane, and do work.

	* server/server.cpp: Fix up some error and status messages.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Make the default ruleset "mason" as basic
	  no longer exists in the default install. Remove some error
	  messages which no longer apply.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Remove the hard coded flag that used to disable
	  the database code.

2007-10-01  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Clean up an error message. Modify the logic
	  when rules aren't loaded, so the error messages make more sense.

2007-09-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-25  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-25  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-25  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Provide more coverage of the operation
	  error permutations, and add some verification of the type of
	  operation in the results.

2007-09-24  Al Riddoch  <alriddoch@zepler.org>

	* common/Add.h, rulesets/SolidProperty: Fill out some more doc
	  comments.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Pedestrian.cpp: Move a calculation into an if clause, to
	  save a few cycles.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.h, rulesets/Pedestrian.cpp, rulesets/Pedestrian.h:
	  Change the movement API so update Location is const when passed to
	  generateMove.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyManager.h, rulesets/Movement.h,
	  rulesets/Pedestrian.cpp, server/EntityFactory.h, server/Peer.cpp,
	  server/Peer.h, server/PersistantThingFactory.h, server/Player.cpp:
	  Fill out some more doc comments, and add some more FIXME notes.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Clean up formatting, and make
	  the code more readable.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Return correctly from the event log testing
	  function.

	* tools/cydumprules.cpp: Remove obsolete usage reporting function.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile, Doxyfile-python: Bring doxygen config files up to date
	  with the latest version.

2007-09-22  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile-python: Remove some obsolete python directories from
	  those scanned for documentation.

2007-09-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Define shader parameters as a map
	  of named values. Shader types and parameters are now 100% compatible
	  with the interface offered by Mercator::ShaderFactories so it should
	  no longer be necessary for clients to do lots of work discovering
	  which shaders to instance.

2007-09-18  Al Riddoch  <alriddoch@zepler.org>

	* scripts/cyphesis-setup.sh: Clarify the message when a database
	  account is found to already exist.

2007-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h:
	  Add storage for terrain.surfaces subproperty.

	* rulesets/mason/define_world.py: Add some surface settings to the
	  default moraf terrain.

2007-09-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/panlingua/interlinguish.py: Add the list verb.

	* rulesets/basic/mind/Goal.py: Add a __repr__() method to make it
	  more intuitive to get a text representation of a goal.

	* rulesets/basic/mind/NPCMind.py: Add a handler for the list verb
	  that causes all the matching knowledge to be listed.

2007-09-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Clean up the deer test.

2007-09-04  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp: Remove debug output.

	* client/BaseClient.h, client/BaseClient.cpp: Add a logout method
	  so that the client can be disconnected.

	* client/client.cpp: Once the client is complete, call logout to
	  ensure all messages sent to the server have been processed.
	  Logout waits for the server to acknowledge that the connection is
	  is complete.

2007-09-04  Al Riddoch  <alriddoch@zepler.org>

	* client/client.cpp: Delete the observer client once it is
	  is finished with.

	* client/ClientConnection.cpp, client/ClientConnection.h: Add
	  a method to make the socket stay around for plenty of time
	  on close to ensure all the data is sent.

2007-08-20  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMetaClient.cpp: Get rid of the header file for metaserver
	  protocol constants, as it is not consistently licensed with the rest
	  of the code.

	* server/protocol_instructions.h, server/Makefile.am: Remove the
	  obsolete metaserver protocol header from the build.

2007-08-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp: Make sure collision flag is initialised,
	  so that calls to Update are deterministic.

2007-08-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Initialise motion pointer to zero, so
	  so tests know whether it is there.

	* rulesets/Thing.cpp: Don't attempt to do a movement update if
	  LOC is zero. It is a sign something not quite right is going on.

	* tests/IGEntityExerciser.h: Check motion is not null before using
	  it.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Add an accessor for the motion object.

	* tests/IGEntityExerciser.h: Add more coverate for Set and Update
	  ops.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Don't try and refer to the entity
	  parent if the entity being tested is the world.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Treat entities with ID 0 a little
	  differently as they should be rigged up as the world for testing.

	* tests/Creatortest.cpp, tests/Worldtest.cpp: Remove the test world
	  is it is now set up in the exerciser.

2007-08-01  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Add more test coverage for operations
	  to trigger errer detection in Thing.MoveOperation.

	* tests/TestWorld.h: Add test code to allow entities to be added to
	  the test world.

2007-07-31  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Expand the operations injected into
	  IG entity classes, to try and trigger every error message.

2007-07-30  Al Riddoch  <alriddoch@zepler.org>

	* client/Py_CreatorClient.cpp, common/Database.cpp,
	  common/accountbase.cpp, common/system.cpp, rulesets/Character.cpp,
	  rulesets/Motion.cpp, rulesets/Plant.cpp, rulesets/Py_Location.cpp,
	  rulesets/Py_Mind.cpp, rulesets/Py_Operation.cpp,
	  rulesets/Py_Point3D.cpp, rulesets/Py_Statistics.cpp,
	  rulesets/Py_Task.cpp, rulesets/Py_TerrainProperty.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Py_Vector3D.cpp,
	  rulesets/Py_WorldTime.cpp, rulesets/Python_API.cpp,
	  rulesets/TerrainProperty.cpp, server/Admin.cpp,
	  server/CommServer.cpp, server/Connection.cpp,
	  server/EntityFactory.cpp, server/WorldRouter.cpp,
	  tools/cycmd.cpp, tools/cyconvertrules.cpp, tools/cyctrl.cpp:
	  Remove unnecessary () from conditional expressions, where operator
	  binding is clear.

2007-07-30  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add an activation for the combat task, as we now
	  require it.

2007-07-30  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, server/EntityFactory.h: Major overhaul of
	  error reporting when installing rules, covering many new cases, and
	  reporting errors more clearly.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/MemMap.cpp, rulesets/Motion.cpp,
	  rulesets/Python_API.cpp, rulesets/TerrainProperty.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp: Don't use camel casing for
	  local variables or function arguments.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Don't use camel casing for local
	  variables or function arguments.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* common/AtlasFileLoader.cpp, common/AtlasFileLoader.h: Fix a leaked
	  codec object.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove some left over debug output.
	  Fix a directory object leaked.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp, common/log.h, common/BaseEntity.cpp,
	  common/BaseEntity.h: Switch to taking a C++ string reference rather
	  than a char *, for the rest of the logging and error related
	  calls.

	* common/Database.cpp, common/log.cpp, common/log.h,
	  rulesets/PythonMindScript.cpp, server/Account.cpp,
	  server/Admin.cpp, server/Connection.cpp, server/Player.cpp,
	  tools/cyisoload.cpp: Convert over to using the new API correctly.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h: Add a world entity to all IG entities
	  before testing, to ensure they are apropriatly rigged up for testing.

2007-07-29  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp, common/log.h: Switch to taking a C++ string reference
	  rather than a char *, as it is not really an optimisation, and it
	  makes the code simpler to read and write.

	* client/BaseClient.cpp, client/ClientConnection.cpp,
	  common/AtlasFileLoader.cpp, common/BaseEntity.cpp,
	  common/Database.cpp, common/globals.cpp, common/id.cpp,
	  common/inheritance.cpp, common/log.cpp, common/log.h,
	  rulesets/Character.cpp, rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/MemMap.cpp, rulesets/Motion.cpp, rulesets/Pedestrian.cpp,
	  rulesets/Py_Object.cpp, rulesets/Py_RootEntity.cpp,
	  rulesets/PythonMindScript.cpp, rulesets/PythonThingScript.cpp,
	  rulesets/Python_API.cpp, rulesets/Thing.cpp, server/Account.cpp,
	  server/Admin.cpp, server/ArithmeticFactory.cpp,
	  server/CommClient.cpp, server/CommListener.cpp,
	  server/CommMDNSPublisher.cpp, server/CommServer.cpp,
	  server/Connection.cpp, server/EntityFactory.cpp,
	  server/Persistance.cpp, server/Restoration.cpp,
	  server/ScriptFactory.cpp, server/TaskFactory.cpp,
	  server/WorldRouter.cpp, server/server.cpp: Convert over to using
	  new API correctly.

	* data/mason.xml: Add biomass and transient to fircone, making its
	  script obsolete:


2007-07-26  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Add a new active property handler,
	  that schedules the destruction of an entity after a timeout.

	* data/mason.xml: Add biomass and transient properties to Acorn,
	  making most of the script obsolete.

	* rulesets/mason/world/objects/plants/seeds/Acorn.py: Remove handlers
	  for eating and handling decay from the script, now that this
	  functionality is taken by properties.

2007-07-26  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Improve the
	  mechanism for identifying rules which have broken dependencies.

2007-07-24  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove and disable debug output.

2007-07-17  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Complete the code that populates
	  operations on a tool based on the task activations in the
	  ruleset, removing the need for world builders to synchronise
	  this data manually.

	* data/basic.xml, data/mason.xml: Remove operations from all tools
	  that only use them for activating tasks, now that this is handled
	  automatically.

2007-07-17  Al Riddoch  <alriddoch@zepler.org>

	* common/debug.cpp: Add template specialisation for dumping lists.

	* server/EntityFactory.cpp: Add part completed code for adding tool
	  operations dynamically to tools.

2007-07-17  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Explicitly enable binreloc for
	  autopackage builds.

	* server/Makefile.am, tools/Makefile.am: Link a couple more libraries
	  statically.

2007-07-16  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Fix a race condition in the code that
	  loads rules that depend on other rules.

2007-07-11  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Update dependencies now that rpms are included in
	  in major distributions under a slightly more sensible name.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.13

2007-07-09  Al Riddoch  <alriddoch@zepler.org>

	* scripts/cyphesis-setup.sh: Complete the database setup script
	  functionality. Clean up the output, and polish.

	* server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h: Partially specialise the non
	  persistent entity factory so we can register the persistor database
	  tables for the world object when persistence is disabled, so the
	  state of this entity can be restored.

	* server/server.cpp: Tidy up the startup output.

	* server/EntityFactory.cpp: Don't try and set up world persistence if
	  it is turned off.

2007-07-08  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove a few pointless entity scripts.

2007-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Cultivate.py: Add new task script for
	  cultivating plants from seed.

	* data/mason.xml: Add task class for cultivate. Add GERMINATES
	  property to all seed classes. Remove germinate operation definition
	  and trowel script.

2007-07-07  Al Riddoch  <alriddoch@zepler.org>

	* Makefile.am, scripts/cyphesis-setup.sh: Get the script for setting
	  up database working fairly smoothly.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: When processing a new task rule, check
	  that the operation and tool classes referenced have been installed.
	  If not, make the class pending on those classes.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: When moving, check if the entity has
	  LOC set. If not, print an error, and assert. This may be a
	  valid way to check for the TLVE, rather than relying on the
	  world class.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: When deleting, check if the entity has
	  LOC set. If not, print an error, and assert. This may be a
	  valid way to check for the TLVE, rather than relying on the
	  world class.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Don't use "with"
	  as a variable name as it is about to become a reserved word in
	  Python 2.6.

2007-07-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Add a temporary fix that removes the top
	  level module init file for basic/world so old installations of the
	  rulesets code don't mess up a new one.

2007-07-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Area.cpp, rulesets/Area.h, rulesets/Food.cpp,
	  rulesets/Food.h, rulesets/Line.cpp, rulesets/Line.h:
	  Remove these unused core entity classes from the build.

	* rulesets/attributes.h, server/EntityFactory.cpp,
	  server/PersistantThingFactory.cpp, server/Persistor.cpp,
	  server/Persistor.h, server/Persistor_impl.h, server/Restoration.cpp,
	  server/Restorer.cpp: Remove the unused classes above from the
	  persistence code.

	* tests/Makefile.am: Remove tests for the removed classes.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Delve.py,
	  rulesets/mason/world/tasks/Dig.py: Use the right coordinates for
	  checking position on the terrain, and abort the task if
	  there is nothing there to dig or delve.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Provide entirely data driven definitions for Cut
	  and Chop ops.

	* common/Chop.h, common/Cut.h, common/Makefile.am, common/custom.cpp,
	  common/operations.cpp, common/types.h, tests/Makefile.am,
	  tests/Tasktest.cpp, tests/allOperations.h,
	  tests/inheritancetest.cpp: Remove the hard coded Cut and Chop op
	  definitions completely from the build.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityExerciser.h, tests/Makefile.am, tests/allOperations.h:
	  Remove Delve, Dig and Mow from the tests.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Strip entity scripts off pickaxe and shovel.

	* rulesets/World.h, rulesets/World.cpp: Remove handlers used to
	  to implement pickaxe and shovel, which are now handled as tasks.

	* common/Delve.h, common/Dig.h, common/Mow.h, common/custom.cpp,
	  common/operations.cpp: Remove a bunch of operations from the build
	  which were only used to do things in an over simple hard coded way.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Delve.py: Handle delving up ice as well,
	  and make it more data driven.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: New task class for shovel.

	* rulesets/mason/world/tasks/Dig.py: Add new task script for using
	  a shovel to get piles of material like sand and mud from the ground.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: New task class for pickaxe. Remove useless script
	  from rope.

	* rulesets/mason/world/tasks/Delve.py: Add new task for using a
	  pickaxe to get rock from the terrain.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the script for scythe as it is no longer
	  used.

	* rulesets/World.cpp: Remove mow operation from World, as this is now
	  handled by a task.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Property.h, rulesets/Py_Property.cpp,
	  rulesets/Py_TerrainProperty.cpp, rulesets/Makefile.am,
	  rulesets/Python_API.cpp: Complete implementation of terrain
	  property wrapper.

	* rulesets/mason/world/tasks/Reap.py: Check the surface to make sure
	  it is grass. Remove deubg output.

2007-07-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_TerrainProperty.cpp: New wrapper for terrain property.
	  Work in progress.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Property.h, rulesets/Py_Property.cpp: Add handling
	  for a Python wrapper for terrain property.

	* rulesets/TerrainProperty.h, rulesets/TerrainProperty.cpp:
	  Copy functions from World for getting information about surface
	  and height from the terrain property.

	* tests/Makefile.am: Update the linker options for the flags now that
	  the core property code references the mercator terrain library.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.h, rulesets/Py_BBox.h, rulesets/Py_Point3D.h,
	  rulesets/Py_Quaternion.h, rulesets/Py_Vector3D.h,
	  server/CommMDNSPublisher.cpp: Use double quotes not angle brackets
	  when including headers out of the cyphesis source tree.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Reap.py: New task to implement reaping
	  grass with a scythe.

	* server/EntityFactory.cpp: Report an error more clearly.

	* data/mason.xml: Fix a bug in the gravestone rule.

	* date/mason.xml: Add new reap task class.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, rulesets/Character.cpp, rulesets/Character.h:
	  Strip all the negative matching out of the filter for operations
	  going from world to mind, instead only dispatch those that pass, or
	  need to be checked.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Remove some long obsolete comments.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Remove the script from cleaver as all the
	  functionality is now tasks.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove factory for food core base class,
	  as it is no longer used.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Remove scripts from pig and deer which are made
	  obsolete by new Slaughter task.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml, data/mason.xml: Add type information for venison
	  from deer.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Set the mass of ham to 1 by default.

	* rulesets/mason/world/tasks/Slaughter.py: Finish task for
	  slaughtering animals for meat.

2007-07-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slaughter.py: Work in progress.

2007-06-30  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the explicit class for butcher, and just use
	  the settler class. Character appearance should not be determined by
	  class.

	* data/mason.xml: Add a new slaughter task class, work in progress.

	* rulesets/mason/world/tasks/Slaughter.py: Incomplete script for
	  slaughter task.

	* rulesets/mason/define_world.py: The butcher is now an instance of
	  settler.

2007-06-28  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h, common/custom.cpp,
	  common/op_switch.h, rulesets/BaseMind.cpp, rulesets/Character.cpp,
	  rulesets/Character.h, rulesets/Thing.cpp, rulesets/Thing.h,
	  tests/EntityExerciser.h: Remove the long obsolete Action op from
	  the core code.

2007-06-28  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, common/BaseEntity.cpp, common/BaseEntity.h,
	  rulesets/Character.cpp, rulesets/Character.h: Remove Cut operation
	  from the core code.

2007-06-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/outdoor/Gravestone.py: Make sure
	  velocity is not set on skeleton parts found in a grave.

2007-06-26  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the script from sword, as it does nothing
	  useful.

2007-06-25  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/outdoor/Gravestone.py, data/mason.xml:
	  Remove the multiple gravestone classes, in favor of using style
	  to differentiate between them.

	* rulesets/mason/define_world.py: Use the new styled gravestone
	  class, and also use style to add variety to the fir trees.

2007-06-25  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h, common/op_switch.h,
	  rulesets/Character.cpp, rulesets/Character.h: Remove the chop
	  operation completely from the core code. Remove some OOG
	  operations from the world to mind filter, as they should never
	  occur.

	* rulesets/BaseMind.cpp, rulesets/Plant.cpp: Remove some obsolete
	  operation header includes.

	* tests/EntityExerciser.h: Remove Chop from the test for entity.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml, data/mason.xml: Remove inheritance from food class,
	  as food is now entirely property based.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp, tools/cyaddrules.cpp,
	  tools/cyloadrules.cpp: Remove some directory walking debug output.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h, common/op_switch.h,
	  rulesets/Character.cpp, rulesets/Character.h, rulesets/Food.cpp,
	  rulesets/Food.h, rulesets/World.cpp, rulesets/World.h,
	  tests/EntityExerciser.h: Purge the burn operation from the core
	  operation handling code. One down, many still to go.

2007-06-22  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Finish installing the burn speed
	  property, now tested.

	* rulesets/Thing.cpp, rulesets/Thing.h: Remove legacy Burn operation
	  handler.

2007-06-21  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Add a new active dynamic property
	  "burn_speed" for things that can burn.

2007-06-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h: Add a new type of property
	  builder than can install multiple operation handlers.

	* server/CorePropertyManager.cpp: Add a new active dynamic property
	  "biomass" for things which can be eaten, which handles the Eat
	  operation.

	* rulesets/Food.cpp, rulesets/Food.h: Remove the old Eat operation
	  handler.

	* data/basic.xml, data/mason.xml: Give all the food entity rules
	  some biomass.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version.

	* rulesets/Plant.cpp, rulesets/Plant.h: Remove the chop operation
	  handler, now completely obsolete as that functionality is done
	  by the task script.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* tools/cydumprules.cpp: Re work the rule dumper to use the ruleset
	  column more correctly.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Fix up the rpm spec for the new layout of config
	  files and script directories.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Ensure the basic code now omitted from
	  rulesets is distributed.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Change the type and name
	  of the ruleset list to a string.

	* rulesets/Python_API.cpp, server/EntityFactory.cpp,
	  server/server.cpp, tools/cyaddrules.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp: Switch to using single ruleset config
	  variable.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Remove loading config data for inherited
	  rulesets.

	* rulesets/Python_API.cpp: Add the python path for mind code
	  manually, and only add one path for the ruleset.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/world/objects/buildings/House.py,
	  rulesets/basic/world/objects/buildings/StoneHouse.py,
	  rulesets/basic/world/objects/buildings/__init__.py,
	  rulesets/basic/world/objects/elements/Fire.py,
	  rulesets/basic/world/objects/elements/__init__.py,
	  rulesets/basic/world/objects/tools/Axe.py,
	  rulesets/basic/world/objects/tools/Bow.py,
	  rulesets/basic/world/objects/tools/Pickaxe.py,
	  rulesets/basic/world/objects/tools/Scythe.py,
	  rulesets/basic/world/objects/tools/Shovel.py,
	  rulesets/basic/world/objects/tools/Sword.py,
	  rulesets/basic/world/objects/tools/__init__.py:
	  Remove files that are no longer used from here, and have
	  been duplicated in the mason ruleset.

2007-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Remove the messy import hooks that make
	  inherited rulesets work, but screw up module reloading.

	* rulesets/acorn/mind/SkelMind.py,
	  rulesets/acorn/world/objects/Weather.py,
	  rulesets/acorn/world/objects/animals/Crab.py,
	  rulesets/acorn/world/objects/animals/Deer.py,
	  rulesets/acorn/world/objects/animals/Pig.py,
	  rulesets/acorn/world/objects/animals/Squirrel.py,
	  rulesets/acorn/world/objects/animals/Wolf.py,
	  rulesets/acorn/world/objects/buildings/FarmHouse1.py,
	  rulesets/acorn/world/objects/buildings/FarmHouse2.py,
	  rulesets/acorn/world/objects/buildings/FarmHouse3.py,
	  rulesets/acorn/world/objects/buildings/FarmStand.py,
	  rulesets/acorn/world/objects/buildings/FishShop.py,
	  rulesets/acorn/world/objects/buildings/House1.py,
	  rulesets/acorn/world/objects/buildings/House2.py,
	  rulesets/acorn/world/objects/buildings/House3.py,
	  rulesets/acorn/world/objects/buildings/House4.py,
	  rulesets/acorn/world/objects/buildings/House5.py,
	  rulesets/acorn/world/objects/buildings/Inn1.py,
	  rulesets/acorn/world/objects/buildings/Inn2.py,
	  rulesets/acorn/world/objects/buildings/ItemShop.py,
	  rulesets/acorn/world/objects/buildings/Mansion.py,
	  rulesets/acorn/world/objects/buildings/MetalShop.py,
	  rulesets/acorn/world/objects/buildings/Ruin.py,
	  rulesets/acorn/world/objects/buildings/Shack.py,
	  rulesets/acorn/world/objects/buildings/Stall.py,
	  rulesets/acorn/world/objects/buildings/Sty.py,
	  rulesets/acorn/world/objects/buildings/VacantShop1e.py,
	  rulesets/acorn/world/objects/buildings/VacantShop1w.py,
	  rulesets/acorn/world/objects/buildings/VacantShop2.py,
	  rulesets/acorn/world/objects/outdoor/Campfire.py,
	  rulesets/acorn/world/objects/plants/Tree.py,
	  rulesets/acorn/world/objects/plants/seeds/Acorn.py,
	  rulesets/acorn/world/objects/plants/seeds/Apple.py,
	  rulesets/acorn/world/objects/plants/seeds/Seed.py,
	  rulesets/acorn/world/objects/tools/Cleaver.py,
	  rulesets/acorn/world/objects/undead/Arm.py,
	  rulesets/acorn/world/objects/undead/Pelvis.py,
	  rulesets/acorn/world/objects/undead/Ribcage.py,
	  rulesets/acorn/world/objects/undead/Shin.py,
	  rulesets/acorn/world/objects/undead/Skull.py,
	  rulesets/acorn/world/objects/undead/Thigh.py,
	  rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/world/objects/Pile.py,
	  rulesets/basic/world/objects/animals/Animal.py,
	  rulesets/basic/world/objects/buildings/House.py,
	  rulesets/basic/world/objects/buildings/StoneHouse.py,
	  rulesets/basic/world/objects/elements/Fire.py,
	  rulesets/basic/world/objects/plants/Tree.py,
	  rulesets/basic/world/objects/tools/Axe.py,
	  rulesets/basic/world/objects/tools/Bow.py,
	  rulesets/basic/world/objects/tools/Pickaxe.py,
	  rulesets/basic/world/objects/tools/Scythe.py,
	  rulesets/basic/world/objects/tools/Shovel.py,
	  rulesets/basic/world/objects/tools/Sword.py,
	  rulesets/mason/world/objects/Pile.py,
	  rulesets/mason/world/objects/Weather.py,
	  rulesets/mason/world/objects/animals/Deer.py,
	  rulesets/mason/world/objects/animals/Pig.py,
	  rulesets/mason/world/objects/buildings/House.py,
	  rulesets/mason/world/objects/buildings/House3.py,
	  rulesets/mason/world/objects/buildings/StoneHouse.py,
	  rulesets/mason/world/objects/clothing/Garment.py,
	  rulesets/mason/world/objects/elements/Fire.py,
	  rulesets/mason/world/objects/outdoor/Campfire.py,
	  rulesets/mason/world/objects/outdoor/Gravestone.py,
	  rulesets/mason/world/objects/plants/Fir.py,
	  rulesets/mason/world/objects/plants/seeds/Acorn.py,
	  rulesets/mason/world/objects/plants/seeds/Apple.py,
	  rulesets/mason/world/objects/plants/seeds/Fircone.py,
	  rulesets/mason/world/objects/plants/seeds/Seed.py,
	  rulesets/mason/world/objects/tools/Axe.py,
	  rulesets/mason/world/objects/tools/Bow.py,
	  rulesets/mason/world/objects/tools/Bucksaw.py,
	  rulesets/mason/world/objects/tools/Cleaver.py,
	  rulesets/mason/world/objects/tools/Pickaxe.py,
	  rulesets/mason/world/objects/tools/Rope.py,
	  rulesets/mason/world/objects/tools/Scythe.py,
	  rulesets/mason/world/objects/tools/Shovel.py,
	  rulesets/mason/world/objects/tools/Sword.py,
	  rulesets/mason/world/objects/tools/Tinderbox.py,
	  rulesets/mason/world/objects/tools/Torch.py,
	  rulesets/mason/world/objects/tools/Trowel.py,
	  rulesets/mason/world/objects/undead/Skeleton.py,
	  rulesets/mason/world/tasks/Bisect.py,
	  rulesets/mason/world/tasks/Combat.py,
	  rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Sharpen.py,
	  rulesets/mason/world/tasks/Slice.py,
	  rulesets/mason/define_world.py:
	  Convert rulesets over to inheriting from the Thing class in
	  the new non ruleset specific location.
	  
	* rulesets/basic/mind/goals/animal/domestic.py: Add file missing from
	  previous commit.

2007-06-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/trigger.py: Generic common trigger
	  goals, starting with a trigger base chase goal.

	* rulesets/basic/mind/goals/animal/domestic.py: Trigger goals specific
	  to domesticated animals, starting with goals for pig herding.

	* rulesets/basic/mind/goals/__init__.py: Add the two new files of
	  trigger goals.

	* rulesets/mason/mind/PigMind.py, rulesets/mason/mind/SkelMind.py,
	  rulesets/mason/mind/WolfMind.py, rulesets/mason/mind/__init__.py:
	  Remove special mind classes for pig, skeleton and wolf, as it
	  should be possible to do it more cleanly with trigger goals.

	* rulesets/mason/define_world.py: Add trigger goals for pig and
	  skeleton to replace the behavior that used to be in special purpose
	  mind classes.

2007-06-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Add a new directory to the python path
	  containing non ruleset specific code that is required by any
	  normal python scripts.

	* rulesets/Makefile.am: Install non ruleset specific python code
	  that was historically in common into a separate place.

	* irulesets/mason/define_world.py: Import the editor functionality
	  from the new location.

2007-06-16  Al Riddoch  <alriddoch@zepler.org>

	* data/Makefile.am: Install the xml files for mason into the mason.d
	  subdir, as the rule loading code now prefers.

	* server/EntityFactory.cpp, tools/cyaddrules.cpp,
	  tools/cyloadrules.cpp: Modify the way rule xml files are loaded
	  so files from the ruleset specific subdirectory are loaded first,
	  and the legacy way of doing it is done if this files, with a warning
	  message.

2007-06-15  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Check for dirent.h.

	* common/AtlasFileLoader.cpp: Report duplicate IDs when loading rule
	  data.

	* data/basic.xml: Remove obsolete old overriden rules, as we will
	  no longer be doing rules that way.

	* server/EntityFactory.cpp: When loading rulesets directly from
	  files, also load all files in ruleset.d.

2007-06-14  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Add some warnings when task classes linked
	  to other classes may be suspect.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Remove the tool script for the bucksaw class, as
	  we now depend entirely on task scripts for bucksaw functionality.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add a meat property to the pig class, so the
	  rules for butchering can be made more generic.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Remove the tool script for the axe base class, as
	  we now depend entirely on task scripts for axe functionality.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/tools/Bucksaw.py: Add an error message
	  if this code gets called, as it should no longer be.

2007-06-12  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp: Add a message reporting when a rule is not
	  uploaded because it has been overridden.

2007-06-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Logging.py: Implement logging entirely
	  in the task, instead of relying on functionality in the plant
	  class.

	* rulesets/Py_Quaternion.cpp: Implement rotation method as in the
	  the wfmath class, as required for Logging.

	* rulesets/Plant.cpp: Add an error message if the old plant
	  functionality gets called.

	* rulesets/basic/world/objects/tools/Axe.py: Add an error message
	  noting that this method should not be called.

2007-05-30  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Add support for SIGINFO on BSD systems and
	  report something vaguely useful.

2007-05-30  Al Riddoch  <alriddoch@zepler.org>

	* scripts/Info.plist: Correct the syntax.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* server/CommUnixListener.cpp: Remove unused and misleading definition
	  for maximum unix socket address path length.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* scripts/Info.plist: Add package list spec.

	* scripts/gen_mac_app.sh: Use pre-created package list rather than
	  trying to generate it on the fly.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* scripts/gen_mac_app.sh: Script to configure cyphesis in a way
	  it just might be able to run as a Mac application.

2007-05-28  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add experimental check for some platform specific
	  libraries.

2007-05-08  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add two stubb classes for dealing with construction.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Fix the namespacing of the access system call.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Fix the check_tmp_path() function, so it is
	  actually checking the path it has been given, add an access check
	  so we detect a temporary directory that exists but does not have
	  right permissions. Fix the error reporting when both paths fail.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add a check to make sure tar takes the --mode
	  flag.

	* rulesets/Makefile.am: Use tar mode flag only if configure has
	  detected the capability.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Use find expressions to omit CVS control
	  directories from the installed python tree. Clean up the directories
	  the contain the python source during uninstall.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Revise the way python files are installed
	  so that directories are created with the right permissions,
	  ruleset names are referred to in only one place, uninstall does
	  not delete any source files which are not present in the source
	  tree, and potentially dangerous commandlines are aborted if
	  critical directories are missing.

2007-05-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Add options to tar to ensure that python
	  source files are installed with the right permissions.

2007-05-06  Al Riddoch  <alriddoch@zepler.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.12

2007-05-03  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Use the configured port number, not
	  a hard coded default when advertising the service.

2007-05-01  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Add version and help options to the usage
	  information.

2007-05-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Logging.py: Comment out broken attempt
	  at re-wrting this task and revert the original obsolete
	  implementation.

2007-04-29  Al Riddoch  <alriddoch@zepler.org>

	* tests/globalstest.cpp: Add a test covering the function that reports
	  usage information.

	* scripts/run_massif: Add a script with all the necessary arguments
	  to get meaningful results out of the valgrind massif tool.

2007-04-29  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Flag the usage data for
	  cycmd and database tools. Add an additional argument to the
	  usage function for programs which take additional non-varconf
	  arguments.

	* tools/cyaddrules.cpp, tools/cycmd.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp: Add usage to the rest of the tools.

	* client/client.cpp: Add additional argument usage information.

2007-04-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Make sure money transfers are only
	  detected if the NPC is not picking up the money themselves.

	* rulesets/mason/world/tasks/Logging.py: Half written broken re-write
	  of the way the logging task handles causing the tree to fall over.

	* tests/Makefile.am: Fix depencies in the tests affected by version
	  reporting code.

2007-04-28  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.h, common/globals.cpp: Break option data down into
	  sections, fix scoping, and fill out most of the options used.

	* client/client.cpp: Add version and usage reporting calls.

2007-04-28  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Add interfact and mechanism
	  for showing usage data for all the programs given one central
	  location for the data.

	* server/server.cpp: Test out the usage function.

	* tools/cypasswd.cpp: Display usage using the old mechanism.

2007-04-28  Al Riddoch  <alriddoch@zepler.org>

	* commong/globals.h, common/globals.cpp: Add definitions for different
	  error codes from reading the config file, in particular codes that
	  indicate that the user has requested version, help or usage
	  information. Add a function for reporting the version of tools.

	* server/server.cpp: Add support for version or usage arguments,
	  including specific reporting of the server build number, which is
	  does not apply when reporting the version of other components.

	* tools/Makefile.am: Fix the globals modules dependency on consts.

	* tools/cypasswd.cpp: Add support for version or usage arguments.

2007-04-24  Al Riddoch  <alriddoch@zepler.org>

	* tools/cypasswd.cpp: Improve the usage documentation.

	* common/globals.cpp: Add a varconf parameter lookup to allow
	  shorthand arguments to be used to request usage information.

2007-04-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py,
	  rulesets/basic/mind/goals/common/move.py,
	  rulesets/basic/mind/goals/humanoid/construction.py,
	  rulesets/mason/define_world.py: Fix most goals so they no longer
	  require a reference to the owning mind object on initialisation,
	  meaning they are now more stateless.

2007-04-23  Al Riddoch  <alriddoch@zepler.org>

	* tests/randomtest.cpp: More thoroughly check that the random number
	  generators are producing what is expected.

2007-04-23  Al Riddoch  <alriddoch@zepler.org>

	* tests/systemtest.cpp: Cover security check function, and priority.

2007-04-23  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.h: Expose flush() method for testing.

	* common/inheritance.cpp: Improve error messages, and include
	  the operation dictionary in the data structures cleared by flush().

	* tests/logtest.cpp: Add more cases to cover the logging functions
	  for libc errno reporting.

	* tests/inheritancetest.cpp: Add many more cases to cover previously
	  untested methods, and verify everything is as it should be when
	  the class is cleared using flush().

2007-04-22  Al Riddoch  <alriddoch@zepler.org>

	* common/log.h, common/log.cpp: Expose a new function to set up the
	  event log system for testing.

	* tests/logtest.cpp: Add test cases for the event log calls.

2007-04-22  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment to new version for release one of these
	  days.

2007-04-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/move.py: Expire the accompany goal
	  used by mercenaries when the person they are working for no longer
	  exists.

2007-04-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Have the warriors for hire gather
	  up all the junk that is left around when unused characters die.

2007-04-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py,
	  rulesets/basic/mind/goals/common/move.py,
	  rulesets/basic/mind/goals/humanoid/construction.py:
	  Re-write goals relating to gathering things off the ground
	  to be clearer, more efficient, and to deal with lists of types.

	* rulesets/mason/define_world.py: Use warrior test to test gathering
	  lists of types.

2007-04-02  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Re-enable static linking of C++
	  libraries for the autopackage.

2007-04-02  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Improve error reporting when dealing with
	  persistence tables.

2007-04-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Oplist.cpp, rulesets/Py_Operation.cpp: Use the python
	  hex version, as its more reliable for comparison when setting up
	  typedefs for older python versions.

	* common/random.h: Use the C++ version of stdlib.h.

2007-03-20  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Try and be smarter about the temporary directory
	  used for logging and socket files so that it works on centrally
	  installed autopackages.

2007-03-19  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Use "basic" if no ruleset is specified in the
	  config.

2007-03-19  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Use a supported date format on Windows.

2007-01-26  Al Riddoch  <alriddoch@zepler.org>

	* tests/TestDataSet.cpp, TestDataSet.h: New class to handle a large
	  set of test Atlas data to throw at various code that accepts Atlas
	  data from the wire.

	* tests/Makefile.am: Add network libs to a unit test, so it will
	  build on platforms where gethostname is in the network libs.

2007-03-08  Al Riddoch  <alriddoch@zepler.org>

	* Makefile.am: Remove GNU echo isms.

	* rulesets/basic/mind/goals/common/move.py: Modify the pick_up_focus()
	  goal so it clears the focus. gather() now gathers things
	  indefinitely.

	* rulesets/mason/define_world.py: Add a test script for warriors to
	  gather stuff.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Clean up database error messages, and add
	  hint about disabling the database if this is required.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Improve the presentation of Database error
	  messages.

	* server/server.cpp: If connecting to the database fails, just
	  disable it, and report plenty of error information.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* data/cyphesis.vconf: Add default value for database config flag.

2007-02-20  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Add a config flag
	  to control whether database code is enabled.

	* server/EntityFactory.cpp, server/EntityFactory.h,
	  server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h, server/Persistor.cpp:
	  Re-work the persistence code so that persistent or non-persistent
	  versions of entity factories are installed at startup, removing
	  the need to check whether the database is enabled during
	  runtime.

	* common/newid.cpp, server/Connection.cpp, server/server.cpp:
	  Replace the const that used to control whether the database
	  was used with the config flag.

2007-02-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/panlingua/interlinguish.py: Add nouns for a
	  number of tools, by Max Randor.

	* rulesets/mason/define_world.py: Make many more tools available for
	  sale, by Max Randor.

2007-02-17  Al Riddoch  <alriddoch@zepler.org>

	* scripts/cyphesis-setup.sh: Add new untested script that automates
	  setting up a database account for cyphesis.

	* Makefile.am: Add a message to the end of the install output
	  informing that the setup script needs to be run to sort out
	  the database access.

2007-02-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Add function by Max Randor to
	  plant a field full of vegetables. Use it to populate the village
	  fields with carrots and turnips.

2007-02-13  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Make some of the error messages a little more verbose,
	  and consistent.

2007-02-10  Al Riddoch  <alriddoch@zepler.org>

	* autopackage/default.apspec.in: Update autopackage spec to latest
	  features.

2007-02-08  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Update all the tests to report their failure in
	  a clean and readable way, with as much information as possible
	  to help the user if they fail.

2007-02-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Don't complain about unknown tick types.

	* tools/cycmd.cpp: Use a cleaner more consistent way to identify
	  tick ops that are for this client.

2007-02-07  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: All add_agent command to specify avatar type,
	  so cycmd is usable with non-priveleged accounts.

2007-02-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.h: Remove m_world as it no longer has to mask
	  Entity::m_world.

2007-02-05  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Correct the spelling of visibility.

2007-01-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/objects/Weather.py: Add visibility to
	  the weather object, used to control the distance of the fogging.

2007-01-31  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add new visibility property to weather, and clamp
	  it to ten metres for testing.

2007-01-31  Al Riddoch  <alriddoch@zepler.org>

	* FIXME: Clearly mark the fixed ones.

	* data/mason.xml: Put a nice enormous huge bbox so its always
	  visible. Make the box non-solid for collision purposes.

	* rulesets/mason/world/objects/Weather.py: Make rain shorter on
	  average, and make the ammount of rain more variable.

2007-01-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/panlingua/interlinguish.py: Add some clothing
	  types to the vocabulary.

	* rulesets/mason/define_world.py: Add a tailor stall to the village.

2007-01-28  Al Riddoch  <alriddoch@zepler.org>

	* server/ExternalMind.cpp: Make sure hungry and starving hints only
	  make it when they apply to this character, not to others.

2007-01-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ActivePropertyFactory_impl.h: Correct the header guard
	  comments.

	* rulesets/SolidProperty.cpp, rulesets/SolidProperty.h: New property
	  to handler whether an entities bbox is solid or not.

	* rulesets/EntityPropertyFactory.cpp, rulesets/EntityPropertyFactory.h,
	  rulesets/EntityPropertyFactory_impl.h: New property factory
	  for properties the contructor of which takes an entity pointer of
	  the owning entity.

	* server/CorePropertyManager.cpp: Install the SOLID property on demand.

	* data/basic.xml: Make area entities non-solid by default, so you don't
	  collide with them.

2007-01-27  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Fix the bounding box size for the pair of boots.

2007-01-27  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Remove the hack that ensures players always
	  create a settler if they try and create a character that does not
	  exist. Handle setting initial attributes unique to player characters
	  here, rather than setting the defaults on the classes.

	* data/mason.xml: Remove initialising status to a ery low value to
	  make settlers and goblins starve easily.

	* data/basic.xml: Set the mass of a arrow to something sane.

2007-01-22  Al Riddoch  <alriddoch@zepler.org>

	* data/werewolf.xml: Fix the syntax of werewolf rule objects.

	* rulesets/Character.cpp: Document what mindSetOperation will have to
	  do once security is locked down.

2007-01-21  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Fix the creation of entities
	  as a result of the decays property so they don't get velocity
	  and bbox from the entity that spawned them.

2007-01-19  Al Riddoch  <alriddoch@zepler.org>

	* server/ExternalMind.cpp: Implement a filter point for all remote
	  controlled characters where hints and other helpful emotes can
	  be inserted. Use it to inform characters of imminent starvation.

2007-01-18  Al Riddoch  <alriddoch@zepler.org>

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.11

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Fix linking tests.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Back off accidentally commited change.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Remove some debugging output.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Set argument names on
	  some methods. Add a new method allowing a property to be set
	  externally.

	* server/ExternalProperty.cpp, server/ExternalProperty.h: Add a new
	  property which reflects whether an entity is connected to the
	  outside world via an external mind.

	* server/Connection.cpp, server/Connection.h: Add a new method which
	  hooks up an avatar to the connection, installing an ExternalProperty
	  if necessary.

	* server/Account.cpp: Use the new Connection method to hook up
	  existing avatars.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Fix the name of character inventory items.

	* server/Connection.cpp: Stop any movement when the client
	  disconnects.

2007-01-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Use isDefaultFoo() rather than
	  hasAttrFlag(FOO) for brevity and readability.

2007-01-16  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Adjust the bbox on the knife like a whole load.

	* server/Account.cpp: Hack some clothes into the startup inventory.

2007-01-16  Al Riddoch  <alriddoch@zepler.org>

	* common/type_utils.h: Properlly check for Atlas data type when
	  converting data to objects.

	* tests/AllPropertytest.cpp: Enable LineProperty test now that the
	  type checking is good enough.

2007-01-15  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Make goblin playable.

2007-01-15  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Remove avahi libraries from the static build
	  as they create more hassle than it is worth.

2007-01-14  Al Riddoch  <alriddoch@zepler.org>

	* common/Property.cpp: Add some specialisations that are useful
	  to cover in the tests, even though we are not using them in
	  the server yet.

	* common/inheritance.h: Provide an accessor for the dictionary of
	  class objects for testing purposes.

	* rulesets/AreaProperty.cpp: Use Map() rather than isMap() once we
	  have already tested it.

	* rulesets/Entity.cpp: Remove some debug output.

	* server/CorePropertyManager.cpp: Remove some debug output.

	* tests/PropertyExerciser.h, tests/PropertyExerciser.cpp: Fill out
	  the functionality of the property tester. Add functions to get
	  random values. Use vector for value storage to make it easier
	  to generate the random values.

	* tests/AllPropertytest.cpp: Cover all the property classes we can
	  test.

	* tests/Makefile.am: Add mercator libraries to the property test,
	  as we are now testing the terrain property.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.cpp: Expand the coverage of the tests.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.cpp, tests/PropertyExerciser.h: Expand the
	  coverage of the tests.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp: Remove debug output.

	* rulesets/Character.cpp: Remove debug output.

2007-01-13  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.cpp: Add the required assert header.

2007-01-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_BBox.cpp, rulesets/Py_Location.cpp, rulesets/Py_Map.cpp,
	  rulesets/Py_Mind.cpp, rulesets/Py_Object.cpp,
	  rulesets/Py_Operation.cpp, rulesets/Py_Oplist.cpp,
	  rulesets/Py_Optime.cpp, rulesets/Py_Quaternion.cpp,
	  rulesets/Py_RootEntity.cpp, rulesets/Py_Task.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Py_World.cpp,
	  rulesets/Python_API.cpp: Replace calls to PyMem_DEL with calls
	  to PyObject_Free. Thanks to Kai for doing most of the digging
	  on this one.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* tests/PropertyExerciser.h, tests/PropertyExerciser.cpp:
	  New class which thoroughly exercises any property class via its
	  base interface.

	* tests/AllPropertytest.cpp: Start passing all property classes
	  through the as yet incomplete exerciser.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp: Add the connection to the entities
	  deleted signal to those to be removed when the entity is containered
	  or a garment will be connected to its wearer forever, even after
	  it has been removed.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.h, rulesets/OutfitProperty.cpp: Add
	  arguments to methods, so the owner of this property is available
	  in important parts of the code. Trigger an Update when clothing
	  is removed, so the property change is propagated.

	* rulesets/Character.cpp: Call OutfitProperty with a pointer to
	  the Character, so it knows where to send the update.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ActivePropertyFactory_impl.h: Remove debug output.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Fix my broken idea of what ISO date was supposed
	  to look like, in the logs and standard output.

2007-01-11  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Modify DECAYS Delete handler so
	  that the parent entity handles the creation of entities that
	  have resulted from the decay.

	* rulesets/Character.cpp: Call Entity::operation() from operation()
	  to ensure operation handlers are called, and all future
	  modifications get picked up too.

	* data/basic.xml, data/mason.xml: Add a DECAYS property leaving a
	  skull to all humanoid classes.

2007-01-10  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h: Add an entity pointer to the handler function
	  pointer arguments.

	* rulesets/ActivePropertyFactory_impl.h: Fix the guard comment.

	* rulesets/Character.cpp: Remove debugging output.

	* rulesets/Entity.cpp: Fix new property code so it now sets the
	  value. Improve the debug reporting when dealing with op handlers.

	* rulesets/mason/define_world.py: Test the decays property.

	* server/CorePropertyManager.cpp: Add a DECAYS property and a
	  test handler for it.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Oplist.cpp: Correct Python 2.5 fix to the right
	  function.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Oplist.cpp, rulesets/Py_Operation.cpp:
	  Fix function fingerprints so they are compatible with Python 2.5.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Implement the delete command for in game
	  entities.

2007-01-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Delete entities if their status has gone
	  below zero when an update is processed.

2007-01-08  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Set default mass on bottle entity.

	* tools/cycmd.cpp: Add help for upcoming delete command. Improve
	  readability by using available typedefs.

	* rulesets/Thing.cpp: Hide some debug output.

2007-01-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h: Fix broken doc comments on constants for
	  metabolism.

	* rulesets/Character.cpp: Switch metabolism code over to use the
	  update mechanism, to remove race conditions. Re-write the
	  math so that nothing can stay alive for ages by consuming all their
	  mass. Tune constants so a well fed character will take a month.

	* data/mason.xml: Set up goblin and settler class so that by
	  default they will starve to death in a few hours, and need to find
	  food to avoid this.

	* common/const.h: Oops. Database got disabled again by accident.
	  Turn it back on.

2007-01-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Operation.cpp: Fix formatting of comments.

	* rulesets/Py_Oplist.cpp: Adapt sequence methods to be compatible
	  with the new interface typedefs in Python 2.5

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add a mechanism to make
	  signal connection to Entity::containered single shot only.

	* rulesets/OutfitProperty.cpp: Make the connect to garments
	  containered signal single shot, to avoid having to disconnect it.

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp: Remove a FIXME comment fixed in the
	  previous commit.

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp, rulesets/OutfitProperty.h:
	  Add a virtual destructor, for strict correctness.

	* rulesets/Entity.cpp: Clean up variable names in destroy().
	  Moving moving contents into LOC on destruction, remove the
	  ref counts to the destroyed entity held by its contents.
	  This means Characters can now get deleted.

2007-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp, rulesets/OutfitProperty.h: Make this
	  property sigc++ trackable, and add a method to handle signals
	  indicating that the entity has been removed from the outfit.

	* rulesets/mason/define_world.py: Add a test function for messing
	  with outfit.

	* rulesets/Character.cpp: Make sure the "outfit" property really is
	  an OutfitProperty.

2007-01-04  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add Python 2.5 to the versions detected by configure.

	* rulesets/Py_Operation.cpp: Adapt sequence methods to be compatible
	  with the new interface typedefs in Python 2.5

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Character.h: Remove SEX property
	  from Character.

	* rulesets/attributes.h, server/Persistor_impl.h, server/Restorer.cpp:
	  Remove SEX property from the persistence code.

	* tests/Charactertest.cpp, tests/Creatortest.cpp: Remove SEX attribute 
	  from the tests, as it is no longer there.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Update dependencies of tests to include new
	  properties.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Get rid of a warning about a missing
	  return value.

	* tests/AtlasFileLoadertest.cpp: Fix a warning about comparing signed
	  and unsigned integers.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/AtlasProperties.cpp, rulesets/AtlasProperties.h:
	  Add 3 custom property classes used to handle very commonly
	  used properties that are hard coded in Atlas more efficiently.

	* rulesets/Entity.cpp: Use the new performance property code in
	  Entity.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/LineProperty.cpp, rulesets/LineProperty.h: Fix the
	  copyright dates with reference to the cvs log.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add rules for new garments, and set the properties
	  on existing properties so they can be worn.

2007-01-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.h, rulesets/OutfitProperty.cpp: Ensure that
	  removed garments or equipment get reported as empty IDs, and provide
	  a function to clean them up. Provide a direct function for adding
	  garments, without needing to go through the slower standard interface.

	* rulesets/mason/define_world.py: Add a quick hacked in test garment.

	* rulesets/Character.cpp: Implement adding OUTFIT property on demand,
	  and adding to it anything wielded that has a WORN attribute.

2007-01-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Makefile.am: Fix dist-hook so an out-of srcdir invocation
	  of dist does not miss out all the python.

2007-01-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Creator.cpp, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/Pedestrian.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Stackable.cpp, rulesets/Thing.cpp, rulesets/World.cpp:
	  Remove m_world member variable from all Entity classes, and
	  access the world manager object as a singleton.

2006-12-31  Al Riddoch  <alriddoch@zepler.org>

	* common/Type.h, physics/VectorPol.h, rulesets/Combat.cpp,
	  rulesets/Missile.h, rulesets/ThingFactory.cpp,
	  server/CommIdleSocket.cpp, tests/utilitytest.cpp:
	  Mark a bunch of files that were probably removed from the build
	  ages ago.

2006-12-31  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Replace asserts with critical error messages,
	  so tests can run without a Database connection.

	* tests/EntityPropertytest.cpp: Re-write test cases to deal with
	  modified behavoir if the Entity reference is null.

2006-12-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.h, rulesets/Thing.cpp: Make updateProperties
	  const for the time being. Only treap Update operations as
	  generic updates if they don't have a refno. Improve the
	  Update operation handler comments.

2006-12-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/EntityProperty.cpp: Modify EntityProperty so it
	  shows its value as an empty ID if it is not set to anything,
	  and clears its reference if it is set to an empty string.

	* rulesets/Character.cpp: Fix the code that handles an empty wield
	  argument, so it clears the wielded entity correctly and efficiently.

2006-12-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/attributes.h, server/Persistor_impl.h,
	  server/Restorer.cpp: Remove right_hand_wield from the
	  persistence layer, pending its complete removal.

	* rulesets/EntityProperty.h, rulesets/EntityProperty.cpp:
	  Make EntityProperty a more normal property by making it hold
	  a reference to its value, not the value itself.

	* rulesets/Character.cpp, rulesets/Character.h: Use EntityProperty
	  for right_hand_wield attribute, so it stores the value long term
	  which I think is more efficient.

2006-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add some debug instrumentation to the new
	  Property update mechanism.

	* rulesets/Character.cpp: Re-write the Wield handling code to use
	  Update ops.

2006-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp, rulesets/Thing.h: Add a new method to
	  generate a Sight(Set) for a designated set of modified attributes.

	* ThingupdatePropertiestest.cpp: Add a test for the new method.

2006-12-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/OutfitProperty.cpp, rulesets/OutfitProperty.h:
	  Remove the flags constructor argument, as this type of property
	  doesn't work that way.

	* server/CorePropertyManager.cpp: Add OUTFIT property to the
	  dynamic properties handled by the property manager.

2006-12-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/GuiseProperty.h, rulesets/GuiseProperty.cpp,
	  rulesets/OutfitProperty.h, rulesets/OutfitProperty.cpp,
	  rulesets/Makefile.am: Rename "guise" to "outfit" as had
	  been agreed quite a while ago on irc, but I forgot. History
	  preserved using cvs repository hackery.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Add buildid.cpp to the files removed by
	  distclean. Update the dependencies for buildid.cpp to include
	  ChangeLog which is used as the source of the build number.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am: Fix include directories to include the top
	  of the build directory in non relocatable builds, so that out
	  of directory non relocatable builds work.

	* server/Makefile.am: Exclude buildid.cpp from distributed sources
	  and from its own deps to fix some warnings and errors.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* Makefile.am: Include buildid script in the distributed sources.

	* tests/consttest.cpp: Remove buildTime and buildDate from the unit
	  test as they are now defined in server/buildid.cpp.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Add declaration for buildid, an incrementing
	  build number to give finer version tracking of development code.

	* server/ServerRouting.cpp: Add buildid to the server status
	  made available to all clients. Fix entity count in server status
	  as it wasn't fully added in the last change.

	* server/Makefile.am, scripts/gen_buildid.py: Implement buildid
	  by pulling the RCS revision number out of ChangeLog from its
	  embedded RCS Id entry.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/const.cpp: Remove build time and date, because they almost
	  never get updated here.

	* scripts/gen_buildid.py: New script to generate a source file
	  to note the build time and date.

	* server/Makefile.am: Create a new file that depends on all server
	  sources that contains the build time and data, and will contain
	  the build number.

	* server/ServerRouting.cpp: Add number of entities in the world
	  to the server info.

2006-12-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/GuiseProperty.cpp, rulesets/GuiseProperty.h:
	  New property class to handle guise data. I think we had decided
	  to call this property something else, but I can't remember what.

	* common/Property.h, rulesets/EntityProperty.h,
	  rulesets/LineProperty.h: Regularise argument names in property
	  classes, to make checking easier and reduce chance of mimatched
	  overriding.

2006-12-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp: Add inline documentation.

2006-12-26  Al Riddoch  <alriddoch@zepler.org>

	* client/CharacterClient.cpp, client/ClientConnection.h,
	  rulesets/Character.cpp, rulesets/Character.h, tools/cyaddrules.cpp,
	  tools/cyconfig.cpp, tools/cyconvertrules.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp, tools/cypasswd.cpp:
	  Add inline documentation.

	* client/CharacterClient.h, client/CharacterClient.cpp: Remove
	  overriden sight operation handlers, as they are no longer
	  present in the base class, and will never be called.

	* client/ClientConnection.h: Remove obsolete unimplemented template
	  declaration.

	* rulesets/Entity.cpp: Remove documentation for an argument that was
	  never there.

	* tools/cyctrl.cpp: Mark as removed from the build.

	* Add a FIXME about removing hard coded gender property

2006-12-26  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.cpp, client/BaseClient.h,
	  client/ClientConnection.cpp, common/AtlasFileLoader.cpp,
	  common/AtlasFileLoader.h, common/BaseEntity.cpp, common/BaseEntity.h,
	  common/Property.h, common/accountbase.cpp, common/accountbase.h,
	  rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h, rulesets/Area.cpp,
	  rulesets/Area.h, rulesets/AreaProperty.cpp, rulesets/AreaProperty.h,
	  rulesets/BaseMind.cpp, rulesets/BaseMind.h, server/Account.cpp,
	  server/Admin.cpp, server/Admin.h, server/ArithmeticFactory.h,
	  tests/Makefile.am, tools/AdminClient.cpp, tools/AdminClient.h,
	  tools/cycmd.cpp: Add inline documentation.

	* rulesets/ActivePropertyFactory.h: Use handler function pointer
	  typedef for readability.

	* rulesets/AreaProperty.cpp, rulesets/AreaProperty.h: Fix PropertyBase
	  overriding by adding const to the right methods.

2006-12-24  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.h, client/Py_CreatorClient.h,
	  common/BaseEntity.cpp, common/PropertyFactory.h,
	  common/PropertyManager.cpp, common/PropertyManager.h,
	  rulesets/ArithmeticScript.h, rulesets/Py_BBox.h,
	  rulesets/Py_EntityWrapper.h, rulesets/Py_Location.h,
	  rulesets/Py_Map.h, rulesets/Py_Mind.h, rulesets/Py_Object.h,
	  rulesets/Py_Operation.h, rulesets/Py_Oplist.h, rulesets/Py_Point3D.h,
	  rulesets/Py_Property.h, rulesets/Py_Quaternion.h,
	  rulesets/Py_RootEntity.h, rulesets/Py_Task.h, rulesets/Py_Thing.h,
	  rulesets/PythonArithmeticScript.cpp,
	  rulesets/PythonArithmeticScript.h, rulesets/PythonThingScript.cpp,
	  rulesets/PythonThingScript.h, server/Account.h,
	  server/ArithmeticFactory.cpp, server/ArithmeticFactory.h,
	  server/Player.h, server/ServerRouting.cpp, server/ServerRouting.h,
	  server/TaskFactory.h: Add more inline documentation. Harmonise
	  argument names, and move documentation comments into base classes
	  as necessary.

	* FIXME: More notes on a factory related fixme.

	* TODO: Add more stuff to do.

2006-12-24  Al Riddoch  <alriddoch@zepler.org>

	* index.dox, common/BaseWorld.cpp, common/BaseWorld.h,
	  common/PropertyFactory.h, common/PropertyManager.h, common/const.h,
	  rulesets/ActivePropertyFactory.h, rulesets/Entity.h,
	  rulesets/Py_Vector3D.h, rulesets/Py_World.h, rulesets/Py_WorldTime.h,
	  rulesets/PythonMindScript.cpp, rulesets/PythonMindScript.h,
	  rulesets/PythonScript.h,
	  rulesets/PythonThingScript.h, rulesets/PythonWrapper.cpp,
	  rulesets/PythonWrapper.h, rulesets/Script.cpp, rulesets/Script.h,
	  server/ArithmeticFactory.h, server/CommServer.h, server/CommSocket.h,
	  server/ScriptFactory.cpp, server/TaskFactory.cpp,
	  server/TaskFactory.h, server/WorldRouter.cpp, tools/AdminClient.h,
	  tools/cyaddrules.cpp, tools/cycmd.cpp, tools/cyconfig.cpp,
	  tools/cydumprules.cpp, tools/cyloadrules.cpp:
	  Add a truck load of inline docs.

	* tools/cywatchdog.cpp: Mark obsolete file as removed from the build.

	* tools/cyloadrules.cpp, tools/cyconfig.cpp, tools/cyaddrules.cpp:
	  Rename some overly generic types so they have more indicative
	  and unique names.

	* FIXME, server/ScriptFactory.cpp, server/TaskFactory.h: Add a couple
	  of formal FIXMEs to sort out the code for loading modules and
	  classes.

	* rulesets/PythonThingScript.h: Remove some commented out code.

2006-12-22  Al Riddoch  <alriddoch@zepler.org>

	* server/CommClient.h, server/CommListener.h, server/CommLocalClient.h,
	  server/CommMDNSPublisher.h, server/CommMaster.h,
	  server/CommMetaClient.h, server/CommPSQLSocket.h,
	  server/CommPeer.h, server/CommPeerListener.h,
	  server/CommRemoteClient.h, server/CommServer.h,
	  server/CommSlaveClient.h, server/CommSlaveListener.h,
	  server/CommSocket.cpp, server/CommSocket.h,
	  server/CommUnixListener.h: Add a documentation group for socket
	  classes.

	* rulesets/Py_BBox.h, rulesets/Py_EntityWrapper.h,
	  rulesets/Py_Location.h, rulesets/Py_Map.h, rulesets/Py_Mind.h,
	  rulesets/Py_Object.h, rulesets/Py_Operation.h,
	  rulesets/Py_Oplist.h, rulesets/Py_Optime.h, rulesets/Py_Point3D.h,
	  rulesets/Py_Property.h, rulesets/Py_Quaternion.h,
	  rulesets/Py_RootEntity.h, rulesets/Py_Task.h, rulesets/Py_Thing.h,
	  rulesets/Py_Vector3D.h, rulesets/Py_World.h, rulesets/Py_WorldTime.h,
	  rulesets/Python_API.cpp: Add documentation group for Python wrapper
	  types.

	* rulesets/Container.h, rulesets/PythonScript.cpp,
	  server/ScriptFactory.h, server/ScriptFactory.cpp:
	  Add more inline documentation comments.

2006-12-19  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Re-enable database for accounts and rules.

	* data/mason.xml: Make loaf inherit from food.

2006-12-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Script.cpp, rulesets/Structure.cpp:
	  Add some inline documentation.

2006-12-12  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile: Add tools to the documented code.

	* index.dox: Update documentation index.

	* tools/cycmd.cpp: Add a document page for this tool.

	* common/DynamicProperty.h, common/Property.cpp, common/Property.h,
	  rulesets/AreaProperty.h, rulesets/CalendarProperty.h,
	  rulesets/EntityProperty.h, rulesets/LineProperty.h,
	  rulesets/StatisticsProperty.h, rulesets/TerrainProperty.h:
	  Add all property classes into a property group.

2006-12-12  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version.

	* common/const.h: Declare a doxygen group for all the consts.

	* common/operations.cpp, common/Add.h, common/Attack.h, common/Burn.h,
	  common/Chop.h, common/Connect.h, common/Cut.h, common/Delve.h,
	  common/Dig.h, common/Drop.h, common/Eat.h, common/Monitor.h,
	  common/Mow.h, common/Nourish.h, common/Pickup.h, common/Setup.h,
	  common/Tick.h, common/Unseen.h, common/Update.h:
	  Declare a doxygen group for all custom operations.

	* rulesets/Area.h, rulesets/Character.h, rulesets/Creator.h,
	  rulesets/Entity.h, rulesets/Food.h, rulesets/Line.h,
	  rulesets/Missile.h, rulesets/Plant.h, rulesets/Stackable.h,
	  rulesets/Structure.h, rulesets/World.h: Declare a doxygen group
	  for in game entity classses.

	* common/Property.h, common/Property_impl.h, server/ScriptFactory.cpp,
	  server/ScriptFactory.h, server/SlaveClientConnection.cpp,
	  server/SlaveClientConnection.h: Add some more inlined documentation.

2006-12-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Container.cpp, rulesets/Container.h: Document some
	  methods.

2006-12-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Container.h, rulesets/Stackable.cpp, rulesets/Stackable.h,
	  rulesets/Statistics.cpp, rulesets/Statistics.h,
	  rulesets/StatisticsProperty.cpp, rulesets/StatisticsProperty.h,
	  rulesets/TaskScript.cpp, rulesets/TaskScript.h, server/TaskFactory.h:
	  Add inline documentation.

2006-12-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Entity.h, rulesets/Task.h,
	  rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/TrustedConnection.cpp,
	  server/WorldRouter.cpp: Add inline documentation.

2006-12-08  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am: Remove unused header from the build.

2006-12-07  Al Riddoch  <alriddoch@zepler.org>

	* debugtest.cpp: Add a test for debug macro, and atlas dump function.

	* common/debug.cpp: Tweak the indenting when outputting map items
	  in a list.

2006-12-07  Al Riddoch  <alriddoch@zepler.org>

	* tests/OOGThingtest.cpp: Fill out unit tests for constructor,
	  destructor and others.

2006-12-07  Al Riddoch  <alriddoch@zepler.org>

	* common/accountbase.h: Fix the destructor so it does not assume the
	  database has been initialised.

	* accountbasetest.cpp: Add a minimal unit test for accountbase.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	* tests/idtest.cpp: Add a unit test for the ID conversion functions
	  in common/id.cpp.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	* tests/Databasetest.cpp: Add a unit test for the features of
	  Database that can be checked without an RDBMS to connect to.

	* common/Database.h, common/Database.cpp: Provide a function to
	  cleanup the Database singleton, for easier testing.

	* common/Database.cpp: Assert that the connection to the database
	  has been created before calling any functions in the database
	  client lib using that connection.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	* tests/BaseWorldtest.cpp: Add a comprehensive unit test for all
	  non virtual parts of the BaseWorld class.

2006-12-06  Al Riddoch  <alriddoch@zepler.org>

	Changes submitted by Kai Blin  <kai.blin@gmail.com>

	* data/mason.xml: Grow the gateway so it fits into the castle wall.

	* rulesets/mason/define_world.py: Add the castle peninsula.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Add prefix.o to one test, or it fails to link
	  if binreloc is enabled.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/AtlasFileLoadertest.cpp, tests/AtlasFileLoadertest.h:
	  Add assert header include as required by some compilers.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityExerciser.h: Fill out the functionality to include tests
	  for the virtual functions that convert an entity into Atlas data.

	* tests/BaseEntitytest.cpp: Use the extended EntityExerciser, and
	  cover all the non-virtual functions in BaseEntity.

	* tests/AtlasFileLoadertest.cpp: Add a test for the file loader
	  class.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* client/Makefile.am, tests/Makefile.am: Add top_buildir to includes,
	  to get config.h in an out-of-tree build.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* OperationExerciser.cpp, OperationExerciser.h: Template class to
	  exercise and test custom operation classes.


	* Attacktest.cpp, Burntest.cpp, Choptest.cpp, Connecttest.cpp,
	  Cuttest.cpp, Delvetest.cpp, Digtest.cpp, Droptest.cpp,
	  Eattest.cpp, Monitortest.cpp, Mowtest.cpp, Nourishtest.cpp,
	  Pickuptest.cpp, Setuptest.cpp, Ticktest.cpp, Unseentest.cpp,
	  Updatetest.cpp: Use OperationExerciser on all current custom op
	  classes.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityPropertytest.cpp: Add a complete set of unit tests for
	  EntityProperty.

	* rulesets/EntityProperty.cpp: Fix and instrument the code based
	  on the findings from the unit test.

2006-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityReftest.cpp: Expand the unit tests to completely cover
	  the EntityRef class.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/EntityProperty.cpp, rulesets/EntityProperty.h: Add a
	  property class that handles a weak reference to another entity.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.cpp, common/BaseWorld.h: Add instance method, so
	  code anywhere can get a pointer to the world.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h: Add a first attempt at defining what kind of result
	  should be returned by operation handler functions.

	* rulesets/mason/define_world.py: Add a test function for testing
	  attachments, and the active property mechanism.

2006-12-04  Al Riddoch  <alriddoch@zepler.org>

	* modules/EntityRef.cpp, modules/EntityRef.h: Add a new class to handle
	  a weak reference to an Entity.

	* tests/EntityReftest.cpp: Test the weak reference class.

2006-12-03  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h: Add a function pointer type, and related
	  typedefs for functions which handle an operation.

	* rulesets/Entity.cpp, rulesets/Entity.h: Add a map of operation
	  handlers so that any operation type can be handled by data
	  defined handlers.

	* rulesets/ActivePropertyFactory.cpp, rulesets/ActivePropertyFactory.h,
	  rulesets/ActivePropertyFactory_impl.h: Add a new type of property
	  factory, which installs a handler when the property is added to
	  an entity.

	* server/CorePropertyManager.cpp: Test out the new property factory
	  and handler mechanism with a new property called "attachment".

2006-11-05  Al Riddoch  <alriddoch@zepler.org>

	* tools/Makefile.am: Add the network libraries to cypasswd as they
	  are needed on some platforms for gethostname.

	* tests/Makefile.am: Ensure the tests link correctly.

	* tests/Creatortest.cpp, tests/Charactertest.cpp: Remove test for
	  drunkness property, as it has been removed from the Character
	  entity class.

2006-11-05  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp: Leave out local connection functionality
	  on systems that don't have unix sockets.

2006-11-03  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add check for arpa/inet.h header.

	* server/CommListener.cpp: Include arpa/inet.h if available, for
	  inet_ntop.

	* server/CommUnixListener.cpp: Include common/system.h to get
	  closesocket().

2006-11-03  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add tests for more optional functions and headers.

	* client/ObserverClient.cpp: Use alternative on systems which don't
	  have usleep().

	* common/system.cpp: Implement gettimeofday for systems which don't
	  have it.

	* server/CommListener.cpp: Add a note about supporting alternatives
	  to inet_ntop.

	* server/CommUnixListener.cpp, server/server.cpp: Disable the unix
	  listen socket on systems which don't have it.

	* tests/systemtest.cpp: Fix the test to work on systems without fork()
	  or kill(), and add a test for the substitute gettimeofday
	  implementation.

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp, server/CommPeerListener.cpp,
	  server/CommUnixListener.cpp:
	  Use closesocket to close sockets, so that it works on systems
	  which do not use the same namespace for files and sockets.
	  Use typedefs provided by skstream to ensure platform neutral
	  handling of socket related types. Disable code that stores
	  presentation version of client address on systems which don't
	  have inet_ntop.

	* server/CommServer.cpp: Use skstream to get the right header
	  for select system call, and use skstream typedefs.

	* server/WorldRouter.cpp: Use common/system.h to get getimeofday
	  on systems which don't provide it.

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* common/system.h: Add prototypes for required C library functions
	  we implement on systems where they are missing.

	* common/system.cpp: Adapt the system specific code for systems
	  which are missing libc functions are system calls, including
	  uname, getuid, nice, fork, kill and some of the signals.

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* common/log.h, common/log.cpp: Some systems have defines in their
	  headers which conflict with cyphesis log levels, so make sure they
	  are undefed before the enum, and add more tightly namespaced
	  versions for files which need those headers. Adapt the logging
	  code for systems without syslog() or reentrant localtime().

2006-11-01  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add checks for functions and headers that may or may
	  not exist on more obscure systems. Relax some tests so that they
	  only warn if they fail, as they may not be fatal.

2006-10-29  Al Riddoch  <alriddoch@zepler.org>

	* acinclude.m4: Add AM_PATH_GCRYPT macro so that less errors occur.

2006-10-26  Al Riddoch  <alriddoch@zepler.org>

	* Add RCS Id keywords to every file, for better version tracking.

2006-10-26  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am, server/Makefile.am: Remove a couple of obsolete
	  headers from the build.

2006-10-24  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Clean up output of the two MDNS service discovery
	  libraries, so it is obvious what has happened when the checks fail.

2006-10-24  Al Riddoch  <alriddoch@zepler.org>

	* man/Makefile.am: Add rules to create man pages for every command,
	  which refer to the combined pages for all commands.

	* man/cyaddrules.1, man/cyconvertrules.1, man/cydumprules.1,
	  man/cyloadrules.1, man/cypasswd.1: Generate new pages as described
	  above.

	* man/cycmd.sgml: Fix argument name in cycmd man page.

	* man/cyclient.1, man/cycmd.1, man/cycmd.sgml, man/cyphesis-tools.1,
	  man/cyphesis.1: Re-generate existing man pages.

	* common/PropertyFactory.h, common/PropertyFactory_impl.h: Pass in
	  pointer to the entity when creating a new property using the
	  factory.

	* server/CorePropertyManager.cpp: Make sure the entity pointer is
	  passed to the property factory as required.

2006-10-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Add doc strings to some key methods.

2006-10-21  Al Riddoch  <alriddoch@zepler.org>

	* acinclude.m4: Update pkgconfig macros to more efficient later
	  versions.

	* configure.ac: Use newer pkgconfig macro to check for pkgconfig
	  first.

2006-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Clean out unused keyword handling in debug
	  functions, fix code to comply with style. Ensure debug calls have
	  minimal cost if debugging is disabled.

2006-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Add debug hooks for the python API, to
	  help debug scripts.

2006-10-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Add doc strings to a number of
	  functions.

2006-10-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp: Remove hacky
	  hardcoded drunkness implementation.

	* rulesets/attributes.h, server/Persistor_impl.h, server/Restorer.cpp:
	  Remove persistence hooks for drunkness.

2006-10-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Block attempts at admin operations from the
	  mind interface, and therefore the client.

2006-10-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/dynamic/DynamicGoal.py:
	  Add a doc string to the class.

2006-09-26  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version number.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.10

2006-09-26  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.init: Fix the options for scripts that create postresql
	  accounts and database, so they don't block expecting interaction
	  from the user.

2006-09-24  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add check for poll system call, as it would probably
	  bast to implement poll, making select a worst case fallback
	  option.

2006-09-24  Al Riddoch  <alriddoch@zepler.org>

	* common/log.h, common/log.cpp: Add a new function to rotate
	  the logs, eliminate duplicate code by breaking out log opening
	  code into a static function.

	* common/system.cpp: Add a HUP system call handler to rotate the logs.

2006-09-20  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: When creating a daemon, create the new session
	  earilier, and change current working directory to / to ensure the
	  daemon does not interfere with the system.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add FIXME notes about appear/disappear
	  generating code.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp, server/CommUnixListener.cpp: Clean up
	  the code layout a little.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp, server/CommUnixListener.cpp:
	  Re-write isOpen() to use the is_open method of the overlying
	  socket object, rather than always returning true. This issue may
	  never arise, but it ensures that all socket objects should
	  return isOpen() == false before they return -1 as a socket fd,
	  which prevents memory corruption in the select code.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp: Remove hardcoded value for the
	  maximum path length for a unix socket, and use the size of
	  the data structure member instead. This fixes an issue caused
	  by the behavoir of strncpy on MacOSX.

2006-09-17  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Re-write isOpen so that it checks
	  the socket fd is not -1.

2006-08-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Change the entity_new constructor used
	  by define world scripts so that it takes an optional "pos" argument
	  rather than the long obsolete "xyz".

	* rulesets/mason/define_world.py, rulesets/werewolf/define_world.py:
	  Modify the most relevant define_world scripts to use the changed API.

	* rulesets/basic/mind/goals/common/move.py: Remove a long obsolete
	  commented out debug line.

2006-08-30  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp: Don't include config.h, as this file doesn't
	  use anything from it.

2006-08-24  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version number.

	* NEWS: Update NEWS announcement for release.

	* Release 0.5.9

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp, client/ClientConnection.cpp: Re-work poll()
	  methods in client code that call select(2), so that they don't
	  ignore errors, or get stuck waiting for data that has not yet
	  arrived by doing so.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp, common/op_switch.h:
	  Ensure that unseen operations are passed to the mind.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: When calling select while waiting for user input,
	  don't specify a timeout for select, as no timing is occuring in
	  the program.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Check the return value of select, and only check
	  file descriptors if an error has not occured.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* tests/distancetest.cpp: Add assertions to distance test that
	  ensure correct behavoir.

2006-08-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Quaternion.cpp: Rename valid() method to is_valid()
	  for API consistency.

	* rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py: Update scripts to the changes
	  API.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: In Python Entity constructor, tighten
	  up checks so exceptions are thrown for initialisers of the wrong
	  type. Convert xyz sequence more directly to C++ vector for
	  efficiency.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Object.cpp: Avoid calling python list length
	  function every loop iteration, for efficiency.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_RootEntity.cpp: Add more warnings if strange types
	  are set as attributes.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Object.h, rulesets/Py_Object.cpp: Remove redundant
	  functions from the header, and make them static. Add a flag to
	  conversion function, to specify the function should return
	  early if the result will be a map or a list.

	* rulesets/Py_Mind.cpp: Indicate that converted python objects
	  being used to set attributes should only be converted to non
	  sequence data, to avoid the wasted copy and conversion.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_RootEntity.cpp: Simplify the check for unconvertible
	  values.

2006-08-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Mind.cpp: Put back restriction on map and list
	  attributes on mind, and force them to be handled as native
	  python objects.

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Ensure operation_new return value is set
	  to null if an exception is generated in addToArgs().

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_BBox.cpp, rulesets/Py_Statistics.cpp,
	  rulesets/Python_API.cpp: Replace calls to the cyphesis log
	  system with Python exceptions.

	* rulesets/Py_Mind.cpp: Accept map and list atlas attributes on
	  the mind object.

	* rulesets/Py_Property.cpp: Improve the wording of some log messags.

	* rulesets/Py_RootEntity.cpp: Assert that attributes work correctly.

	* rulesets/Plant.cpp: Add FIXME about an issue with plants eating
	  people.

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Fell.cpp: Exclude from the build, and doxygen.

2006-08-14  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: Only call idlers once every second, and
	  still only when the server is not busy of congested with network
	  traffic.

2006-08-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp: Re-write 
	  findInInventory to recurse into inventory containers.

2006-08-09  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Add a further customisation to the prompt so it
	  shows the type of server being connected to.

	* TODO: Add a note about a possible re-work of the database
	  world persistence model.

2006-08-09  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Customise the prompt so it indicates the
	  name of the server connected to, the username authenticated
	  and the privelege level.

2006-08-08  Al Riddoch  <alriddoch@zepler.org>

	* tests/type_utilstest.cpp: Expand tests to cover lists of
	  vectors and quaternions, and confirm the resultings lists contain
	  objects with the right value.

2006-08-08  Al Riddoch  <alriddoch@zepler.org>

	* client/CharacterClient.cpp: Remove pointless class scope when
	  acessing member variable.

	* tools/cycmd.cpp: Don't wait forever for responses from the
	  server to commands.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp, server/CommClient.cpp: Clarify the
	  error messages about non operation objects on the wire, and
	  use the same messages in the client.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Delete all the property
	  factories on shutdown, to keep the memory usage clean.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Rename some variables to clearer meanings.
	  Only send confirmation of subscription on entity creation if
	  the entity created is a character. Otherwise it is still created,
	  and can be manipulated, but not directly controlled by the
	  client.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Only add initial inventory items if the entity
	  being created is a character. Add some comments.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.h, server/Connection.cpp: Change disconnectObject
	  to removePlayer to make it clearer what the return value means,
	  and return a pointer to the removed object if it is a player account.

	* server/Connection.cpp: When removing an account which has been
	  logged out, remove all its characters which are not currently in
	  use from the connections list.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommSlaveClient.cpp, server/CommSlaveClient.h: Require an
	  ID to be passed into the constructor for a slave connection.

	* server/CommSlaveListener.cpp: Generate an ID for client connections
	  to a slave server, and pass it into the CommSlaveClient constructor.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/slave.cpp: Remove duplicate line added accidentally.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: Remove FIXME and replace with comments
	  explaining the choice of value for epoll_create(). Check if
	  epoll_wait is returning the maximum events possible, so we know
	  if we should enlarge the array.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Report a warning if avahi frees
	  a watch data structure, which is currently not implemented.
	  Move checks on the event type avahi requires to the callback
	  called by avahi, so it is only checked once. Ensure that no
	  events are flagged once the events have been processed.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp: Report socket errors when accepting a
	  new connection.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Admin.cpp: Remove obsolete FIXME.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommClient.cpp: Fully report the parent and objtype of
	  spurious objects received on the network.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Report an error if a logout is received by
	  an account which is not connected.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.h, server/Connection.cpp: Move the code that
	  decouples an object from the subscribed connection into its
	  own function, so the same code is invoked from two different
	  places.

2006-08-07  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: More thoroughly and accuratly report the
	  failure if epoll doesn't work.

2006-08-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Raise.py: Move the check which ensures
	  that task is not attempting to move the world is placed earlier.
	  Add a check that the item being affected is non-zero distance from
	  the character, ensuring the rotation maths don't give weird errors.
	  A recently commited fix to wfmath should ensure that corruption
	  does not occur again, but this check is still a good idea.

2006-08-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Expose wfmath's epsilon as a const value
	  to python.

	* rulesets/Py_Point3D.cpp: Expose isValid() method on WFMath::Point<3>
	  to python.

	* tests/distancetest.cpp: Add test to confirm that distanceTo
	  determines distance to inventory items correctly.

2006-08-03  Al Riddoch  <alriddoch@zepler.org>

	* server/server.cpp: Ensure that that world does not obtain
	  position or orientation when being restored from the database.

2006-08-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Fix the size of the world bbox
	  being set when terrain is defined.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* scripts/compile_python.py: Add a new script which compiles python
	  files.

	* cyphesis.spec.in: Modify spec to compile installed python
	  scripts, and remove original source for runtime performance
	  and compact package size.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile-python: Add a new doxyfile for building separate docs
	  for the python scripts.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* common/Use.h, common/Wield.h, common/Generic.h: Mark unused files
	  as removed from the build.

	* common/Attack.h, common/Burn.h, common/Chop.h, common/Connect.h,
	  common/Cut.h, common/Delve.h, common/Dig.h, common/Drop.h,
	  common/Eat.h, common/Monitor.h, common/Mow.h, common/Nourish.h,
	  common/Pickup.h, common/Setup.h, common/Tick.h, common/Unseen.h,
	  common/Update.h: Add class documentation to all the custom
	  properties.

	* common/DynamicProperty.h, client/ClientPropertyManager.h,
	  server/CorePropertyManager.h, server/PersistantThingFactory.h,
	  server/ScriptFactory.h, server/WorldRouter.cpp: Add documentation
	  to some places where it is missing.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Modify Burn to inherit from Affect, as it is
	  is not a pure action.

2006-08-02  Al Riddoch  <alriddoch@zepler.org>

	* Doxyfile, client/define_world.cpp, client/define_world.h,
	  common/CustomOp.cpp, common/CustomOp.h, common/CustomOp_impl.h,
	  common/Load.h, common/Save.h, common/inheritance_impl.h,
	  common/operations.h, common/refno.h, common/utility.cpp,
	  common/utility.h, rulesets/Combat.h, rulesets/Entity_getLocation.h,
	  rulesets/Fell.h, rulesets/MemMap_methods.h, rulesets/Py_Optime.cpp,
	  rulesets/Py_Optime.h, rulesets/ThingFactory.h,
	  server/CommIdleSocket.h, server/ServerRouting_methods.h,
	  tools/Formatter.cpp, tools/Formatter.h, tools/cydbload.cpp,
	  tools/cyisoload.cpp: Make doxygen skip code that has been removed
	  and is just left in cvs for reference.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: If Look op is from something that can't be
	  found, report an error rather than carrying on.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp, rulesets/World.h, rulesets/mason/define_world.py:
	  Remove the special handling of Set ops in world which prevented
	  setting status below zero from generating a Delete op. Add a test
	  function to define_world which attempts to destroy the world by
	  setting its status to -1.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h, rulesets/Character.h, rulesets/Character.cpp:
	  Add Update to the poll op handlers in the world2mind interface,
	  removing the special case.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* common/op_switch.h: Remove all ops but Create, Delete, Move and
	  Set from the sub op switch used in mind code.

	* rulesets/BaseMind.cpp, rulesets/BaseMind.h: Remove vast virtual
	  perception handling interface as overriding is now handled centrally
	  and base mind only handles 4 sub types of sight.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp, rulesets/Character.h,
	  rulesets/Character.cpp: Remove now empty operation methods.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp, rulesets/Character.cpp, rulesets/Food.cpp,
	  rulesets/Plant.cpp, rulesets/Stackable.cpp, rulesets/Thing.cpp:
	  Remove script override calls from the individual C++ operation
	  methods, as script overrides are now done centrally.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Remove script override calls from the
	  individual C++ operation methods, as script overrides are
	  now done centrally.

2006-08-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add a override of
	  BaseEntities operation() method which handles calling
	  script operation handlers directly, rather than relying
	  on the C++ handlers to check for them later.

	* rulesets/Character.cpp, rulesets/BaseMind.cpp: Check for script
	  operation handlers centrally in Character and BaseMind too.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Use class numbers rather than names to
	  determine operation handler.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp: Move all script overrides so the override
	  and are called before the mind checks to see if the character
	  is awake.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Add script hooks to Wield and Nourish
	  handlers.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Move the script hook for Character
	  to the beginning of the Tick op handler.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Don't call upper_bound in a loop
	  as it is return by value, and expensive to call.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Add script override code to the
	  imaginary and talk operation handlers.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* common/debug.h: Add a macro to print out function name when
	  debugging.

2006-07-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Add checks that operations have the class
	  number expected, so that this section can be converted to work on
	  class numbers.

2006-07-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Moved increment on m_seq to later in the
	  function, to make sure its only incremented when the entity
	  has really been updated. Scripts will be required to update
	  now.

2006-07-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Thing.cpp, rulesets/Thing.h:
	  Move Look and Create handlers into Thing from Entity, so Entity is
	  a more abstract for all IG entities.

2006-07-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.h, rulesets/Thing.cpp, rulesets/Plant.h,
	  rulesets/Plant.cpp: Remove SetupOperation from Thing
	  and implement in Plant, as not all entities need a starting
	  tick, but plants do.

	* rulesets/basic/world/objects/elements/Fire.py,
	  rulesets/mason/world/objects/Weather.py: Add setup_operation
	  handlers as these scripts require ticks.

2006-07-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Remove Appearance from SetupOperation
	  in Character too.

2006-07-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp, server/WorldRouter.cpp: Remove broadcasting
	  an appearance from Setup handlers, and put it WorldRouter when
	  the entity is added to the world, to take out the special case
	  from the Setup operation handler.

2006-07-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add note about updating m_seq in SetOperation
	  Correct function name in an error message.

2006-07-19  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Make coin inherit from stackable.

	* rulesets/Character.cpp, rulesets/Stackable.cpp: Add debug output
	  to new combine op handlers.

2006-07-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Stackable.cpp: Report an error if a divide op has
	  args with the wrong ID.

	* rulesets/Character.h, rulesets/Character.cpp: Add function
	  to check if an entity is in the characters inventory.

	* rulesets/Character.cpp: First pass at implementing filters
	  for combine and divide ops from the client.

2006-07-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Stackable.cpp: Fix some bugs and finish implementing
	  combine and divide on stacked entities.

2006-07-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Use != for logical exclusive or on bools.

	* physics/Collision.cpp: Re-write complete excluseive or
	  implementation and replace with !=.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp, rulesets/MemMap.cpp, rulesets/MemMap.h:
	  Remove commented out lookId code. Re-write findByLocation to
	  require a type as well, and use a more efficient search to find
	  the entities requested.

	* rulesets/Py_Map.cpp: Re-write find_by_location wrapper to handle
	  the extra type argument.

	* rulesets/basic/mind/Memory.py: Re-write recall_place so that
	  type and radius are now required, and make sure all types listed
	  are checked for.

	* rulesets/basic/mind/goals/common/move.py: Check if recall_place
	  has returned anything at all.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/MemMap.h, rulesets/MemMap.cpp: Replace lookId() with
	  sendLooks() which sends a look to all required entities in
	  one batch more efficiently.

	* rulesets/Py_Map.cpp: Remove bindings for Map.look_id, as its not
	  used.

	* rulesets/BaseMind.cpp: Use MemMap.sendLooks() instead of
	  MemMap.lookIds() to look at the world.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Use the flag check to see if TO is set on
	  an operation, rather than checking if TO is empty.

2006-07-11  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h: Remove opEnumerate
	  method as its now a trivila call to another method.

	* rulesets/BaseMind.cpp, rulesets/Character.cpp, rulesets/Creator.cpp:
	  Replace calls to opEnumerate with direct calls to getClassNo().

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Improve test
	  for task classes by checking if the class parent has already been
	  installed as a class.

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* tests/Fell.cpp: Remove obsolete FIXME.

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Implement improved error reporting.
	  Remove related FIXMEs.

2006-07-10  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp: Implement improved error reporting.
	  Remove related FIXMEs.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Re-order checks for increased robustness.
	  Add more error reports.

	* server/CommMDNSPublisher.cpp: Remove a redundant FIXME.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Use class number to check for delete ops.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp, server/WorldRouter.h: Remove now obsolete
	  object list.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.h, server/WorldRouter.cpp: Re-write the way
	  broadcasts are handled, so the code is cleaner, and non
	  perception operations are properlly broadcast without the
	  need to store an explicit list of all entities in the world.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Re-write check for broadcast op types to
	  use numeric class number instead of string parents.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Remove undocumented FIXME.

	* server/WorldRouter.cpp: Move an assert into a better place
	  where it covers more.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Remove obsolete FIXME about feature already
	  implemented.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp, server/WorldRouter.cpp,
	  server/WorldRouter.h: Remove obsolete code to handle omnipresent
	  entities.

	* common/const.h: Remove obsolete flag enabling omnipresent
	  entities.

	* tests/consttest.cpp: Remove test for omnipresent flag.

2006-07-08  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Remove obsolete config option to disable
	  range checks and calculations.

	* client/ObserverClient.cpp, rulesets/Movement.cpp,
	  server/Admin.cpp, tools/AdminClient.h, tools/cycmd.cpp:
	  Remove const.h from files which no longer require it.

	* rulesets/Python_API.cpp: Remove python bindings for obsolete
	  constants.

	* rulesets/Thing.cpp, rulesets/World.cpp, server/WorldRouter.cpp:
	  Remove obsolete rotten code for handling sight without ranges.

	* tests/consttest.cpp: Remove tests for removed constants.

2006-07-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/LineProperty.h: Remove obsolete FIXMEs.

2006-07-07  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Remove FIXME about nice option which has already
	  been implemented.

2006-07-07  Al Riddoch  <alriddoch@zepler.org>

	* common/AtlasFileLoader.cpp, common/AtlasFileLoader.h: Modify
	  the class so that fundamentally it can handle any atlas codec.

2006-07-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Remove debug output.

	* server/CorePropertyManager.cpp: Remove more debug output.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.8

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Add a missing header.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* tests/IGEntityExerciser.h, tests/TestPropertyManager.cpp,
	  tests/TestPropertyManager.h: Add a dummy property manager, and
	  install it before testing any IG entity classes.

	* tests/Areatest.cpp, tests/Charactertest.cpp,
	  tests/Creatortest.cpp, tests/EntityFactorytest.cpp,
	  tests/Entitytest.cpp, tests/Foodtest.cpp, tests/IGEntityExerciser.h,
	  tests/Linetest.cpp, tests/Planttest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Thingtest.cpp, tests/Worldtest.cpp: 
	  Switch to new hasAttr getAttr setAttr method names.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyManager.cpp: When the PropertyManager is deleted,
	  set the instance variable to 0.

	* server/EntityFactory.cpp, server/EntityFactory.h: Add a destructor
	  so the property manager can be deleted at shutdown.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientPropertyManager.cpp, client/ClientPropertyManager.h:
	  Fix formatting and remove obsolete typedefs.

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* client/Py_CreatorClient.cpp, rulesets/Character.cpp,
	  rulesets/Entity.cpp, rulesets/Entity.h, rulesets/Food.cpp,
	  rulesets/Pedestrian.cpp, rulesets/Plant.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_Thing.cpp, rulesets/Thing.cpp, server/WorldRouter.cpp:
	  Rename Entity members get(), set() and has() to getAttr(), setAttr()
	  and hasAttr().

2006-07-03  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientPropertyManager.cpp, client/ClientPropertyManager.h:
	  A new class as a dummy property manager for the client side.
	  Never creates property objects.

	* client/client.cpp: Instantiate the client property manager
	  during client initialisation.

	* server/EntityFactory.cpp: Instatiate the server property manager
	  during server intialisation.

	* common/PropertyManager.h: Add the singletons accessor, and
	  make the addProperty member return a pointer to the property.

	* server/CorePropertyManager.h, server/CorePropertyManager.cpp:
	  Implement creating properties for server side entity objects.

	* rulesets/Entity.cpp: Use the property manager singleton to
	  create properties if a new attribute is set which is not already
	  a property, and its also not already a soft attribute.

2006-06-30  Al Riddoch  <alriddoch@zepler.org>

	* FIXME, Makefile.am: Add new FIXME file which documents FIXMEs in
	  the code.

	* server/EntityFactory.cpp: Remove the terrain feature classes
	  implemented as hard coded classes.

	* data/basic.xml: Add the terrain feature classes as soft data
	  defined classes.

2006-06-29  Al Riddoch  <alriddoch@zepler.org>

	* server/CorePropertyManager.cpp: Add properties for START_INTERSECTIONS
	  and END_INTERSECTIONS.

2006-06-29  Al Riddoch  <alriddoch@zepler.org>

	* common/DynamicProperty.h, common/DynamicProperty_impl.h:
	  Add a second dynamic property template which can wrap any
	  property class, not just instances of Property<>.

	* server/CorePropertyManager.cpp: Install a property factory for
	  COORDS, to handle the coordinates in a line.

	* common/DynamicProperty.cpp, common/PropertyFactory.cpp: Remove
	  unnecessary template instanciations.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, server/Account.cpp, server/Admin.cpp,
	  server/Connection.cpp, server/EntityFactory.h,
	  server/Persistor_impl.h, tools/cycmd.cpp: 
	  Switch from using deprecated sigc++ 1.2 headers to the right
	  sigc++ 2.0 equivalents.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* common/DynamicProperty.cpp, common/DynamicProperty.h,
	  common/DynamicProperty_impl.h: New property class for handling
	  properties or attributes added on the fly which need to store the
	  value.

	* common/PropertyFactory.cpp, common/PropertyFactory_impl.h,
	  server/CorePropertyManager.cpp: Use DynamicProperty in the
	  property factories for properties created on the fly.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add check for recent gcc versions, and turn of
	  strict aliasing on versions which have trouble with python
	  pointer casting.

	* common/PropertyFactory_impl.h, server/CorePropertyManager.cpp:
	  Return safe values from function stubs to get rid of compiler
	  warnings.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am: Add missing reference to header file.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* common/PropertyFactory.cpp, common/PropertyFactory.h,
	  common/PropertyFactory_impl.h, common/PropertyManager.cpp,
	  common/PropertyManager.h: Add new classes to automate the
	  creation of property objects for known property types.

	* server/CorePropertyManager.cpp, server/CorePropertyManager.h:
	  Manager object that will coordinate creating properties
	  when they are added to entities.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Bisect.py: Starting point for task
	  for cutting chunks of material in half.

2006-06-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slice.py: Clean out some unused code.

2006-06-21  Al Riddoch  <alriddoch@zepler.org>

	* common/debug.h, common/debug.cpp: Add interface template for a
	  function which dumps a representation of a type to stdout, and
	  add a specialisation for dumping Atlas message data.

2006-06-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slice.py: Fix shape of boards, and add
	  appropriate position offset.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Slice.py: The basics of cutting lumber
	  into boards is now working.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Task.cpp: Add "progress" and "rate" to Task.getattr
	  for python.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Task.cpp: Allow progress to be set as an integer from
	  a task script.

	* data/mason.xml, rulesets/mason/world/tasks/Slice.py: Add a new
	  slice task for sawing logs into boards.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Fix some issues
	  with code that assumed op.from and op.to where entities rather
	  than entity IDs.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Don't forward ops to the mind blindly if
	  we don't know what they are.

2006-06-20  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add classes for raw building materials.

2006-06-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Re-write comments about sending ops from
	  mind to world.

2006-06-08  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Add a message to the crash handlers giving
	  an email address to report bugs to.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp: Ensure collision prediction returns move_tick
	  when a collision is not predicted. Remove pointless assignments.
	  Clarify error message.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, rulesets/Character.cpp, rulesets/Creator.cpp,
	  server/Account.cpp, server/Admin.cpp, server/Connection.cpp,
	  server/Lobby.cpp, server/WorldRouter.cpp: Don't bother with serial
	  numbers on ops generated inside the server. They just leak and upset
	  clients.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Creator.cpp, common/BaseEntity.cpp:
	  Catch the last few places, and ensure refno is only set if
	  serialno is set on the causing op.

2006-06-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add a function to handle
	  all the changes required when the LOC or container of an entity
	  changes.

	* rulesets/Motion.cpp, rulesets/Thing.cpp: Use changeContainer()
	  rather than repeating the code in three places.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Add some assert checks when altering the
	  container of an entity.

	* rulesets/Motion.cpp: Fix the code in collision resolution that
	  handler container changes so it does reference counting,
	  inserting and removing from contains lists, and flagging entity
	  changes.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac, NEWS: Increment version for forthcoming release.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Don't add a settler to the deer
	  test scanario, as its not required.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* tests/Makefile.am: Update the linked modules for the tests so that
	  they build against the new movement code.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/move.py: Make deer run further
	  when they are scared, thus making their movement smoother.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Clear out movement debug output.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.h: Add method to check if a target position has
	  been specified.

	* rulesets/Character.cpp: Don't return a tick for movement if no
	  target is specified, as the old movement object has no further
	  role to play.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Re-work the movement code so it never relies
	  on external serial numbers, but will use internal op serialnos
	  if they are available, or use its own refnos if not.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp, server/CommClient.cpp, server/Account.cpp:
	  Only set refnos on ops if the client has set a serial number.

	* rulesets/Character.cpp: Simplify handling the transfer of
	  operations from client to in-game. Don't give new operations
	  serial numbers at this point.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Only set the refno on an op if the original
	  had a serilno. Don't bother setting serialno on internal ops.

2006-06-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp, rulesets/Motion.h: Add method and storage
	  to note what the reference number of the next update op should
	  be.

	* rulesets/Thing.cpp: Note the current serialno as the refno of the
	  expected update op, and ignore all others obsolete update ops.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp, rulesets/Thing.cpp: Disable debug flags.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.h, rulesets/Movement.cpp, rulesets/Pedestrian.cpp:
	  Remove old obsolete collision code.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h: Rename to clearCollision() to adhere to
	  convention.

	* rulesets/Motion.cpp: Implicitly clear a pending collision whenever
	  one is resolved.

	* rulesets/Thing.cpp: Cut in the new collision resolution code.

2006-06-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.cpp, rulesets/Motion.h: Initial implementation of
	  collision resolution code.

2006-06-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h: Add method to clear the collision flag.

	* rulesets/Thing.cpp: Clear the collision flag once it has been
	  handled, and improve code harmonisation between MoveOp and
	  UpdateOp handlers.

2006-06-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Plant.cpp: Fix nourish handler to check for a script
	  handler first.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Pedestrian.cpp: Disable old collision detection code.

	* rulesets/Thing.cpp: First working version of entity based collision
	  code.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Add op to notify client when account object
	  is modified.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h, rulesets/Motion.cpp: Add flag and time to sore
	  info about collisions.

	* rulesets/Thing.cpp: Rambling messy code to detect and act on
	  predicted collisions.

2006-06-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Motion.h, rulesets/Motion.cpp: Add method to check for
	  collisions.

	* rulesets/Thing.cpp: Use Motion::checkCollisions to output debug
	  data about collisions.

2006-05-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Implement basic movement updates.

	* rulesets/Pedestrian.cpp: Disable updatePos as it is no longer
	  required.

	* TODO: Add notes on further refactoring of movement code.

2006-05-31  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Add new constant for period between movement updates.

	* rulesets/Pedestrian.cpp: Don't update entity movement timestamp
	  here.

	* rulesets/Thing.cpp: Add comments about movement code. Update
	  movement timestamp when move op is handled. Use movement update
	  interval for update ops.

2006-05-30  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Add Update operation type to those registered
	  with Atlas.

2006-05-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.h, rulesets/Thing.cpp: Create a function to hold
	  visibility checking code, and remove it from MoveOperation, calling
	  the function instead.

2006-05-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/TaskScript.h: Add accessor for the script object associated
	  with a task.

	* rulesets/Py_Task.cpp: Add a function to wrap a task which uses the
	  tasks existing python object if it has one.

2006-05-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Add function to test matrixing
	  deer.

2006-05-23  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Remove debug output.

2006-05-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonMindScript.cpp: Report an error if one occurs
	  running a hook function in a script.

	* rulesets/Statistics.cpp: Remove an obsolete FIXME.

2006-05-18  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h, rulesets/Creator.cpp, rulesets/World.cpp,
	  server/WorldRouter.cpp, server/WorldRouter.h, tests/TestWorld.h:
	  Pass perceptive entities to the world by pointer rather than
	  by ID, avoiding a lookup in the dictionary.

2006-05-16  Al Riddoch  <alriddoch@zepler.org>

	* server/ExternalMind.cpp: Don't remove object from connection
	  as it may be required again, and it will be removed anyway if the
	  entity is destroyed.

2006-05-16  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Don't remove characters from the connection
	  when they are logged out.

2006-05-16  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Fix the wrong dynamic cast.

2006-05-16  Al Riddoch  <alriddoch@zepler.org>

	* server/Connection.cpp: Slightly simplify the code that handles
	  subscribing character entities to a connection.

2006-05-16  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Return 0 on security check fail, as -1 is
	  signed.

	* server/Connection.cpp: Re-order logging messages so that messages
	  reflect the fact the a broken connection occurs before the
	  subscriptions associated with that connection can be dropped.
	  Implement logging out just specific objects without closing the
	  connection.

2006-05-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp: Send an unseen op if admin attempts to
	  puppet something that does not exist. Add some comments and
	  a FIXME.

	* TODO: Add a note about the lack of crossover between ops used
	  by OOG code and IG code.

2006-05-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Be more severe about error messages if
	  client sends an action op. Remove obsolete comments.
	  Warn if client sends a Set op. Don't accept look ops with
	  an arg containing no ID - nothing sends this, and nothing should.

	* rulesets/Thing.cpp: Add an error report if an explicit Action op
	  is received by an entity.

2006-05-12  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Add mode "relative" to be specified only
	  on new entities that indicates that the entity's height is specified
	  relative to the terrain surface.

	* rulesets/mason/define_world.py: Specify the stockade stakes
	  are all embedded 1 metre into the ground, and increase the base
	  height by 2 metres to make the stockade look more convincing.

2006-05-12  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp, common/system.h: Add a parameter specifying
	  the extent of the change when reducing priority.

	* server/server.cpp: Add option to control the increased nice level
	  the server runs at.

2006-05-10  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am, tools/Makefile.am: Switch static libraries over
	  to linking avahi so static builds and auto packages can be made
	  on Fedora Core 5.

2006-05-10  Al Riddoch  <alriddoch@zepler.org>

	* common/Property.h, common/Property_impl.h,
	  rulesets/AreaProperty.cpp, rulesets/AreaProperty.h,
	  rulesets/CalendarProperty.cpp, rulesets/CalendarProperty.h,
	  rulesets/Entity.cpp, rulesets/EntityProperties.cpp,
	  rulesets/LineProperty.cpp, rulesets/LineProperty.h,
	  rulesets/Py_Thing.cpp, rulesets/StatisticsProperty.cpp,
	  rulesets/StatisticsProperty.h, rulesets/TerrainProperty.cpp,
	  rulesets/TerrainProperty.h: Change return value of Property::get
	  to bool, and use it to indicate if the property has a value.

2006-05-10  Al Riddoch  <alriddoch@zepler.org>

	* server/PersistantThingFactory.h: Improve comments.

	* data/mason.xml: Add maximum and minimum values example for the mass
	  of a pig.

	* common/Type.h: Add empty interface class which will be padded out
	  to be the interface used by instances to query their class.

2006-05-09  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.7

2006-05-09  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Remove hard dependency on howl-devel, as this
	  is replaced by a soft dependency on avahi-devel on modern systems.

2006-05-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Task.cpp: Missing missing return when an error is
	  detected.

	* rulesets/Python_API.cpp: Remove obsolete Vector3D and Point3D
	  constructors and method tables, now replaced by init method
	  implementations.

	* server/EntityFactory.cpp: Comment out as yet unused code for
	  updating a task factory from an admin client.

2006-05-09  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add a base class "mobile" from which all entities
	  that are actors in game systems should inherit as it sets up the
	  default statistics.

2006-05-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_BBox.cpp: Add method exposing boxSquareBoundingRadius
	  to python.

	* rulesets/Task.cpp, rulesets/Task.h: Add method to generate the
	  next tick for this task, using a given interval. Fix setting
	  progress and rate, so both can be zero.

	* rulesets/Py_Task.cpp: Expose nextTick() method to python.
	  Allow rate to be set as an integer from python, so it can be zero.

	* rulesets/mason/world/tasks/Combat.py: Use next_tick() for all
	  tick ops.

	* rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Sharpen.py: Add range checks, and use
	  next_tick() to simplify tick op generation.

2006-05-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Combat.py: Implement check which
	  ensures fighting characters are close together.

2006-05-07  Al Riddoch  <alriddoch@zepler.org>

	* common/newid.cpp: Add assert.h as required by some compilers.

2006-05-07  Al Riddoch  <alriddoch@zepler.org>

	* common/accountbase.cpp, server/Admin.cpp, server/Persistance.cpp,
	  server/server.cpp, server/slave.cpp: Add more checks to ensure
	  that not getting an ID from the database always fails cleanly.

2006-05-06  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp, common/newid.cpp, server/server.cpp:
	  Modify new ID checks so that code still runs when database is
	  unavailable, and events requiring new IDs fail cleanly.

	* server/Connection.cpp: Report a failure to create a player
	  account if no ID available.

	* rulesets/BaseMind.cpp: When processing appearance ops, handle
	  stamp more efficiently, report an error if ID is missing
	  from argument.

	* server/IdlePSQLConnector.cpp, server/IdlePSQLConnector.h:
	  Implement re-connecting to the Database if connection is lost.

	* rulesets/Character.cpp, rulesets/Entity.cpp, rulesets/Thing.cpp:
	  Ensure STAMP is present on appearance op args.

	* server/CommListener.cpp, server/CommListener.h,
	  server/CommPeerListener.cpp, server/CommPeerListener.h,
	  server/CommSlaveListener.cpp, server/CommSlaveListener.h,
	  server/CommUnixListener.cpp, server/CommUnixListener.h:
	  Add a return value to method for creating new client socket
	  objects, and use it to return failure if no ID is available
	  from the database for a new object.

	* rulesets/Py_Point3D.cpp, rulesets/Py_Vector3D.cpp,
	  rulesets/Python_API.cpp: Add "new" method for class wrappers, and
	  call the in place constructor from new rather than init. Re-write
	  internal function for creating new instances so it uses the "new"
	  method.

	* rulesets/Py_Statistics.cpp: Remove some obsolete code inadvertedly
	  copied from another file. Comment out some unused code to get rid
	  of a warning.

	* server/CommPSQLSocket.cpp: Clear the database connection from
	  destructor.

	* tests/python_class.cpp: A new test for experimenting with new
	  Python wrappers.

2006-05-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Point3D.cpp, rulesets/Py_Vector3D.cpp,
	  rulesets/Python_API.cpp: Extend the type object for python
	  Vector3D and Point3D to the format used by more recent python
	  versions, adding init methods as well as flags, and doc string.

2006-05-02  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp, common/system.h: Add a function to increment nice
	  value for the server. Change security check to return unsigned, as
	  the magic number is in fact unsigned.

	* server/server.cpp: Call system function to increment nice, thus
	  reducing priority once setup is complete.

2006-05-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Combat.py,
	  rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Sharpen.py: Remove debug output from
	  task scripts.

2006-05-02  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Oak bounding box update.

2006-04-30  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add the last 3 remaining castle components.

2006-04-30  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Double the bounding box height of the oak to
	  match new client scale factor.

2006-04-30  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove some debug output.

2006-04-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Sharpen.py: Add task instrumentation
	  to the Sharpen task.

2006-04-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Task.cpp: Fix the name of the
	  TASKS attribute.

	* rulesets/mason/world/tasks/Logging.py: Make the logging task
	  progress in the right direction.

2006-04-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Set ID on the argument of set ops
	  used to handle tasks. Remove debug output.

2006-04-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Task.cpp, rulesets/Task.h: Add two members to task,
	  progress and rate which handle the progress towards completion,
	  and the rate at which it is changing. Add a member function which
	  adds an atlas representation of the task as an attribute to an
	  Atlas entity.

	* rulesets/Py_Task.cpp: Expose progress and rate attributes allowing
	  them to be set.

	* server/TaskFactory.cpp: Set the name of a task when it is created
	  by its factory.

	* rulesets/mason/world/tasks/Logging.py: Set the progress and rate
	  of the logging task as it progresses.

	* rulesets/Character.h, rulesets/Character.cpp: Add updateTask()
	  method to be called when task ticks. Make initTask, updateTask
	  and clearTask emit Set operations which set the TASK attribute
	  on the character to reflect the current status of the task.

2006-04-28  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Clear out all the factories on shutdown,
	  not just the entity factories.

2006-04-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Set the bounding box of the world
	  entity to the encompassing volume of all the terrain points. This
	  ensures changes to the terrain are broadcast as required.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/terrain.py: Add client script to allow easy
	  setup of some basic terrain types.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add new server rules for some parts of a castle.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Task.h: Add a name member to the task class.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Ram.py: Use two move ops to give the
	  entity being hammered a short burst of velocity, so it being
	  hammered in is visible.

	* rulesets/Character.cpp: Don't process task tick ops if they have
	  no serial number.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Sharpen.py: Add serial numbers to
	  tick ups.

	* rulesets/mason/world/tasks/Combat.py: Fix the attacker initiative
	  and detect if combat is obsolete if a character has been defeated.

	* rulesets/Task.h: Add an accessor to return an incremented serial
	  number for a new tick op.

	* rulesets/Py_Task.cpp: Add python wrapper for new tick accessor.

	* rulesets/Character.cpp: Add debug output to code enforcing
	  old task ticks.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Added leaf and loaf. Fixed hat bbox.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Re-write the way combat is initialised
	  so each participant owns its own combat task object.

	* rulesets/mason/world/tasks/Combat.py: Re-implement the example
	  combat system so it works with one instance per character instead
	  of one per battle.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Py_Operation.cpp,
	  rulesets/Python_API.cpp: Remove last remaining remnants of
	  code using SUB_TO.

2006-04-27  Al Riddoch  <alriddoch@zepler.org>

	* tests/Tasktest.cpp: Tighten up tests for the sample task.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: When the client sends a Use op with
	  no args, stop the current task. A mechanism for testing the
	  task for interruptibility is still required, so characters can't
	  escape too easily from combat.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add flower, hat, knife, longtable and statue.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add boots and bowl.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add a cow to the world.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Switch to using Create to install types rather
	  than the obsolete Set.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Stop using SUB_TO for tick and setup ops to
	  subsystems, and use argument.NAME instead to indicate the subsystem
	  to be compatible with movement ticks.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Simplify check tick ops for subsystem.

	* rulesets/Combat.h, rulesets/Fell.h: Remove obsolete hard coded
	  tasks from the build.

	* tests/Tasktest.cpp, tests/Fell.cpp, tests/Fell.h: Move old Fell
	  class into tests, and use it to verify tasks operate correctly.

2006-04-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Task.cpp, rulesets/Task.h,
	  rulesets/TaskScript.cpp: Re-work tick ops to tasks so they use
	  argument, not sub_to to get routed to the task. Do the groundwork
	  for having a serial number for each op, which resets to zero when
	  a new task is started.

	* rulesets/mason/world/tasks/Combat.py,
	  rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Ram.py,
	  rulesets/mason/world/tasks/Sharpen.py: Modify all current tasks
	  to set their arg as required.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Remove some debug output.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment server version for release soon.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* tests/TestWorld.h: Add changes to the world interface to the world
	  test framework.

	* tests/EntityFactorytest.cpp: Update EntityFactory tests for changes
	  in the API.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: When entity creation cannot get a new ID,
	  fail cleanly.

	* server/Idle.h: Clean up header, and correct copyright date.

	* server/CommPSQLSocket.cpp: Implement eof() method to check the
	  connection is still okay.

	* server/CommPSQLSocket.cpp, server/IdlePSQLConnector.cpp,
	  server/IdlePSQLConnector.h: Add class stub which will try and
	  re-establish connection to the RDBMS once lost.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/test_python_api.py: More tests of the Python API
	  for Atlas Operations.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* server/Admin.cpp, server/EntityFactory.cpp, server/EntityFactory.h:
	  Change function args to take class descriptions for modification
	  as an Object not a Message. Makes it easier to defermine when
	  op definitions should be processed.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* server/Admin.cpp: Allow client to update op definition, passing
	  it to EntityFactory, just like other types.

	* server/EntityFactory.h, server/EntityFactory.cpp: Add method to
	  handle updating op definitions. Catch a bug which might cause
	  a crash if the client updates a core C++ hard coded entity type.

2006-04-25  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Make the
	  activation map a multimap, and search through it to find a match
	  for the target entity.

2006-04-24  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h, rulesets/Character.cpp,
	  server/EntityFactory.cpp, server/EntityFactory.h,
	  server/TaskFactory.h, server/WorldRouter.cpp,
	  server/WorldRouter.h: Specify the target base type that a given
	  task is valid for, and provide target type when activating a task.

	* data/mason.xml: Add target base types to most task rules.

	* rulesets/mason/world/tasks/Combat.py: Fix the copyright date.

	* rulesets/mason/world/tasks/Sharpen.py: Proof of concept task
	  for turning logs into stakes.

2006-04-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Ram.py: Implement hammering things into
	  the ground.

	* rulesets/mason/define_world.py: Use stakes instead of logs for the
	  stockade.

	* rulesets/TaskScript.cpp: Don't send a tick to the task if its
	  initialisation has failed, indicated by it being flagged as
	  obsolete.

2006-04-24  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add new type for "stake", a sharpened version of
	  lumber.

2006-04-24  Al Riddoch  <alriddoch@zepler.org>

	* tools/AdminClient.cpp: Fix a typo which meant admin clients did
	  not report server error message strings.

2006-04-24  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Add a "task" base class to the inheritance tree.

	* server/EntityFactory.h, server/EntityFactory.cpp: Add
	  functionality to allow task rules to be installed and updated from
	  an admin client. Improve the error reporting for a number of error
	  conditions.

	* server/Connection.cpp: Correct the copyright dates.

	* server/Admin.cpp: Improve error reporting for a number of error
	  conditions. Remove obsolete commented out code for installing
	  rules using Set ops, and add error notification when the
	  admin client attempts to update an op definition. Allow the
	  admin client to install an op definition.

2006-04-24  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Add a tool, operation and class for hammering
	  wooden stakes into the ground.

	* rulesets/mason/world/tasks/Ram.py: Add stub task script for
	  hammering things into the ground.

2006-04-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Raise.py: Fix multiplication order
	  of quaternions, which ensures that rotation is world relative.

2006-04-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/TaskScript.cpp: Add default tick operation to bootstrap
	  tasks to all task scripts in the C++.

	* rulesets/mason/world/tasks/Logging.py,
	  rulesets/mason/world/tasks/Raise.py,
	  rulesets/mason/world/tasks/Combat.py: Remove bootstrap tick op
	  now handled by the C++ base class. Simplify making Combat
	  irrelevant, as it no longer needs special handling. Add doc
	  strings to Combat.

2006-04-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Raise.py: Check if the entity being
	  levered has a parent. If not, we cannot move it.

2006-04-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/test_python_api.py: Add test script to exercise
	  the server's Python API.

2006-04-21  Al Riddoch  <alriddoch@zepler.org>

	* client/client.cpp: Remove some debug output.

2006-04-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Improve the quaternion constructor
	  so it can build one from an axis and an angle of rotation.

	* rulesets/Py_Quaternion.cpp: Add support for multiplying quaternions
	  together.

	* data/mason.xml: Add rules for a pole tool, together with
	  operations and tasks associated with the pole.

	* rulesets/mason/world/tasks/Raise.py: Add a task used with the
	  pole to lever items into different orientations. When used on an
	  entity, the entity is oriented away from the users current
	  position, rotating around a horizontal axis.

2006-04-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Vector3D.cpp: Fix incorrect METH_VARARGS function type
	  of the three rotateN methods, as it should have been converted to
	  METH_O. Add a new rotate method used to rotate a vector using a
	  quaternion.

	* rulesets/Py_Quaternion.cpp: Add a method to check the validity of
	  the quaternion, and a type method to create a string representation
	  of the quaternion.

	* rulesets/Character.cpp: Remove commented out legacy hard coded
	  combat task setup. Now all tasks are scripts.

	* rulesets/mason/world/tasks/Logging.py: Break logging down into
	  something that happens over many ticks, using the orientation of
	  the tree to determine if its felled yet.

2006-04-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Logging.py: A test logging task.
	  Currently does nothing.

2006-04-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Randomise the palissade logs a bit.

2006-04-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: When tick ops are passed to mind, check
	  that SUB_TO=="mind" so that task ticks don't get treated as mind
	  ticks.

	* rulesets/mason/world/tasks/Combat.py: Clean up logic for checking
	  attacker stamina on initialisation.

2006-04-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Combat.py: Re-work the way combat works
	  so all involved entities do their own tick ops, rather than the
	  whole thing being coordinated by only one entity. This simplifies
	  removing the task once obsolete.

	* rulesets/Py_Thing.cpp: Add get_task() on Character so task is
	  available to scripts.

	* rulesets/Py_Oplist.cpp: Allow an oplist to be appended to an
	  oplist as well as being added.

	* rulesets/Character.h: Add an accessor for task.

	* rulesets/Character.cpp: Ensure a task is cleared if it does not
	  get initialised.

2006-04-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Improve error logging in task setup.

	* rulesets/Task.h, rulesets/Py_Task.cpp: Add an accessor for the
	  refcount of a task, and expose it to the script interface.

	* rulesets/mason/world/tasks/Combat.py: Add a check that there are
	  still at least two participants in combat, or end the task.

2006-04-05  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h, server/WorldRouter.h, server/WorldRouter.cpp:
	  Add interface to allow world entities to activate tasks based on
	  tool use operations.

	* server/EntityFactory.h, server/EntityFactory.cpp: Add method which
	  createa a new task in response to an activation request.

	* rulesets/Character.cpp: When a character uses a tool, use the
	  tool type and operation to activate a task if one is available.

2006-04-04  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h: Add dictionary for storing task
	  factories by the tools and operations that activate them.

2006-04-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Further cleanups of mind Use op handler,
	  and improvements to error messages.

2006-04-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp: Add stub of Use op
	  handler on character. Re-write the mind Use op handler to be
	  cleaner, faster and easier to understand.

2006-04-02  Al Riddoch  <alriddoch@zepler.org>

	* common/system.h: Fix name for second argument of hash_password().

	* data/mason.xml: Add example task specification for a logging task.

2006-03-25  Al Riddoch  <alriddoch@zepler.org>

	* common/system.h, common/system.cpp: Add security check function
	  which for now just ensures cyphesis is not run as root.

	* server/server.cpp: Use security check function when starting
	  the server.

2006-03-25  Al Riddoch  <alriddoch@zepler.org>

	* server/CommListener.cpp: Add comments about socket setup.

2006-02-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Thing.cpp: Add a signal to be emitted
	  when an entities container changes, and emit it during
	  MoveOperation processing.

	* rulesets/Character.h, rulesets/Character.cpp: Hook up to the
	  containered signal of a wielded entity, and unwield it when its
	  container changes.

2006-02-18  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.h, common/BaseWorld.h, common/Property.h,
	  modules/Location.h, rulesets/Entity.cpp, rulesets/Entity.h,
	  server/Account.cpp, server/Account.h, server/Admin.cpp,
	  server/Admin.h, server/Connection.cpp, server/Connection.h,
	  server/Persistor.cpp, server/Persistor.h, server/Persistor_impl.h,
	  tools/cycmd.cpp: Update usage of sigc++ to the native 2.0 API
	  rather than the deprecated compatability API. Eleminate the
	  manual disconnection code for deleted objects, as this is now
	  handled automatically by sigc::trackable.

2006-02-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Clean up defend
	  goal so it works with new spot_something.

	* rulesets/mason/define_world.py: Add goblins.

2006-02-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Remove commented out code. Make use of the
	  fact that CONTAINS is directly supported by RootEntity to
	  make handling it much more efficient.

2006-02-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/World.cpp: Re-write look handling to use existing
	  addToEntity() to create an atlas representation of the entity
	  rather than doing most by hand. This ensures that properties
	  and attributes now work on the world.

	* rulesets/Entity.cpp: Ensure that the best use is made of static
	  attributes on RootEntity.

2006-02-07  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Minor update to autoconf syntax.

2006-02-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: When a character picks something up, wield it
	  by default.

2006-01-26  Al Riddoch  <alriddoch@zepler.org>

	* data/basic.xml: Add "collapse" action op to trigger a defeated
	  animation.

	* rulesets/mason/world/tasks/Combat.py: Prevent characters from
	  attacking characters that are exhausted. Send a sight of
	  collapse operation when combat finishes.

2006-01-26  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp, server/Admin.cpp: Improve error messages
	  when client use Set ops incorrectly.

2006-01-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Fix the FROM of pickup and drop operations to
	  be the actor, not the actee.

2006-01-22  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.6

2006-01-21  Al Riddoch  <alriddoch@zepler.org>

	* client/Py_CreatorClient.cpp, rulesets/Py_Map.cpp,
	  rulesets/Py_Operation.cpp, rulesets/Py_Oplist.cpp,
	  rulesets/Py_Point3D.cpp, rulesets/Py_Vector3D.cpp,
	  rulesets/Py_WorldTime.cpp, rulesets/Python_API.cpp:
	  Convert functions that take a single argument to use METH_O
	  and avoid calling PyArg_ParseTuple.

	* rulesets/Py_Point3D.cpp, rulesets/Py_Vector3D.cpp,
	  rulesets/basic/mind/goals/common/move.py: Rename
	  unit_vector_to_another_vector to unit_vector_to.

2006-01-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_World.cpp: Experiment to try METH_O with calls which
	  take an argument of string type.

2006-01-21  Al Riddoch  <alriddoch@zepler.org>

	* client/Py_CreatorClient.cpp: Switch CreatorClient.as_entity() to
	  using METH_NOARGS flag, as it takes no arguments.

	* rulesets/Py_Thing.cpp: Use METH_O for methods which take only
	  one argument, avoiding the call to PyArg_ParseTuple().

2006-01-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Allow FROM to be set on operations in
	  the constructor so that attac ops from combat work better.

2006-01-20  Al Riddoch  <alriddoch@zepler.org>

	* common/Pickup.h, common/Drop.h, common/custom.cpp,
	  common/operations.cpp, common/types.h: Add and install two new
	  op types for Pickup and Drop.

	* rulesets/Thing.cpp: Send sights of Pickup and Drop when characters
	  perform this actions implicitly with move ops.

2006-01-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp: Detect if something is being picked up or
	  dropped.

2006-01-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Combat.py: Fix a bug which would cause
	  the script to stall if one combatant gets picked up by the other.

2006-01-19  Al Riddoch  <alriddoch@zepler.org>

	* aiclient/ClientAccount.cpp, aiclient/ClientAccount.h,
	  aiclient/ClientConnection.cpp, aiclient/ClientConnection.h,
	  aiclient/client.cpp, aiclient/client.h, client/BaseClient.cpp,
	  client/BaseClient.h, client/CharacterClient.cpp,
	  client/CharacterClient.h, client/ClientConnection.cpp,
	  client/ClientConnection.h, client/CreatorClient.cpp,
	  client/CreatorClient.h, client/ObserverClient.cpp,
	  client/ObserverClient.h, client/Py_CreatorClient.cpp,
	  client/Py_CreatorClient.h, client/client.cpp,
	  client/define_world.cpp, client/define_world.h, common/Add.h,
	  common/Affect.h, common/AtlasFileLoader.cpp,
	  common/AtlasFileLoader.h, common/Attack.h, common/BaseEntity.cpp,
	  common/BaseEntity.h, common/BaseWorld.cpp, common/BaseWorld.h,
	  common/Burn.h, common/Chop.h, common/Connect.h, common/CustomOp.cpp,
	  common/CustomOp.h, common/CustomOp_impl.h, common/Cut.h,
	  common/Database.cpp, common/Database.h, common/Delve.h, common/Dig.h,
	  common/Eat.h, common/FormattedXMLWriter.cpp,
	  common/FormattedXMLWriter.h, common/Generic.h, common/Load.h,
	  common/Monitor.h, common/Mow.h, common/Nourish.h,
	  common/OOGThing.cpp, common/OOGThing.h, common/Property.cpp,
	  common/Property.h, common/Property_impl.h, common/Save.h,
	  common/Setup.h, common/Tick.h, common/Unseen.h, common/Update.h,
	  common/Use.h, common/Wield.h, common/accountbase.cpp,
	  common/accountbase.h, common/const.cpp, common/const.h,
	  common/custom.cpp, common/debug.h, common/globals.cpp,
	  common/globals.h, common/id.cpp, common/id.h, common/inheritance.cpp,
	  common/inheritance.h, common/inheritance_impl.h, common/log.cpp,
	  common/log.h, common/newid.cpp, common/nls.h, common/op_switch.h,
	  common/operations.cpp, common/operations.h, common/random.h,
	  common/refno.h, common/serialno.cpp, common/serialno.h,
	  common/system.cpp, common/system.h, common/terrain_utils.cpp,
	  common/terrain_utils.h, common/type_utils.h, common/types.h,
	  common/utility.cpp, common/utility.h, modules/DateTime.cpp,
	  modules/DateTime.h, modules/Location.cpp, modules/Location.h,
	  modules/WorldTime.cpp, modules/WorldTime.h, physics/BBox.cpp,
	  physics/BBox.h, physics/Collision.cpp, physics/Collision.h,
	  physics/Quaternion.cpp, physics/Quaternion.h, physics/Vector3D.cpp,
	  physics/Vector3D.h, physics/VectorPol.h, rulesets/Area.cpp,
	  rulesets/Area.h, rulesets/AreaProperty.cpp, rulesets/AreaProperty.h,
	  rulesets/ArithmeticScript.cpp, rulesets/ArithmeticScript.h,
	  rulesets/BaseMind.cpp, rulesets/BaseMind.h,
	  rulesets/CalendarProperty.cpp, rulesets/CalendarProperty.h,
	  rulesets/Character.cpp, rulesets/Character.h, rulesets/Combat.cpp,
	  rulesets/Combat.h, rulesets/Container.cpp, rulesets/Container.h,
	  rulesets/Creator.cpp, rulesets/Creator.h, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/EntityProperties.cpp,
	  rulesets/Entity_getLocation.h, rulesets/Fell.cpp, rulesets/Fell.h,
	  rulesets/Food.cpp, rulesets/Food.h, rulesets/Line.cpp,
	  rulesets/Line.h, rulesets/LineProperty.cpp, rulesets/LineProperty.h,
	  rulesets/MemEntity.cpp, rulesets/MemEntity.h, rulesets/MemMap.cpp,
	  rulesets/MemMap.h, rulesets/MemMap_methods.h,
	  rulesets/MindFactory.cpp, rulesets/MindFactory.h, rulesets/Missile.h,
	  rulesets/Motion.cpp, rulesets/Motion.h, rulesets/Movement.cpp,
	  rulesets/Movement.h, rulesets/Pedestrian.cpp, rulesets/Pedestrian.h,
	  rulesets/Plant.cpp, rulesets/Plant.h, rulesets/Py_BBox.cpp,
	  rulesets/Py_BBox.h, rulesets/Py_EntityWrapper.h,
	  rulesets/Py_Location.cpp, rulesets/Py_Location.h,
	  rulesets/Py_Map.cpp, rulesets/Py_Map.h, rulesets/Py_Mind.cpp,
	  rulesets/Py_Mind.h, rulesets/Py_Object.cpp, rulesets/Py_Object.h,
	  rulesets/Py_Operation.cpp, rulesets/Py_Operation.h,
	  rulesets/Py_Oplist.cpp, rulesets/Py_Oplist.h, rulesets/Py_Optime.cpp,
	  rulesets/Py_Optime.h, rulesets/Py_Point3D.cpp, rulesets/Py_Point3D.h,
	  rulesets/Py_Property.cpp, rulesets/Py_Property.h,
	  rulesets/Py_Quaternion.cpp, rulesets/Py_Quaternion.h,
	  rulesets/Py_RootEntity.cpp, rulesets/Py_RootEntity.h,
	  rulesets/Py_Statistics.cpp, rulesets/Py_Statistics.h,
	  rulesets/Py_Task.cpp, rulesets/Py_Task.h, rulesets/Py_Thing.cpp,
	  rulesets/Py_Thing.h, rulesets/Py_Vector3D.cpp,
	  rulesets/Py_Vector3D.h, rulesets/Py_World.cpp, rulesets/Py_World.h,
	  rulesets/Py_WorldTime.cpp, rulesets/Py_WorldTime.h,
	  rulesets/PythonArithmeticScript.cpp,
	  rulesets/PythonArithmeticScript.h, rulesets/PythonMindScript.cpp,
	  rulesets/PythonMindScript.h, rulesets/PythonScript.cpp,
	  rulesets/PythonScript.h, rulesets/PythonThingScript.cpp,
	  rulesets/PythonThingScript.h, rulesets/PythonWrapper.cpp,
	  rulesets/PythonWrapper.h, rulesets/Python_API.cpp,
	  rulesets/Python_API.h, rulesets/Python_Script_Utils.h,
	  rulesets/Script.cpp, rulesets/Script.h, rulesets/Stackable.cpp,
	  rulesets/Stackable.h, rulesets/Statistics.cpp, rulesets/Statistics.h,
	  rulesets/StatisticsProperty.cpp, rulesets/StatisticsProperty.h,
	  rulesets/Structure.cpp, rulesets/Structure.h, rulesets/Task.cpp,
	  rulesets/Task.h, rulesets/TaskScript.cpp, rulesets/TaskScript.h,
	  rulesets/TerrainProperty.cpp, rulesets/TerrainProperty.h,
	  rulesets/Thing.cpp, rulesets/Thing.h, rulesets/ThingFactory.cpp,
	  rulesets/ThingFactory.h, rulesets/World.cpp, rulesets/World.h,
	  rulesets/attributes.h, server/Account.cpp, server/Account.h,
	  server/Admin.cpp, server/Admin.h, server/ArithmeticFactory.cpp,
	  server/ArithmeticFactory.h, server/CommClient.cpp,
	  server/CommClient.h, server/CommIdleSocket.cpp,
	  server/CommIdleSocket.h, server/CommListener.cpp,
	  server/CommListener.h, server/CommLocalClient.cpp,
	  server/CommLocalClient.h, server/CommMDNSPublisher.cpp,
	  server/CommMDNSPublisher.h, server/CommMaster.cpp,
	  server/CommMaster.h, server/CommMetaClient.cpp,
	  server/CommMetaClient.h, server/CommPSQLSocket.cpp,
	  server/CommPSQLSocket.h, server/CommPeer.cpp,
	  server/CommPeer.h, server/CommPeerListener.cpp,
	  server/CommPeerListener.h, server/CommRemoteClient.cpp,
	  server/CommRemoteClient.h, server/CommServer.cpp,
	  server/CommServer.h, server/CommSlaveClient.cpp,
	  server/CommSlaveClient.h, server/CommSlaveListener.cpp,
	  server/CommSlaveListener.h, server/CommSocket.cpp,
	  server/CommSocket.h, server/CommUnixListener.cpp,
	  server/CommUnixListener.h, server/Connection.cpp,
	  server/Connection.h, server/Connection_methods.h,
	  server/EntityFactory.cpp, server/EntityFactory.h,
	  server/ExternalMind.cpp, server/ExternalMind.h,
	  server/Idle.cpp, server/Idle.h, server/Lobby.cpp, server/Lobby.h,
	  server/Master.cpp, server/Master.h, server/Peer.cpp, server/Peer.h,
	  server/Persistance.cpp, server/Persistance.h,
	  server/PersistantThingFactory.cpp, server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h, server/Persistor.cpp,
	  server/Persistor.h, server/Persistor_impl.h,
	  server/Player.cpp, server/Player.h, server/Restoration.cpp,
	  server/Restoration.h, server/Restorer.cpp, server/Restorer.h,
	  server/Restorer_impl.h, server/ScriptFactory.cpp,
	  server/ScriptFactory.h, server/ServerRouting.cpp,
	  server/ServerRouting.h, server/ServerRouting_methods.h,
	  server/SlaveClientConnection.cpp, server/SlaveClientConnection.h,
	  server/TaskFactory.cpp, server/TaskFactory.h,
	  server/TrustedConnection.cpp, server/TrustedConnection.h,
	  server/WorldRouter.cpp, server/WorldRouter.h,
	  server/server.cpp, server/server.h, server/slave.cpp,
	  tests/Areatest.cpp, tests/BaseEntitytest.cpp,
	  tests/Charactertest.cpp, tests/Containertest.cpp,
	  tests/Creatortest.cpp, tests/EntityExerciser.h,
	  tests/EntityFactorytest.cpp, tests/Entitytest.cpp,
	  tests/Foodtest.cpp, tests/IGEntityExerciser.h,
	  tests/Linetest.cpp, tests/Locationtest.cpp, tests/OOGThingtest.cpp,
	  tests/Planttest.cpp, tests/Propertytest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Tasktest.cpp, tests/TestWorld.h,
	  tests/Thingtest.cpp, tests/WorldTimetest.cpp, tests/Worldtest.cpp,
	  tests/allOperations.h, tests/collisiontest.cpp, tests/consttest.cpp,
	  tests/distancetest.cpp, tests/emergencetest.cpp,
	  tests/inheritancetest.cpp, tests/logtest.cpp, tests/randomtest.cpp,
	  tests/systemtest.cpp, tests/transformtest.cpp,
	  tests/type_utilstest.cpp, tests/utilitytest.cpp,
	  tools/AdminClient.cpp, tools/AdminClient.h, tools/cyaddrules.cpp,
	  tools/cycmd.cpp, tools/cyconfig.cpp, tools/cyconvertrules.cpp,
	  tools/cyctrl.cpp, tools/cydbload.cpp, tools/cydumprules.cpp,
	  tools/cyisoload.cpp, tools/cyloadrules.cpp, tools/cypasswd.cpp,
	  tools/cywatchdog.cpp: Replace the copyright and license statements
	  with new versions that include disclaimer of warranty, and
	  permit distribution under later versions of the GPL.

2006-01-18  Al Riddoch  <alriddoch@zepler.org>

	* Makefile.am: Remove TODO.mason, as it contained nothing of note.

2006-01-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Remove error reports when client sends
	  move ops which refer to a non-existant entity.

2006-01-17  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: When allowing a character to create a character
	  even though it has specified a type that does not exist, install
	  a dummy type record for the non-existant type to keep Eris happy.

2006-01-16  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Modify interim hack that allows characters
	  of any type to be created so that it suppresses the character
	  creation error op.

2006-01-15  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Initialise the python interpreter
	  before testing the entity factory, as it is now required.

	* tests/Makefile.am: Re-order the submodules of rulesets when
	  linking, to ensure they link correctly.

2006-01-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Combat.py: Add method to cause one
	  entity to turn to face the other, and use it each tick of combat.

	* rulesets/Python_API.cpp: Rename "rules" python module to "rulesets"
	  so it maps more directly onto the classes it wraps.

	* rulesets/mason/world/statistics/Statistics.py: Use modified rulesets
	  module name.

2006-01-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Thing.cpp: Add wrapper for Character::mind2body.

2006-01-14  Al Riddoch  <alriddoch@zepler.org>

	* client/Py_CreatorClient.h, rulesets/Py_BBox.h,
	  rulesets/Py_Location.h, rulesets/Py_Map.h, rulesets/Py_Mind.h,
	  rulesets/Py_Object.h, rulesets/Py_Operation.h, rulesets/Py_Oplist.h,
	  rulesets/Py_Point3D.h, rulesets/Py_Quaternion.h,
	  rulesets/Py_RootEntity.h, rulesets/Py_Task.h, rulesets/Py_Thing.h,
	  rulesets/Py_Vector3D.h, rulesets/Py_World.h, rulesets/Py_WorldTime.h:
	  Re-wrote PyFoo_Check macros to comply with recent conventions
	  and be a little more efficient.

	* rulesets/Py_Statistics.cpp, rulesets/PythonArithmeticScript.cpp,
	  rulesets/mason/world/statistics/Statistics.py: Remove lots of
	  debug output.

	* rulesets/PythonArithmeticScript.h: Add an accessor to get to the
	  python object.

	* rulesets/StatisticsProperty.h: Add an accessor to get to the
	  Statistics reference handled by this class.

	* rulesets/Py_Property.cpp: Return the script for a statistics
	  object rather than creating a wrapper for it.

2006-01-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Statistics.cpp: Replace getattr and setattr methods
	  with getattro and setattro so they are inherited from the
	  python subclass. Add lookup to get methods from the subclass
	  so they can still be called.

	* rulesets/mason/world/statistics/Statistics.py: No longer necessary
	  to store explicit reference to owning character entity, as its
	  now available from the inherited base class.

2006-01-11  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Require Python 2.2 or later. Increment version.

	* rulesets/Py_Statistics.cpp: Remove commented out code, and add
	  initialisation of the entity pointer in this type during
	  construction.

	* rulesets/Py_WorldTime.cpp, rulesets/Py_Statistics.cpp: Use tp_free
	  in tp_dealloc as instructed by the latest documentation.

2006-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Statistics.cpp: Require that the character owning
	  statistics is passed to the script constructor.

	* rulesets/mason/world/statistics/Statistics.py: Pass entity
	  to base class constructor.

	* server/ArithmeticFactory.cpp: When building statistics constructor,
	  passed in reference to its owner.

2006-01-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonArithmeticScript.cpp: Implement getting attribute
	  values from statistics script.

	* rulesets/Statistics.cpp, rulesets/Statistics.h,
	  rulesets/Py_Statistics.cpp, rulesets/Character.cpp,
	  rulesets/Combat.cpp: Remove hard coded stats for combat
	  and strength.

	* rulesets/mason/world/statistics/Statistics.py: Add test support
	  for combat and strength stats.

	* server/PersistantThingFactory.cpp: Remove debug output.

2006-01-11  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp, server/Account.cpp, server/Connection.cpp,
	  server/server.cpp: Make server logs much more machine readable
	  by removing stray colons, standardising field semantics, and
	  cleaning up messages.

2006-01-10  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Re-order checks so that type is checked
	  for before checking to see if its legal. Add temporary code
	  to force settler if an unknown character type is specified.

	* server/Player.cpp: Remove some tests no longer required
	  because they have already been checked in Account::CreateOperation.

2006-01-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ArithmeticScript.h: Remove redundant constructor.

	* rulesets/ArithmeticScript.cpp: Provide empty virtual destructor
	  implementation.

	* rulesets/Py_Statistics.cpp: Add debugging output, and remove
	  rubbish from __init__.

	* rulesets/PythonArithmeticScript.cpp: Test implementation of
	  attribute.

	* server/ArithmeticFactory.cpp, server/ArithmeticFactory.h: New
	  factory class to create instances of scripts to handle
	  statistics.

	* server/EntityFactory.cpp, server/EntityFactory.h: Add new method
	  and supporting data structures to provide a way to create
	  statistics objects for newly created Character entities.

	* server/PersistantThingFactory.cpp: Add a call to
	  EntityFactory::addStatisticsScript to the Character
	  specialisation of PersistantThingFactory::populate, giving
	  all characters a statistics script now.

	* rulesets/mason/world/statistics/Statistics.py: Test implementation
	  of a class for all character statistics.

2006-01-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ArithmeticScript.h: Remove compile time warnings.

	* rulesets/Statistics.h, rulesets/Statistics.cpp: Pass stats request
	  onto script object if one is available.

	* server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h,
	  server/PersistantThingFactory.cpp: Add a populate method to the
	  entity factory, and specialise it for Character so it can be
	  used to add scripted statistics.

	* server/EntityFactory.cpp: Add a call to populate() in the right
	  place.

2006-01-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/ArithmeticScript.h, rulesets/PythonArithmeticScript.h,
	  rulesets/PythonArithmeticScript.cpp: Stub classes for handling
	  adding a script to handle Statistics.

2006-01-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Statistics.cpp: Re-order method and attribute handling
	  so that the C++ default handler can be used when no other hit occurs.

2006-01-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Statistics.h, rulesets/Statistics.cpp: Add methods for
	  getting values for soft statistics.

2006-01-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Remove C++ implementation of server.dictlist
	  as its installation was messy, and it serves no purpose being
	  implemented in C++.

	* rulesets/basic/mind/NPCMind.py, rulesets/basic/mind/dictlist.py: 
	  Use python dictlist implementation from original Python version
	  of cyphesis.

2006-01-06  Al Riddoch  <alriddoch@zepler.org>
,
	* rulesets/Py_Statistics.cpp: Extend type structure to comply with
	  more recent Python API.

	* rulesets/Python_API.cpp: Add Statistics to a new module called
	  rules.

2006-01-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_WorldTime.cpp: Extend the type object for python
	  WorldTime to the format used by more recent python versions,
	  adding new and init methods as well as flags, and doc string.

	* rulesets/Python_API.cpp: Refactor the way the server python
	  module and its type server.WorldTime are created to be the
	  preferred way for more recent python versions.

	* rulesets/basic/mind/NPCMind.py: Remove explicit WorldTime
	  member, as there is already one in the C++ base class.

2006-01-04  Al Riddoch  <alriddoch@zepler.org>

	* data/mason.xml: Make skeleton playable.

	* server/Connection.cpp: Differentiate in the event logs between
	  account creation and login to an existing account.

2006-01-04  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Require latest varconf for its new features.

	* common/globals.cpp, tools/cyconfig.cpp: Use new varconf scope for
	  settings to more suitably handle user overidden config settings.

	* aiclient/ClientConnection.cpp, aiclient/client.cpp,
	  client/client.cpp, common/Database.cpp, server/server.cpp,
	  server/slave.cpp, tools/AdminClient.h, tools/cyaddrules.cpp,
	  tools/cycmd.cpp: Use new varconf/config.h header.

2005-12-31  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Reduce the rate at which animal mass is
	  consumed when they are starving.

2005-12-30  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp: Move character creation logging to a place
	  where the information is easier to get to.

	* server/Connection.cpp: Add logging of taking existing character.

2005-12-30  Al Riddoch  <alriddoch@zepler.org>

	* common/log.h, common/log.cpp: Add logging function for logging
	  regular server activity, for statistics purposes, to a file.

	* server/Account.cpp, server/Connection.cpp, server/server.cpp:
	  Add log calls to recall typical events.

	* tools/cycmd.cpp: Set a name on the admin agent avatar.

2005-12-30  Al Riddoch  <alriddoch@zepler.org>

	* common/log.cpp: Include date and time when logging to the console.

2005-12-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/StatisticsProperty.h,
	  rulesets/StatisticsProperty.cpp: Add a property handler for
	  statistics.

	* rulesets/Character.cpp: When setting task, check if an existing
	  task needs to be cleared first. When clearing a task, check
	  whether a task exists or not.

	* rulesets/Character.cpp: When initiating combat task from task
	  factory, check to see if the task is successfully created before
	  using it.

	* rulesets/Py_Property.cpp, rulesets/Py_Property.h: New python wrapper
	  class for entity properties.

	* rulesets/Py_Mind.cpp: Re-work getattr logic to make it clearer.

	* rulesets/Py_Object.cpp: Return Py_None when an Atlas Element cannot
	  be converted to python. This ensures that this function never returns
	  null.

	* rulesets/Py_Statistics.cpp: Add temporary handlers for hardcoded
	  statistics for "attack", "defence", and "strength".

	* rulesets/Py_Task.cpp: Add wrappers for methods Task.irrelevant and
	  Task.obsolete, as these are now required in combat scripts.

	* rulesets/Py_Task.h: Fix the PyTask_Check macro, which was miscoded.

	* rulesets/Py_Thing.cpp: Add wrapper for Entity.send_world so that
	  scripts can channel ops through entities.

	* rulesets/Py_Thing.h, rulesets/Py_Thing.cpp: Add an addition structure
	  for directlty wrapping Character in a type safe way. Add method
	  structure pointer to Entity and Character wrappers so that
	  the same getattr method is used for both. Add new method table for
	  Character including wrappers for set_task and clear_task, allowing
	  task scripts to add themselves and remove themselves from
	  characters. Modify wrapEntity() to ensure that Character entities
	  get the right wrapper.

	* rulesets/Py_Thing.cpp: Re-work getattr code so that properties and
	  soft attributes are checked individually, rather than in a single
	  call to Entity.get. Use new python property wrappers to wrap
	  properties explicitly if required rather than converting to Atlas
	  then to generic Python data.

	* rulesets/TerrainProperty.h: Fix incorrect class description in
	  documentation.

	* rulesets/mason/world/tasks/Combat.py: Complete implementation of
	  simple example combat.

	* server/TaskFactory.cpp: Remove debug output.

2005-12-27  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.cpp: Remove commented out code for enumerating
	  op classes.

2005-12-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/MemMap.py: Remobe obsolete AI code.

2005-12-26  Al Riddoch  <alriddoch@zepler.org>

	* tests/TestWorld.h: Complete test world interface by adding new
	  task method.

2005-12-26  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h: Add factory method for new tasks to the world
	  interface.

	* rulesets/Character.cpp: Use world interface to create combat
	  task, rather than using EntityFactory directly.

	* server/WorldRouter.h, server/WorldRouter.cpp: Implement the
	  new task method in the core world object.

2005-12-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Switch to using the test combat script.

	* rulesets/Py_EntityWrapper.h, rulesets/Py_Statistics.h: Move the
	  generic entity wrapper structure into its own header.

	* client/Py_CreatorClient.cpp, rulesets/Py_Location.cpp,
	  rulesets/Py_Location.h, rulesets/Py_Mind.cpp, rulesets/Py_Thing.cpp,
	  rulesets/Python_API.cpp: Modify PyLocation so that rather than
	  having a flag to indicate whether the script owns the object,
	  it instead stores a pointer to the entity that owns it in that
	  eventuality.

	* rulesets/Py_Thing.cpp: Allow map and list attributes to be set from
	  scripts as long as the contents are Atlas compatible.

	* rulesets/Python_API.cpp: Fix script output handling so only complete
	  lines are output.

	* rulesets/mason/world/tasks/Combat.py: Add code for identifying
	  attacker and defender in a combat.

2005-12-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Re-work the keywords handling in Operation()
	  to avoid bugs in the mapping protocol by using Dict functions, and
	  eliminate wasteful double lookup. No longer accept setting FROM
	  in constructor as its never required.

	* rulesets/werewolf/world/objects/characters/Villager.py,
	  rulesets/basic/editor.py: No longer set FROM on operations at
	  construction. It was never necessary.

2005-12-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/world/tasks/Combat.py: Expand the sample combat
	  to include tick ops.

	* rulesets/Python_API.cpp, rulesets/Py_Operation.cpp: Add necessary
	  handlers for sub_to attribute on operations.

	* rulesets/Character.cpp: Adapt test code for combat scripts to
	  the latest task API.

2005-12-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Fix a problem where
	  an NPC seller would not count all the coins handed over immediatly.

	* rulesets/basic/mind/goals/humanoid/transaction.py: Add a FIXME about
	  a mis-coding using for loops.

2005-12-18  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.5

2005-12-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/humanoid/transaction.py: Tell the seller
	  how much the pig they have just sold was worth. Only value each
	  pig rather than continuously re-pricing the same pig.

2005-12-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.cpp: Ensure collision position is invalidated
	  once a collision isn't done.

	* rulesets/Pedestrian.cpp: Add some assert checks. Ensure that
	  m_updatedPos is always valid. Add a check for a race condition
	  where a collision is predicted, and the tick that should trigger
	  it occurs, but another move request arrives from the client
	  before the update Move op has been applied to the entity.

2005-12-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Remove a return statement so
	  legacy money handling code still works.

2005-12-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.cpp: Reset stored positions more efficiently.

	* rulesets/Pedestrian.cpp: Improve error reporting when a bad
	  collision occurs. Reset the coordinates, so that character does
	  not teleport to origin when a strange collision happens.

2005-12-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Add help to the tool merchant
	  and the butcher.

2005-12-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Fix formatting.

	* rulesets/basic/mind/NPCMind.py: Add structure to store things
	  an NPC has been given.

	* rulesets/basic/mind/goals/humanoid/transaction.py: Add new goal
	  for buying things from a given entity.

2005-12-15  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.h, rulesets/Movement.cpp,
	  rulesets/Pedestrian.h, rulesets/Pedestrian.cpp: When processing
	  a move operation, if its going to cause an immediate collision,
	  set the velocity to 0.

2005-12-15  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version.

	* rulesets/Movement.h, rulesets/Movement.cpp: Add a flag to indicate
	  if movement has been diverted by a collision.

	* rulesets/Pedestrian.cpp: Use flag to ensure that entities moving
	  towards a target position that are diverted by a collision
	  don't just snap to their original destination. When collision errors
	  are detected, don't mess the entities position up by changing it.

	* tests/Makefile.am: Fix broken tests.

2005-12-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Remove an obsolete commented out function.

	* rulesets/CalendarProperty.cpp, rulesets/CalendarProperty.h,
	  rulesets/World.cpp: Add a new property to handle revealing
	  astronomical calendar information on the world object, so clients
	  can get day/night cycle right.

	* tools/cycmd.cpp: Improve formatting of output Atlas data, to make
	  it readable.

2005-12-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Statistics.cpp, rulesets/Py_Task.cpp: Modify
	  getattr handlers for "character" to use wrapEntity.

	* rulesets/Task.h: Add accessor for character that owns this task.

2005-12-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/BaseMind.cpp: When appearance arrives, check stamp and send
	  looks if necessary.

	* rulesets/basic/mind/NPCMind.py: Remove some debug output.

2005-12-13  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Remove some obsolete comments.

2005-12-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp: When an op is being source routed by an admin
	  client, find its target and insert it into the world using the
	  target so it appears to be from the target, rather than using
	  the "cheat" marker.

	* server/WorldRouter.cpp: Remove check for FROM=="cheat", and
	  simplify setting FROM on ops. Use flags to check for FUTURE_SECONDS.

2005-12-13  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Don't set TO
	  on eat ops from goals.

2005-12-13  Al Riddoch  <alriddoch@zepler.org>

	* common/const.h: Add a second const for the non-squared default
	  box size for visibility calculations.

	* modules/Location.cpp: Initialise cached box size members with
	  defaults from consts.

	* rulesets/basic/mind/goals/common/move.py: Don't remove focus
	  knowledge about item just because it has been picked up. This
	  fixes eating acorns.

	* rulesets/basic/mind/goals/common/misc_goal.py: Remove focus knowledge
	  when something is eaten.

2005-12-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Thing.h, rulesets/Py_Thing.cpp: Add a new function to add
	  a wrapper to an entity, using PythonWrapper to cache it.

	* rulesets/Py_Location.cpp, rulesets/Py_Map.cpp, rulesets/Py_Mind.cpp,
	  rulesets/Py_World.cpp, rulesets/PythonMindScript.cpp: Convert code to
	  use new entity wrapper function, ensuring that wrappers are cached if
	  possible.

2005-12-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Mind.cpp, rulesets/Py_Thing.cpp: Fix a bug where
	  a new object was not decrefed after passing it into a list.
	  Remove some commented out code. Fix some assertions.

2005-12-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Mind.cpp: Clean up some variable names in preparation
	  for some major changes.

2005-12-12  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonWrapper.cpp: Make sure PythonWrapper holds a propper
	  reference to the wrapper object, to ensure its not dealloced.

	* rulesets/Py_Location.cpp: Store a PythonWrapper when creating
	  a new wrapper object if the entity does not already have
	  a script.

	* rulesets/MemMap.cpp: Fix an uninitialised variable.

2005-12-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonWrapper.h, rulesets/PythonWrapper.cpp: Add new
	  class which inherits from Script to store a wrapper pointer
	  for instances which have no script.

	* rulesets/PythonScript.h, rulesets/PythonScript.cpp,
	  rulesets/PythonThingScript.h, rulesets/PythonThingScript.cpp,
	  rulesets/PythonMindScript.h, rulesets/PythonMindScript.cpp:
	  Refactor script classes to inherit from PythonWrapper to make
	  storing wrappers for mind and world entities easier.

	* rulesets/Py_Location.cpp, rulesets/Py_World.cpp: Use PythonWrapper
	  interface to get wrapper pointers from Script objects.

	* rulesets/Python_API.cpp: Improve variable names, and comment out
	  some unused code.

2005-12-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Script.h, rulesets/Script.cpp: Add a default Script
	  instance for entities that don't have a script.

	* rulesets/Entity.cpp: Assign a pointer to the default script
	  object in constructor, and check for it when deleting scripts.

2005-12-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Add accessor for script.

	* rulesets/PythonThingScript.h: Add accessor for script wrapper.

	* rulesets/Py_World.cpp, rulesets/Py_Location.cpp: When getting a
	  python wrapper for an entity for a script, check to see if the
	  entity has a permanent wrapper already.

2005-12-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonThingScript.h, rulesets/PythonThingScript.cpp:
	  Store a pointer to the core object's python wrapper, and modify
	  constructor to initialise it.

	* rulesets/Python_API.cpp, server/ScriptFactory.cpp,
	  server/TaskFactory.cpp: Modify variable name to make it clearer
	  what the wrapper object is. Pass wrapper to script management
	  object constructor, so it can store the pointer.

	* rulesets/PythonMindScript.h: Make constructor explicit for
	  safety.

2005-12-10  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMaster.cpp, server/CommMaster.h,
	  server/Master.cpp, server/Master.h, server/slave.cpp:
	  Convert slave code over to use conventions for integer IDs.

2005-12-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonMindScript.cpp, rulesets/PythonThingScript.cpp:
	  Clean up code which handles calling methods in python, removing
	  some unnecessary checks, and report error messages on some more
	  error occurences.

2005-12-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.h, rulesets/Character.cpp: Add a function to
	  assign a task to a character.

	* tests/Tasktest.cpp: Test the combat task.

2005-12-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Fell.h, rulesets/Fell.cpp: Update to new interface
	  so tests work.

2005-12-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Script.cpp: Document the script interface.

	* rulesets/Task.h: Modify task interface so tasks now expect
	  the operation that initiated the task to be passed in
	  to an init function.

	* rulesets/Combat.h, rulesets/Combat.cpp: Modify the combat task
	  methods to match the interface changes.

	* rulesets/Character.cpp: Modify Combat use to take account
	  of interface changes. Prototype using script based
	  combat.

	* rulesets/TaskScript.h, rulesets/TaskScript.cpp: Implement
	  passing the initialising op through to the script using the
	  standard scripp operation handling functions.

	* rulesets/mason/world/tasks/Combat.py: Add handler for Attack
	  operation, which should now be passed in at init time.

2005-12-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/TaskScript.cpp, server/TaskFactory.cpp: Add some assert
	  checks.

	* server/EntityFactory.cpp: Remove some debug output.

	* rulesets/mason/world/tasks/Combat.py: Add a simple example
	  of the interface required in a task script.

2005-12-08  Al Riddoch  <alriddoch@zepler.org>

	* server/TaskFactory.h, server/TaskFactory.cpp,
	  server/EntityFactory.h, server/EntityFactory.cpp,
	  rulesets/TaskScript.h, rulesets/TaskScript.cpp:
	  Implement task script interface.

2005-12-07  Miguel Guzman

	* data/mason.xml: Add dog.

	* rulesets/mason/define_world_aglanor.py: Add some dogs, they patrol
	  the outskirt of the town and chase squirrels and chickens.

2005-12-07  Al Riddoch  <alriddoch@zepler.org>

	* server/ServerRouting.h: Add accessor for client count.

	* server/CommMDNSPublisher.h, server/CommMDNSPublisher.cpp:
	  Add alternative MDNS-SD handler using Avahi, which is preferred
	  over howl.

	* server/server.cpp: CommMDNSPublisher is now an idler as well
	  as a socket.

2005-12-07  Al Riddoch  <alriddoch@zepler.org>

	* server/ServerRouting.h: Add accessor for server ruleset.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/Admin.h, server/Admin.cpp: Add all character and NPC types
	  the the list of playable types available for admin.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/CommMDNSPublisher.cpp: Use server name rather than
	  "WorldForge Server" when publishing via MDNS service discovery
	  to avoid name clashes when using avahi.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* tools/cyconfig.cpp: Start adding a system for processing commands,
	  so cyconfig can be used to perform more server configuration
	  tasks.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* man/cyclient.1, man/cycmd.1, man/cyphesis-tools.1, man/cyphesis.1:
	  Commit generated manpages, as they cause problems for people with
	  older docbook installed.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Report failure as "no" when pkg-config checks don't
	  find the right libs. Improve the clarity of error messages, and
	  use the messages provided by pkg-config to indicate what is
	  wrong when there are multiple posibilities.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/TaskFactory.cpp, server/TaskFactory.h: Re-write the
	  script task to handle creating the script directly, rather than
	  use ScriptFactory which is not suitable.

	* rulesets/PythonMindScript.cpp, rulesets/PythonScript.cpp,
	  rulesets/PythonScript.h, PythonThingScript.cpp,
	  rulesets/PythonThingScript.h, rulesets/Python_API.cpp,
	  server/ScriptFactory.cpp: Remove obsolete pointer to entity
	  from script class, removing its link to Entity, making it more
	  generally useful.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/world/objects/Thing.py: Move some functionality
	  from the Thing base class into NPCMind, leaving minimal
	  functionality in the base class making it suitable as an interface
	  for all scripts.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.h, server/EntityFactory.cpp: Add a handler for
	  objects in rules files.

	* rulesets/TaskScript.h, rulesets/TaskScript.cpp: Task class which
	  delegates functionality to a script object. Basically just a
	  stub at this point.

	* server/TaskFactory.h server/TaskFactory.cpp: Factory class for
	  creating instances of Task classes.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Mind.cpp: Delay initialisation of mind's python
	  attribute store until it's required.

	* rulesets/Py_Mind.cpp, rulesets/Py_Thing.cpp: Add FIXME about
	  allowing the client to set map and list attributes.

2005-12-05  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_BBox.cpp, rulesets/Py_Optime.cpp,
	  rulesets/Py_Statistics.cpp, rulesets/Py_Thing.cpp: Ensure that
	  setattr returns an exception if the attribute is not a valid one.

	* rulesets/Py_Map.cpp, rulesets/Py_Point3D.cpp,
	  rulesets/Py_Quaternion.cpp, rulesets/Py_World.cpp,
	  rulesets/Py_WorldTime.cpp: Remove setattr, as no attributes can
	  be set on this type.

	* rulesets/Py_Mind.cpp, rulesets/Py_Oplist.cpp,
	  rulesets/Py_Vector3D.cpp: Clean up type structure.

	* rulesets/basic/mind/goals/common/move.py: Remove attempt
	  to set "rotation" attribute on location, as its obsolete
	  and pointless.

2005-12-04  Al Riddoch  <alriddoch@zepler.org>

	* server/CommUnixListener.cpp, server/CommListener.cpp: Add cassert
	  include required by some compilers.

	* configure.ac: Add experimental support for new avahi DNS service
	  discovery implementation, using howl compatabiity API. Untested.

2005-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Operation.cpp: Throw an attribute exception if a script
	  tries to modify an unknown attribute on an operation.

2005-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add getProperty method
	  which allows the property object of an attribute to be accessed.

	* tests/IGEntityExerciser.h, tests/Entitytest.cpp: Add tests for
	  getProperty() basic functionality.

2005-12-04  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Mind.cpp, rulesets/Py_Task.cpp, rulesets/Py_Thing.cpp:
	  Throw assertion expceptions if python code attempts to compare
	  objects with NULL pointers.

	* rulesets/Py_Statistics.cpp, rulesets/Py_Statistics.h: Basic python
	  wrappers for Statistics.

2005-12-03  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Thing.cpp: Clean up error messages. Delay initialisation
	  of entity's python attribute store until its required.

	* rulesets/Py_Task.cpp, rulesets/Py_Task.h: Basic python wrappers
	  written for Task.

2005-12-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/world/objects/Thing.py: Get rid of redundant kw
	  arg to constructor, move op_dict initialisation to cinit()
	  and remove base_init completely as its only required to handle
	  the C++ constructor behavoir which we no longer need.

	* rulesets/basic/mind/NPCMind.py: Get rid of redundant args to
	  to mind, and call cinit to handle connection to C++ core directly
	  now that base_init is gone.

2005-12-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/BaseMind.py: Remove obsolete base mind class,
	  now completely implemented in C++.

2005-12-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/ExternalMind.py: Remove obsolete external
	  mind class, now completely implemented in C++.

2005-12-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/mind/SkelMind.py: Remove constructor, and
	  add Setup operation handler so that skeleton can see again.

	* rulesets/mason/world/objects/Weather.py: Remove unnecessary
	  constructor.

2005-11-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Remove obsolete C++ set_kw() implementation.

2005-11-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/world/objects/Thing.py: Remove self.attributes
	  from the base class for all python scripts.

	* rulesets/mason/world/objects/Weather.py,
	  rulesets/basic/world/objects/plants/Tree.py,
	  rulesets/basic/world/objects/animals/Animal.py,
	  data/basic.xml, data/mason.xml: Don't use set_kw to handle default
	  attributes, and add the to the .xml rules files.

	* rulesets/basic/world/objects/buildings/House.py,
	  rulesets/basic/world/objects/buildings/StoneHouse.py,
	  rulesets/basic/world/objects/tools/Bow.py,
	  rulesets/basic/world/objects/tools/Sword.py,
	  rulesets/mason/world/objects/animals/Deer.py,
	  rulesets/mason/world/objects/animals/Pig.py,
	  rulesets/mason/world/objects/outdoor/Campfire.py,
	  rulesets/mason/world/objects/outdoor/Gravestone.py,
	  rulesets/mason/world/objects/plants/seeds/Acorn.py,
	  rulesets/mason/world/objects/plants/seeds/Apple.py,
	  rulesets/mason/world/objects/plants/seeds/Fircone.py,
	  rulesets/mason/world/objects/plants/seeds/Seed.py,
	  rulesets/mason/world/objects/tools/Cleaver.py,
	  rulesets/mason/world/objects/undead/Skeleton.py,
	  rulesets/werewolf/world/objects/characters/Villager.py,
	  rulesets/werewolf/world/objects/tools/Gallows.py:
	  Don't import set_kw from misc, as its now obsolete and unused.

2005-11-30  Al Riddoch  <alriddoch@zepler.org>

	* common/Property.h, common/Property_impl.h, common/Property.cpp:
	  Modify property interface to make apropriate methods const,
	  re-order inheritance to eliminate some redundant code.

	* rulesets/EntityProperties.cpp, rulesets/LineProperty.h,
	  rulesets/LineProperty.cpp, rulesets/TerrainProperty.h,
	  rulesets/TerrainProperty.cpp: Update methods to match modified
	  interface.

2005-11-30  Al Riddoch  <alriddoch@zepler.org>

	* server/CommServer.cpp: Update some comments about how the flags
	  work to ensure the server is repsonsive.

2005-11-27  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.4

2005-11-25  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/mason/define_world.py: Add some more knowledge about pig
	  herding, and the mausoleum.

2005-11-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Add handling for 'about' knowledge
	  and return it in a way that makes sense to the listener.

	* rulesets/mason/define_world.py: Provide NPCs which lots of
	  information 'about' the world, so they can help players.

2005-11-23  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version.

2005-11-23  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Fix height correction calculation inversion.

	* data/mason.xml: Make houses inherit from structure so it is possible
	  to go in and out.

2005-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Pedestrian.cpp: Improve debug output for collision code
	  errors.

2005-11-23  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.cpp, common/Database.cpp, rulesets/MemMap.cpp,
	  server/Connection.cpp, server/EntityFactory.cpp, server/Peer.cpp,
	  server/Persistance.cpp, server/Restoration.cpp,
	  server/ServerRouting.h: Update integer ID related checks now that
	  integerId() function has changed.

2005-11-23  Al Riddoch  <alriddoch@zepler.org>

	* common/id.cpp, common/id.h: Break integer ID conversion into
	  two versions, one which abort()s and one which returns a known
	  invalid ID.

	* rulesets/Character.cpp: Fix the grammar in an error message.

	* server/Player.cpp: Make error message on failed character creation
	  clearer.

2005-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Prevent characters from attacking themselves.

2005-11-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp, rulesets/World.cpp, server/WorldRouter.cpp:
	  Use Location cached box size instead of calculating on the fly.

2005-11-22  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.h, modules/Location.cpp: Add members to store
	  box diagonal size and bounding radius.

	* tests/Locationtest.cpp: Test that the diagonal size and bounding
	  radius are updated correctly.

2005-11-22  Al Riddoch  <alriddoch@zepler.org>

	* server/Restorer_impl.h: Notify Location that bbox is modified
	  once it has been restored from database.

	* tests/Locationtest.cpp: Add test for checking bbox related data
	  gets updated.

2005-11-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Switch to using SignalProperty for BBOX.

	* rulesets/Area.cpp, rulesets/Character.cpp, rulesets/Line.cpp,
	  rulesets/Plant.cpp, rulesets/Py_Location.cpp:
	  Update bbox on location using setBBox(), so cached values are
	  updated.

2005-11-21  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.h, modules/Location.cpp: Add methods to modify
	  bbox, and to report if it has been modifed so that cached values
	  can be computed.

	* common/Property.h, common/Property_impl.h: Add a new type of
	  Property which emits a signal when modified.

	* rulesets/EntityProperties.cpp, rulesets/Entity.cpp: Implement
	  signal Property and use it for bbox, so linking its signal
	  to Location so that the necessary values can be computed after
	  modification.

2005-11-20  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.3

2005-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Get rid of warning about unused variables
	  in non-debug build.

	* configure.ac: Increment version for release soonish.

2005-11-20  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Add more tests to ensure adding or
	  removing attributes propagates correctly down the type tree.

	* server/EntityFactory.cpp: Reset class attributes when factory
	  is modified.

2005-11-19  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Encapsulate server monitor functionality
	  in an AdminTask class.

2005-11-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp: Reply to client with Unseen op when client
	  looks for an IG entity by name or type which returns no results.

	* tools/cycmd.cpp: Add a cancel command to stop current running task.
	  Detect Unseen at the end of a flush task, and end the task.
	  Remove a bunch of debug output. Fix typo in add_agent output.

2005-11-19  Al Riddoch  <alriddoch@zepler.org>

	* common/id.cpp, common/id.h: Add a function to check a string ID
	  can be converted to an integer.

	* server/EntityFactory.cpp: Check IDs are valid integers before
	  looking them up in the world.

2005-11-19  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Modify flusher so it uses tick ops to schedule
	  regular queries, until no more are found rather then attempting
	  to purge all entities asap, which caused race conditions. Check
	  the type of entities before deleting them.

	* rulesets/Creator.cpp: Improve debug output. Don't dispatch ops
	  from client to creator locally if the are scheduled to occur
	  in the future.

2005-11-19  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Flush output to server from AdminTask objects.

2005-11-19  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Add task handling, and start work on a task to
	  flush entities of a given type from the server.

2005-11-18  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Fill out comments in tests a bit better.

2005-11-18  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Add new tests to verify the Entity
	  Factory does the right thing with class attributes and inheritance.

2005-11-18  Al Riddoch  <alriddoch@zepler.org>

	* server/PersistantThingFactory.h,
	  server/PersistantThingFactory_impl.h: Add separate tracking of
	  class attributes, and accumulated attributes including those
	  inherited from the parent class. Add members for storing
	  parent and child types to a factory.

	* server/EntityFactory.h: Ensure instance pointer is zeroed
	  when instance is deleted. Make internal methods protected so
	  its easier to test them in a unit test.

	* server/EntityFactory.cpp: Add pointers to child factories to parent
	  when installing new ones. Handle copying inherited attribute
	  defaults from the parent factory.

	* tests/EntityFactorytest.cpp: Add a new class which exposes the
	  protected parts of EntityFactory for testing.

2005-11-18  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Add an AdminTask interface for tasks which
	  take longer to complete.

2005-11-18  Al Riddoch  <alriddoch@zepler.org>

	* tests/EntityFactorytest.cpp: Add new test to work EntityFactory.

2005-11-18  Al Riddoch  <alriddoch@zepler.org>

	* tests/TestWorld.h, tests/Creatortest.cpp, tests/Worldtest.cpp:
	  Move test implementation of BaseWorld into its own header, as
	  it's used in multiple places.

2005-11-17  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Creator.cpp: Ensure Look returns nothing when client
	  is searching by name or type, and nothing is found.

	* tools/cycmd.cpp: Add help for some more commands. Ensure help is
	  formatted ok, no matter how long the commands are. Report an
	  error if commands that required an argument don't get one.
	  Ensure find_by_name and find_by_type still work ok if
	  nothing is seen.

2005-11-17  Al Riddoch  <alriddoch@zepler.org>

	* tests/Areatest.cpp, tests/BaseEntitytest.cpp,
	  tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/EntityExerciser.h, tests/Entitytest.cpp, tests/Foodtest.cpp,
	  tests/Linetest.cpp, tests/Makefile.am, tests/OOGThingtest.cpp,
	  tests/Planttest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Tasktest.cpp, tests/Thingtest.cpp,
	  tests/Worldtest.cpp, tests/distancetest.cpp:
	  Update tests to work with integer ID changes.

2005-11-17  Al Riddoch  <alriddoch@zepler.org>

	* tools/cycmd.cpp: Re-code help system to use the commands list when
	  generating help output.

2005-11-14  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.cpp: Reset the collision LOC change flag before
	  running the check.

	* rulesets/Pedestrian.cpp: Improve debug reporting of collision
	  errors.

2005-11-14  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.init: Fix hardcoded PostgreSQL admin user to use the
	  shell variable as it should. Thanks to Kai Blin for the fix.

2005-11-14  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h: Switch the core object index for the server, and
	  the subscription index for connections to use integer IDs.

	* server/Admin.cpp, server/Connection.cpp, server/Connection.h,
	  server/ExternalMind.cpp, server/ServerRouting.h:
	  Modify code to use integer object indices.

	* server/Lobby.cpp: Remove debug output.

2005-11-13  Al Riddoch  <alriddoch@zepler.org>

	* server/Admin.cpp, server/CommPeer.cpp, server/CommPeer.h,
	  server/CommPeerListener.cpp, server/Peer.cpp, server/Peer.h:
	  Re-work classes for peer connections to use integer IDs.

	* server/Lobby.cpp, server/Lobby.h: Modify interface so its more
	  obvious that lobby only handles accounts, and adjust to have
	  integer ID.

	* server/Connection.cpp, server/Connection.h,
	  server/TrustedConnection.cpp, server/TrustedConnection.h: Use
	  integer IDs, and modify to match new Lobby API changes.

	* server/ServerRouting.cpp, server/ServerRouting.h, server/server.cpp:
	  Modify server to have integer ID, and handle ID for Lobby as well.

	* server/CommListener.cpp, server/CommLocalClient.cpp,
	  server/CommLocalClient.h, server/CommRemoteClient.cpp,
	  server/CommRemoteClient.h, server/CommUnixListener.cpp:
	  Modify communication classes for normal clients to handle
	  integer IDs on the connection classes.

2005-11-12  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp, common/Database.h, common/id.h, common/id.cpp:
	  Make newId() functions return the integer value.

	* common/newid.cpp: Break newId out into its own file, and make
	  it handle whether or not the database should issue IDs.

	* server/Connection.cpp, server/Persistance.cpp,
	  server/WorldRouter.cpp, server/server.cpp: Simply generating IDs
	  by just using the newId() function, and use its return value.

2005-11-12  Al Riddoch  <alriddoch@zepler.org>

	* client/BaseClient.cpp, common/BaseWorld.cpp, common/id.cpp,
	  common/id.h, rulesets/MemMap.cpp, server/Account.cpp,
	  server/Admin.cpp, server/Connection.cpp, server/Persistance.cpp,
	  server/Restoration.cpp, server/WorldRouter.cpp, server/server.cpp:
	  Add intgerId() function to convert ID strings to integers, and
	  check the conversion went okay.

2005-11-11  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.h, common/OOGThing.cpp, common/OOGThing.h,
	  server/Account.cpp, server/Account.h, server/Admin.cpp,
	  server/Admin.h, server/Connection.cpp, server/ExternalMind.cpp,
	  server/ExternalMind.h, server/Lobby.cpp, server/Lobby.h,
	  server/Peer.cpp, server/Persistance.cpp, server/Player.cpp,
	  server/Player.h, server/ServerRouting.cpp,
	  server/SlaveClientConnection.cpp, server/server.cpp:
	  Add integer ID handling to accounts, and some other OOG
	  objects.

2005-11-11  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.init: Don't commit without checking with me first.

2005-11-11  Kai Blin  <blin@gmx.net>

	* cyphesis.init: replaced a hardcoded reference to the postgres user
	  by the $POSTGRESUSER variable

2005-11-11  Al Riddoch  <alriddoch@zepler.org>

	* common/types.h, server/Persistance.h, common/BaseWorld.h,
	  common/BaseWorld.cpp, server/WorldRouter.cpp:
	  Switch core world map to reference by integer ID rather than string.
	  Add version of getEntity() which converts from string to integer
	  automatically.

	* rulesets/Character.cpp, rulesets/Thing.cpp, rulesets/World.cpp,
	  server/EntityFactory.cpp, 
	  Use getEntity() when looking up an entity, so that conversion of
	  ID from string to integer is automatic.

	* rulesets/BaseMind.cpp, rulesets/MemMap.cpp, rulesets/MemMap.h:
	  Switch to using integer IDs in MemMap's core mapping.

	* server/Account.cpp, server/Account.h: Switch a few function
	  parameters to use integer ID values, making the code cleaner.

	* server/Account.cpp, server/Admin.cpp, server/Persistance.cpp:
	  Handle string ID to integer conversions as required.

2005-11-10  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.h, common/BaseEntity.cpp: Add an integer ID
	  member variable, and accessor, and require it to be initialised
	  along with string ID in constructor.

	* common/const.cpp, common/const.h: Add a const for the integer value
	  of the world ID.

	* rulesets/Area.cpp, rulesets/Area.h, rulesets/BaseMind.cpp,
	  rulesets/BaseMind.h, rulesets/Character.cpp, rulesets/Character.h,
	  rulesets/Creator.cpp, rulesets/Creator.h, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/Food.cpp, rulesets/Food.h,
	  rulesets/Line.cpp, rulesets/Line.h, rulesets/MemEntity.cpp,
	  rulesets/MemEntity.h, rulesets/Plant.cpp, rulesets/Plant.h,
	  rulesets/Stackable.cpp, rulesets/Stackable.h, rulesets/Structure.cpp,
	  rulesets/Structure.h, rulesets/Thing.cpp, rulesets/Thing.h,
	  rulesets/World.cpp, rulesets/World.h: Add integer ID handling to
	  constructors of all in-game entity classes.

	* rulesets/MemMap.cpp: Initialise integer ID of entities in the mind
	  map.

	* rulesets/MindFactory.cpp, rulesets/MindFactory.h: Handle integer
	  ID when constructing mind objects.

	* server/EntityFactory.cpp, server/EntityFactory.h,
	  server/PersistantThingFactory_impl.h: Handle integer
	  ID when contructing entity objects.

	* server/Restoration.cpp, server/Restoration.h, server/Restorer.h,
	  server/Restorer_impl.h: Handle integer ID when restoring from
	  database.

	* server/WorldRouter.cpp: Assign integer ID when constructing the
	  world.

2005-11-10  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseWorld.h: Remove obsolete ID member variable.

2005-11-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Statistics.h: Add comments clarifying use of references
	  in this class.

2005-11-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Combat.cpp: Use Entity::sendWorld() to ensure that
	  notification of victory or defeat appear to come from the world
	  rather than one of the combatants.

2005-11-09  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h: Add a new method which
	  generates an error operation without creating an log entry.

	* server/Connection.cpp: Report routine client errors, like
	  login failure using the new error method, so they no longer
	  create high priority log messages.

2005-11-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Prevent clients and minds for using
	  FUTURE_SECONDS on ops other than tick. Remove all handling
	  of FUTURE_SECONDS when processing move ops from clients and minds.

2005-11-02  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Don't respond to knowledge
	  queries if the character has no knowledge.

	* server/Connection.cpp, rulesets/Creator.cpp, rulesets/Character.cpp:
	  Use flag check to see if operations have FROM set, rather than
	  checking for an empty string.

	* rulesets/Thing.cpp: When handling move ops, avoid lookup of LOC
	  in world unless it has changed.

2005-10-25  Al Riddoch  <alriddoch@zepler.org>

	* cyphesis.spec.in: Fix dependency on Atlas-C++06

	* Release 0.5.2

2005-10-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Immobilise character if they have no stamina.

	* configure.ac, NEWS: Increment version and update news.

	* TODO: Remove done TODO items.

2005-10-24  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Combat.cpp: Modify win condition check, so it occurs at
	  the end of tick. Send notification to winner and loser of combat
	  using faked Talk ops. Make the loser lose a little health.

2005-10-23  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Report an error if m_task becomes null
	  while processing a task tick op.

	* rulesets/Combat.cpp: Remove debug output.

	* rulesets/Statistics.cpp: Remove debug output.

2005-10-22  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.cpp: Cache value of std::list::end() to avoid
	  expensive return by value in every loop iteration. Add some comments
	  about obsolete getoperationFromQueue() function.

2005-10-21  Al Riddoch  <alriddoch@zepler.org>

	* physics/BBox.cpp: Re-code squareBoxSize() to be much more efficient.

	* server/CommServer.cpp: Don't report "Interrupted System Call" as
	  an error from epoll_wait, as its always happening.

	* tools/Makefile.am: Add pthread library to static link libs for
	  database using tools.

2005-10-21  Al Riddoch  <alriddoch@zepler.org>

	* physics/Vector3D.cpp: Replace the seriously inefficient
	  implementation of squareDistance() with one that should perform
	  a bit better.

2005-10-21  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Pedestrian.cpp, rulesets/Movement.h, rulesets/Movement.cpp:
	  Store the time of the last collision, and if the next one occurs
	  almost immediatly, stop the movement. This eliminates the judder
	  which used to occur in some nasty collision scenarios.

2005-10-21  Al Riddoch  <alriddoch@zepler.org>

	* server/WorldRouter.h, server/WorldRouter.cpp: Add a second op
	  queue for ops which do not have a time specified, so it is
	  cheaper to add ops to the queue if they are to be dispatched
	  immediatly.

2005-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Creator.cpp: Modify operations
	  in place rather than copying first in the mind operation interface
	  as this should be much more efficient.

2005-10-20  Al Riddoch  <alriddoch@zepler.org>

	* server/CommClient.cpp: Store serialno from clients, to make sure
	  its not being read from the op after it has been given to
	  the core server code.

2005-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Report a warning when action ops are sent
	  from client or mind code.

	* rulesets/Py_Location.cpp: Allow invalid vectors to be used
	  to set attributes on Location.

	* rulesets/acorn/world/objects/undead/Skeleton.py,
	  rulesets/mason/world/objects/undead/Skeleton.py: Remove action
	  ops replacing them with setting MODE of skeleton to
	  collapsed.

	* rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/mind/goals/common/misc_goal.py: Use Imaginary ops
	  rather than Action for emotes.

2005-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Audit all mindFooOperation() methods, to
	  ensure operations from the mind or client code are handled in
	  a correct and consistant manner. Improve comments documenting
	  the mind operation interface.

	* rulesets/Entity.cpp: Add comments documenting how externalOperation
	  should be used.

2005-10-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h: Add an assert to ensure reference counting
	  is bug free.

	* server/WorldRouter.cpp: When delivering ops, check if the op
	  is to the same entity it is from, which avoids looking up
	  the ID in the world dictionary.

2005-10-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/NPCMind.py: Fix face() so that NPC doesn't crash
	  if it turns to face something that is zero distance away.

	* server/EntityFactory.cpp: Improve error reporting when an entity
	  has velocity set at creation, and ensure that the velocity is
	  unset before the entity goes into the world.

2005-10-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Task.h: Make irrelevant() virtual so that each task
	  class is responsible for doing most of its cleanup.

	* rulesets/Movement.h: Make updateNeeded() public so other code
	  can determine if a character is moving.

	* rulesets/Character.h, rulesets/Character.cpp: Add a stamina property.
	  Add clearTask() used to clear the current running task. Check
	  if tasks are irrelevant immediatly after setup, or after each
	  tick, and remove if they are.

	* rulesets/Combat.h: Add irrelevant() implementation, and a static
	  variable defining stamina level below which combat cannot occur.

	* rulesets/Combat.cpp: Switch to stamina as the base stat for
	  combat. Implement checking stamina at setup to ensure
	  both combatants are fit to fight, and each tick to determine if
	  someone has lost.

2005-10-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Fix handling of Touch op so it now
	  returns a Sight(Touch) rather than an Action op to indicate
	  what has occured.

	* common/custom.cpp: Fix inheritance of Attack op to Action.

	* TODO: Add a note about optimising the mind operation interface.

2005-10-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Statistics.cpp: Fix logic for incrementing existing
	  skills, and debug output for determining whether the change
	  should be passed to the user.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* README: Regenerate from source.

	* TODO: Add note describing eventual goals of statistics system.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Combat.cpp: Fill out handler for combat, adding
	  ops which apply damage to defender, and using statistics
	  to handle combat ability.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Character.h: Add a Statistics
	  objects as a member variable of Character, and use it to
	  determine if a character is strong enough to move other
	  entities.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_RootEntity.cpp: Add comments about leaked python objects.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Statistics.cpp, rulesets/Statistics.h: Add class to
	  handle skill statistics for characters.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* common/random.h: Make uniform() random function inlined.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* man/cyphesis-tools.sgml, man/cyphesis.sgml: Fix some typos on
	  the man pages.

2005-10-16  Al Riddoch  <alriddoch@zepler.org>

	* server/CommClient.h, server/CommClient.cpp: Check stream has not
	  failed before sending ops, to ensure that failed sockets are
	  cleared promptly. Check fail() in addition to eof() to ensure
	  that failed connections are detected when reading.

2005-10-12  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am, server/Makefile.am, tools/Makefile.am:
	  Add top_builddir to the include paths to catch config.h.

2005-10-12  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Add nostdinc option, to get rid of unnecessary
	  -I options on the compile commandlines.

2005-10-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Task.h: Add required <cassert> include.

2005-10-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Combat.h, rulesets/Combat.cpp: More experiments with
	  tasks and combat.

2005-10-07  Al Riddoch  <alriddoch@zepler.org>

	* Release 0.5.1

2005-10-07  Al Riddoch  <alriddoch@zepler.org>

	* Update NEWS.

	* Update version to 0.5.1 for release.

	* tests/consttest.cpp: Fix warning due to unused variables.

2005-10-05  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Replace SA_ONESHOT with SA_RESETHAND is it
	  seems to be a more portable way to do the same thing.

2005-10-04  Al Riddoch  <alriddoch@zepler.org>

	* server/Idle.h, server/Idle.cpp: Rename reference to CommServer
	  so there is no ambiguity in classes which inherit from Idle
	  and CommSocket.

	* server/CommServer.h, server/CommServer.cpp: Store the current
	  time, and a flag indicating if the server is currently handling
	  client traffic. Modify idle handlers so they are only
	  called if the server is not busy with internal traffic, or traffic
	  from clients. Check for errors returned by epoll().

	* server/CommUnixListener.cpp, server/CommListener.cpp,
	  server/CommClient.h, server/CommClient.cpp: Make CommClient an
	  idler, and use it to track clients which connect but don't
	  negotiate, disconnecting them after a timeout.

2005-10-02  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp, server/CommClient.cpp,
	  tools/AdminClient.cpp, tools/cycmd.cpp:
	  Update to use new Negotiate API in Atlas-C++.

2005-10-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Plant.cpp: Fix bug in tree felling which caused an op
	  to get into an infinite loop.

2005-10-01  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Install the Monitor op type, which was missing.

	* server/Admin.cpp: Use class_no to determine op types rather
	  than string type.

2005-10-01  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Re-order code so that its not necessary
	  to lookup an entity that is to be moved unless we already know
	  its not the current entity.

	* rulesets/Character.cpp: Implement destination based movement when
	  the target position is specified with a different LOC to the
	  current LOC of the character.

	* modules/Location.cpp: Document the functions used to determine
	  relative distance vectors.

2005-09-30  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonThingScript.cpp, rulesets/PythonMindScript.cpp: Fix a
	  bug which meant that most operations returned from scripts were
	  silently ignored.

2005-09-29  Al Riddoch  <alriddoch@zepler.org>

	* client/Makefile.am, server/Makefile.am, tools/Makefile.am:
	  Update static libs to Atlas-C++ 0.6.

	* RELEASE-check: Add a note about autopackage building.

2005-09-29  Al Riddoch  <alriddoch@zepler.org>

	* Update NEWS.

	* Release 0.5.0

2005-09-28  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.cpp, modules/Location.h:
	  Add const accessors for location data, in preparation for
	  adding cached collision data which must be updated every
	  time data is modified.

	* physics/Collision.cpp, rulesets/Character.cpp, rulesets/Entity.cpp,
	  rulesets/Entity.h, rulesets/MemMap.cpp, rulesets/Movement.cpp,
	  rulesets/Pedestrian.cpp, rulesets/Plant.cpp,
	  rulesets/Py_Location.cpp, rulesets/Thing.cpp, rulesets/World.cpp,
	  server/Account.cpp, server/EntityFactory.cpp, server/Persistor.cpp,
	  server/Persistor_impl.h, server/Restorer_impl.h,
	  server/WorldRouter.cpp, tests/Locationtest.cpp:
	  Use the const accessors whenver reading data from Location.

2005-09-28  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.cpp: Add an assert check to ensure collision
	  code is working ok.

	* physics/Collision.cpp: Fix a bug where emergence from a container
	  was incorrectly predicted because the final emerging corner was
	  mispredicted.

2005-09-27  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Movement.cpp: Re-word a comment to make it clearer.

2005-09-27  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.cpp, common/inheritance.h: Re-introduce
	  opEnumerate function as its useful for scripts, and tests.

	* tests/inheritancetest.cpp: Add necessary includes to pick up
	  operation class numbers.

	* tests/Areatest.cpp, tests/BaseEntitytest.cpp,
	  tests/Charactertest.cpp, tests/Creatortest.cpp,
	  tests/EntityExerciser.h, tests/Entitytest.cpp,
	  tests/Foodtest.cpp, tests/Linetest.cpp, tests/OOGThingtest.cpp,
	  tests/Planttest.cpp, tests/Stackabletest.cpp,
	  tests/Structuretest.cpp, tests/Thingtest.cpp, tests/Worldtest.cpp:
	  Remove all uses of the removed op subscription mechanism.

2005-09-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: Report an error if a movement tick op has
	  no serialno. Remove some obsolete comments.

2005-09-26  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: When processing Move op from mind,
	  suppress Tick op used to update if character is not moving.

2005-09-26  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/BaseEntity.h, common/inheritance.cpp,
	  common/inheritance.h, rulesets/BaseMind.cpp, rulesets/BaseMind.h,
	  rulesets/Character.cpp, rulesets/Character.h, rulesets/Entity.cpp,
	  rulesets/Food.cpp, rulesets/Plant.cpp, rulesets/Stackable.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/Account.cpp,
	  server/Admin.cpp, server/Connection.cpp, server/server.cpp:
	  Remove the subscription mechanism as it is no longer necessary
	  now that operations have class numbers.

2005-09-26  Al Riddoch  <alriddoch@zepler.org>

	* common/BaseEntity.cpp, common/custom.cpp, common/op_switch.h,
	  common/types.h, rulesets/BaseMind.cpp, rulesets/Character.cpp,
	  rulesets/Creator.cpp, rulesets/Food.cpp, rulesets/Plant.cpp,
	  rulesets/Thing.cpp, rulesets/World.cpp, server/Admin.cpp,
	  server/Admin.cpp: Replace OpNo enumeration with defines for the
	  integer class numbers.  Expand the switch statements used for op
	  dispatch because runtime extended op definitions don't have a const
	  number. 

	* server/EntityFactory.cpp: Re-order installation of ops to ensure
	  the number registered in enumeration maps is the one returned by
	  the Atlas factories.

	* rulesets/Character.cpp: Improve debug output for op handling when
	  debug is enabled for this file.

2005-09-24  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.cpp: Replace a #warning with a FIXME.

2005-09-23  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp: Remove debug output.

2005-09-23  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Implement reading pvp settings
	  from config file.

	* data/cyphesis.vconf: Disable pvp in the default config.

2005-09-23  Al Riddoch  <alriddoch@zepler.org>

	* common/globals.cpp, common/globals.h: Add config flags for
	  pvp settings.

2005-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Container.h, rulesets/Container.cpp,
	  rulesets/EntityProperties.cpp: Implement add(Entity) for common
	  poperties, and containers.

	* rulesets/Entity.cpp: Use add(Entity) instead of get() on properties,
	  ensuring that unset properties aren't copied. Fixes problem with
	  bboxes appearing on all entities.

2005-09-22  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp: If reading quaternion from Atlas results
	  in an invalid quaternion, report an ERROR. Abort processing
	  the move op if any exception is thrown when reading values
	  from Atlas.

2005-09-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Character.h:
	  Add handler for chop ops, which is a quick implementation of
	  Axe murder to test the health bar in clients.

2005-09-20  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp: Make sure cassert is included before assert
	  macro is used.

	* common/Makefile.am: Add missing header.

	* data/Makefile.am: Install copies of the config files in
	  the documentation directory for reference.

2005-09-20  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Character.cpp, rulesets/Character.h: Add Attack operation
	  handler to set up combat when sent by attacker.

	* rulesets/Combat.cpp: Fix bootstrap tick op, and return a future tick
	  op from the tick op handler.

2005-09-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.h, rulesets/Entity.cpp: Add default script
	  only handler for Attack ops.

	* rulesets/Character.cpp: When Attack op comes from mind,
	  move it on to the target entity.

2005-09-19  Al Riddoch  <alriddoch@zepler.org>

	* server/EntityFactory.cpp: Report if entities have velocity on
	  creation.

2005-09-19  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Task.h, rulesets/Task.cpp: Add reference counting to the
	  task interface.

	* rulesets/Character.cpp, rulesets/Combat.cpp, rulesets/Combat.h:
	  Add experimental code to handle initiating combat.

2005-09-18  Al Riddoch  <alriddoch@zepler.org>

	* common/Attack.h, common/operations.cpp, common/types.h:
	  Add a new Attack operation type.

	* common/op_switch.h, common/BaseEntity.h, common/BaseEntity.cpp,
	  rulesets/BaseMind.cpp, rulesets/BaseMind.h,
	  rulesets/Character.cpp, rulesets/Character.h: Add handlers to base
	  classes for Attack op.

2005-09-18  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/PythonMindScript.cpp, rulesets/PythonMindScript.h,
	  rulesets/PythonThingScript.cpp, rulesets/PythonThingScript.h,
	  rulesets/PythonScript.h, rulesets/Script.cpp, rulesets/Script.h:
	  Clean up script API.

	* rulesets/BaseMind.cpp, rulesets/Character.cpp, rulesets/Entity.cpp,
	  rulesets/Food.cpp, rulesets/Plant.cpp, rulesets/Stackable.cpp,
	  rulesets/Thing.cpp: Modify script calls to new API.

	* rulesets/BaseMind.cpp, rulesets/BaseMind.h: All sub_op calls now
	  take const ref for sub_op argument.

2005-09-17  Al Riddoch  <alriddoch@zepler.org>

	* server/Makefile.am, tools/Makefile.am: Add gcrypt static libs.

2005-09-16  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Don't link libdl and libutil explicitly when linking
	  python dynamically.

	* common/const.cpp: Remove some obsolete comments.

2005-09-16  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Remove some operation types only used in
	  scrypts.

	* data/basic.xml, data/mason.xml: Add the operation definitions
	  into the rule files.

2005-09-15  Al Riddoch  <alriddoch@zepler.org>

	* common/system.cpp, common/system.h: Add new functions for handling
	  encrypted password hashes with a salt, based on gcrypt rather
	  than openssl. Include legacy support for hashes without a salt.

	* common/const.cpp: Add a salt to the default admin password.

	* tests/systemtest.cpp: Modify the password tests to use the new
	  functions.

	* server/Connection.cpp, server/Connection.h,
	  server/TrustedConnection.cpp, server/TrustedConnection.h:
	  Update the login code to use the new password functions.

2005-09-14  Al Riddoch  <alriddoch@zepler.org>

	* client/ClientConnection.cpp: Improve error reporting when
	  unexpected object arrives from server.

	* rulesets/Character.cpp: Invert test so that tool use op arguments
	  are now set correctly.

	* rulesets/Entity.cpp: Use proper entities to handle responses to
	  Create and Look ops.

	* server/Connection.cpp, server/EntityFactory.cpp: Improve error
	  reporting using String::compose.

	* server/EntityFactory.cpp: Invert test so that all custom ops
	  now don't fail to get installed. Ensure that custom ops that
	  need to wait for their parent a properly inserted into the
	  waiting queue.

2005-09-13  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.cpp: Fix a bug where POS was being corrupted
	  whenever velocity was supposed to be set.

	* rulesets/basic/mind/goals/humanoid/mason.py: Convert ID to entity
	  before checking location.

	* rulesets/mason/mind/PigMind.py: Convert ID to entity before
	  passing location to another function.

2005-09-13  Al Riddoch  <alriddoch@zepler.org>

	* common/Database.cpp: Report error when database connection fails.

2005-09-12  Al Riddoch  <alriddoch@zepler.org>

	* common/Makefile.am: Fix some missing headers.

2005-09-12  Al Riddoch  <alriddoch@zepler.org>

	* configure.ac: Increment version to development 0.5.x series.

	* aiclient/ClientAccount.cpp, client/BaseClient.cpp,
	  client/ClientConnection.cpp, common/BaseEntity.cpp,
	  common/Database.cpp, common/custom.cpp, common/inheritance.cpp,
	  common/operations.h, rulesets/BaseMind.cpp, rulesets/Creator.cpp,
	  rulesets/Food.cpp, rulesets/MemMap.cpp, rulesets/Pedestrian.cpp,
	  rulesets/Py_Operation.cpp, rulesets/Py_RootEntity.cpp,
	  rulesets/Python_API.cpp, rulesets/Stackable.cpp, rulesets/Thing.cpp,
	  rulesets/World.cpp, server/CommClient.cpp, server/Connection.cpp,
	  server/WorldRouter.cpp, tests/inheritancetest.cpp,
	  tools/AdminClient.h, tools/cyaddrules.cpp,
	  tools/cycmd.cpp, tools/cydumprules.cpp,
	  tools/cyloadrules.cpp, tools/cypasswd.cpp:
	  Remove unnecessary using directives.

	* common/utility.cpp, common/utility.h,
	  rulesets/BaseMind.cpp, rulesets/Py_Operation.cpp,
	  server/CommClient.cpp, tools/AdminClient.h, tools/cycmd.cpp:
	  Remove obsolete utility function from the build.

	* common/operations.h: Remove unused obsolete header from the
	  build.

2005-09-12  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.h, tests/inheritancetest.cpp: Remove the
	  newOperation declarations from the header, and removes their
	  tests.

2005-09-12  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance_impl.h, common/inheritance.h,
	  common/inheritance.cpp, common/custom.cpp: Get rid of the op
	  factory feature of inheritance, as its not required.

	* server/EntityFactory.cpp: Register op types defined in the
	  data into the Atlas factory rather than the old inheritance
	  factory mechanism.

2005-09-12  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp, rulesets/Character.cpp: Ensure all custom op
	  types are registered with the Atlas factories, and switch
	  to using it for tool operations.

2005-09-12  Al Riddoch  <alriddoch@zepler.org>

	* common/Add.h, common/Burn.h, common/Chop.h, common/Connect.h,
	  common/Cut.h, common/Delve.h, common/Dig.h, common/Eat.h,
	  common/Monitor.h, common/Mow.h, common/Nourish.h, common/Setup.h,
	  common/Tick.h, common/Unseen.h, common/Update.h,
	* common/operations.cpp, scripts/gen_op.py:
	  Try a new much simpler way of handling custom ops.

	* common/CustomOp.cpp, common/CustomOp.h, common/CustomOp_impl.h:
	  Remove obsolete old template for custom ops.

	* common/custom.cpp: Install factories in a different way for all
	  the custom op types.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* common/const.cpp, common/const.h: Git rid of bizare scheme
	  where each constant appears twice, debug and non-debug versions.

	* rulesets/Pedestrian.cpp, rulesets/Thing.cpp,
	  server/WorldRouter.cpp: Fix problem where an essential call
	  was inside an assert, so did not happen when built in non-debug
	  mode.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/humanoid/mason.py: Fix self -> me
	  when checking for mind ID.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Operation.h, rulesets/Py_Operation.cpp: Remove reference
	  ownership flag, and from and to pointers from the python operation
	  structure.

	* rulesets/Py_Map.cpp, rulesets/Py_Oplist.cpp,
	  rulesets/PythonMindScript.cpp, rulesets/PythonThingScript.cpp,
	  rulesets/Python_API.cpp: Remove all usage of own, from and to.

	* rulesets/basic/mind/NPCMind.py,
	  rulesets/basic/mind/goals/common/misc_goal.py,
	  rulesets/basic/mind/goals/humanoid/mason.py,
	  rulesets/basic/mind/goals/humanoid/transaction.py,
	  rulesets/mason/world/objects/clothing/Garment.py,
	  rulesets/mason/world/objects/plants/seeds/Acorn.py,
	  rulesets/mason/world/objects/plants/seeds/Apple.py,
	  rulesets/mason/world/objects/plants/seeds/Fircone.py,
	  rulesets/mason/world/objects/tools/Bucksaw.py,
	  rulesets/mason/world/objects/tools/Cleaver.py,
	  rulesets/mason/world/objects/tools/Trowel.py: Modify all scripts
	  so they expect from and to of ops to be an ID string rather than
	  an entity.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Python_API.cpp: Modify Python API so Entity() now creates
	  a RootEntity not a Message Element.

	* client/Py_CreatorClient.cpp, client/CreatorClient.h,
	  client/CreatorClient.cpp: Modify CreatorClient and bindings to
	  take a RootEntity rather than a Message Element.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Object.h, rulesets/Py_Object.cpp: Remove nasty code
	  used to handle complex attributes to Message Elements. Now should
	  either be converted or rejected.

	* rulesets/Python_API.cpp: Remove code that merged complex python
	  attributes to entity arguments.

	* rulesets/Py_Mind.cpp: Add note that as_entity() method should
	  be removed in the long term.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Object.cpp, rulesets/Py_Object.h: Ensure that
	  Python to Atlas conversions are aborted if they fail at any
	  point.

	* rulesets/Py_RootEntity.cpp: Ensure all static functions still have
	  unique names. Support setting and retrieving soft attributes.
	  For attribute values which are non-convertible python objects,
	  store a pointer to the original Python object.

	* rulesets/Python_API.cpp: Adapt setting of operation arguments
	  modified Python to Atlas conversion functions.

	* rulesets/mason/define_world.py: Add a very basic test for
	  experimenting with interlinguish.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.h, modules/Location.cpp: Remove handling of
	  LOC attribute from readFromEntity() as every use of this function
	  has differen requirements.

	* rulesets/MemMap.cpp: Implement setting LOC so that the minimum
	  of lookups in the world dictionary are required.

	* server/EntityFactory.cpp: Implement setting LOC in a much simpler
	  way, as its always uninitialised at this point.

	* client/BaseClient.cpp: Add a note that LOC is currently unhandled,
	  as there is nothing sane to do with it.

2005-09-11  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Operation.cpp: Return entity arguments as RootEntity
	  rather than MessageElement.

	* rulesets/Py_RootEntity.cpp: get_name() returns "obj" as it should
	  rather than "op". Add warnings if unknown attributes are requested
	  or set.

	* rulesets/Python_API.cpp: Accept RootEntity python wrapped
	  objects as arguments to operations. 

2005-09-10  Al Riddoch  <alriddoch@zepler.org>

	* modules/Location.cpp, modules/Location.h: Add a new method to
	  read location data from an Atlas Entity.

	* rulesets/MemMap.cpp, server/EntityFactory.cpp, client/BaseClient.cpp:
	  Switch to using new function rather than Entity::getLocation.

	* rulesets/Entity.h, rulesets/Entity_getLocation.h: Remove obsolete
	  getLocation method.

2005-09-10  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Thing.cpp, rulesets/Character.cpp: Use getVelocity()
	  on RootEntity, rather than accessing it as a soft attribute.

2005-09-10  Al Riddoch  <alriddoch@zepler.org>

	* physics/Vector3D.h: When constructing a vector or point from
	  a std::vector, set its valid flag.

2005-09-09  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Thing.cpp: Use copy correctly
	  when creating copies of operations.

2005-09-09  Al Riddoch  <alriddoch@zepler.org>

	* common/CustomOp_impl.h: Correctly set the refcount on copied custom
	  ops.

2005-09-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp: Update copyright date.

	* rulesets/BaseMind.cpp, rulesets/Entity_getLocation.h,
	  rulesets/Entity.h, rulesets/MemMap.cpp, rulesets/MemMap.h,
	  rulesets/Py_Map.cpp, server/EntityFactory.cpp,
	  server/EntityFactory.h, server/WorldRouter.cpp,
	  client/BaseClient.cpp, client/CreatorClient.cpp:
	  Change various methods to pass entity information
	  around as RootEntity rather than MapType.

2005-09-08  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/MemMap.cpp: Remove unnecessary copy of name to entity,
	  as it's handled later in merge().

2005-09-07  Al Riddoch  <alriddoch@zepler.org>

	* common/compose.hpp: Add Ole Laursen's fine string composition
	  library for improved messages.

	* rulesets/Character.cpp: Fix inverted check for string pos,
	  and add a clearer error message when it fails, using
	  compose.

2005-09-07  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_Operation.cpp: Decref operations correctly when the
	  Python object wrapping them is deleted.

	* rulesets/mason/define_world.py: Add a simple single entity
	  test function.

	* server/WorldRouter.cpp: Make sure orientation is not used
	  un-initialised when correcting height.

2005-09-06  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Py_RootEntity.cpp, rulesets/Py_RootEntity.h:
	  New python wrappers for Atlas-C++ entity classes.

2005-08-31  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.cpp: Avoid hasAttr(),getAttr() use by using
	  copyAttr().

2005-08-31  Al Riddoch  <alriddoch@zepler.org>

	* common/inheritance.h: Set the correct objtype on the Root meta class.

	* rulesets/Character.cpp, rulesets/Food.cpp, rulesets/Plant.cpp,
	  rulesets/Stackable.cpp, rulesets/Thing.cpp, server/Account.cpp,
	  server/Admin.cpp, server/Connection.cpp, tools/AdminClient.cpp,
	  tools/cycmd.cpp: Switch to renamed copyAttr() method from
	  Atlas-C++.

2005-08-30  Al Riddoch  <alriddoch@zepler.org>

	* common/AtlasFileLoader.cpp, common/Database.cpp,
	  common/FormattedXMLWriter.cpp, common/Property.cpp,
	  common/accountbase.cpp, rulesets/Character.cpp,
	  rulesets/Entity_getLocation.h, rulesets/MemMap.cpp,
	  rulesets/Pedestrian.cpp, rulesets/Plant.cpp,
	  rulesets/Py_Object.cpp, rulesets/Thing.cpp,
	  server/Admin.cpp, server/Connection.cpp, server/EntityFactory.cpp,
	  server/WorldRouter.cpp, tools/AdminClient.cpp, tools/cycmd.cpp,
	  tools/cyconvertrules.cpp: After an Element has been checked
	  with isFoo(), it is more efficient to get its value using Foo()
	  rather than asFoo() which repeats the check.

2005-08-29  Al Riddoch  <alriddoch@zepler.org>

	* server/Account.cpp, rulesets/Thing.cpp, rulesets/Character.cpp:
	  Replace asserts with proper checks that arguments are of the
	  expected type.

	* common/custom.cpp: Put ignite op installation back in.

2005-08-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/basic/mind/goals/common/misc_goal.py: Don't return
	  non-existant ops.

	* rulesets/Thing.cpp: Fix some places where root_operations
	  were being returned.

	* common/inheritance.cpp: Add "affect" operation base class,
	  and fix parents on use and wield.

	* common/custom.cpp: Install atlas factories for custom op
	  types.

2005-08-29  Al Riddoch  <alriddoch@zepler.org>

	* rulesets/Entity.cpp, rulesets/Thing.cpp: Use static LOC and POS
	  members in RootEntity.

	* rulesets/Entity_getLocation.h: Add some slightly more thorough
	  checking for location data.

2005-08-28  Al Riddoch  <alriddoch@zepler.org>

	* common/custom.cpp: Install an atlas factory for custom op as a test.

	* rulesets/Py_Operation.cpp: Improve error reporting.

